### Watch all release presentations and videos at [ClickHouse Theater](https://presentations.clickhouse.com/) and [YouTube Playlist](https://www.youtube.com/playlist?list=PL0Z2YDlm0b3jAlSy1JxyP8zluvXaN3nxU).

### Table of Contents
**[ClickHouse release v26.6, 2026-06-25](#266)**
**[ClickHouse release v26.5, 2026-05-21](#265)**
**[ClickHouse release v26.4, 2026-04-30](#264)**
**[ClickHouse release v26.3 LTS, 2026-03-26](#263)**
**[ClickHouse release v26.2, 2026-02-26](#262)**
**[ClickHouse release v26.1, 2026-01-29](#261)**
**[Changelog for 2025](https://clickhouse.com/docs/whats-new/changelog/2025/)**
**[Changelog for 2024](https://clickhouse.com/docs/whats-new/changelog/2024/)**
**[Changelog for 2023](https://clickhouse.com/docs/whats-new/changelog/2023/)**
**[Changelog for 2022](https://clickhouse.com/docs/whats-new/changelog/2022/)**
**[Changelog for 2021](https://clickhouse.com/docs/whats-new/changelog/2021/)**
**[Changelog for 2020](https://clickhouse.com/docs/whats-new/changelog/2020/)**
**[Changelog for 2019](https://clickhouse.com/docs/whats-new/changelog/2019/)**
**[Changelog for 2018](https://clickhouse.com/docs/whats-new/changelog/2018/)**
**[Changelog for 2017](https://clickhouse.com/docs/whats-new/changelog/2017/)**

# 2026 Changelog

###  ClickHouse release 26.6, 2026-06-25. [Presentation](https://presentations.clickhouse.com/2026-release-26.6/), [Video](https://www.youtube.com/watch?v=-NmqMH9y4EY)

#### Backward Incompatible Change
* The change removes `allow_experimental_query_deduplication` feature. The feature was experimental for a long time, has no tests and not going to be supported (initial tests were unstable and has been removed in [#49579](https://github.com/ClickHouse/ClickHouse/pull/49579)). [#99398](https://github.com/ClickHouse/ClickHouse/pull/99398) ([Igor Nikonov](https://github.com/devcrafter)).
* The XRay-based `SYSTEM INSTRUMENT` feature now uses `arguments` instead of `parameters`: the `system.instrumentation.parameters` column was renamed to `arguments`, and the `SYSTEM INSTRUMENT ADD ... HANDLER PARAMETERS ...` syntax was renamed to `SYSTEM INSTRUMENT ADD ... HANDLER ARGUMENTS ...`. Queries or automation that use the old column or syntax must be updated to use the new names; the old names are no longer supported. [#103854](https://github.com/ClickHouse/ClickHouse/pull/103854) ([Pablo Marcos](https://github.com/pamarcos)).
* The setting `show_data_lake_catalogs_in_system_tables` has been renamed to `show_remote_databases_in_system_tables` and broadened: when its value is 0 (the default), `MySQL` and `PostgreSQL` databases are also hidden from `system.tables`, `system.columns`, and `system.completions`, in addition to data lake catalogs. The old setting name is kept as an alias. [#104416](https://github.com/ClickHouse/ClickHouse/pull/104416) ([Pablo Marcos](https://github.com/pamarcos)).
* The default x86 build now targets x86-64-v3 (AVX2) instead of x86-64-v2 (SSE4.2). This requires a CPU with AVX2 support (Intel Haswell or later, AMD Excavator or later). If your CPU does not support AVX2, use the `amd64compat` build which targets plain x86-64. [#105019](https://github.com/ClickHouse/ClickHouse/pull/105019) ([Raúl Marín](https://github.com/Algunenano)).
* Reject nested `Dynamic`/`Variant` in `min`/`max` aggregates and `minmax` indexes. Previously only top-level `Dynamic`/`Variant` were checked. Closes [#104747](https://github.com/ClickHouse/ClickHouse/issues/104747). [#105468](https://github.com/ClickHouse/ClickHouse/pull/105468) ([Pavel Kruglov](https://github.com/Avogar)).
* `icebergHash` and `icebergBucket` now reject `Int128`, `UInt128`, `Int256`, `UInt256`, and `Decimal256` arguments with an explicit error. Previously they silently truncated wider values and produced colliding hashes. The Iceberg spec only defines hashing for 32/64-bit integers and decimals with precision up to 38; cast to `Int64` or `Decimal128` to keep the previous behaviour for values that fit. [#105866](https://github.com/ClickHouse/ClickHouse/pull/105866) ([Raúl Marín](https://github.com/Algunenano)).
* Added granular control over query echoing in the CLI. The `--echo` option now accepts an optional boolean value and works in both interactive and batch mode. New options `--echo-formatted` and `--echo-query-id` control whether echoed queries are formatted and whether the `query_id` is printed, respectively. The `--hilite`/`--highlight` option now also controls highlighting of echoed queries. As a side effect, `--echo` is now a boolean-value option, so a positional query directly after a bare `--echo` is treated as its value; use `--echo --query "..."` or `--echo=false` instead. [#106191](https://github.com/ClickHouse/ClickHouse/pull/106191) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Removed the experimental KQL (Kusto) functions `array_sort_asc` and `array_sort_desc`, and their SQL backends `kql_array_sort_asc` and `kql_array_sort_desc`. These functions were experimental, implemented with low quality, and the source of correctness and parser bugs. Queries using these names now return `UNKNOWN_FUNCTION`. [#108101](https://github.com/ClickHouse/ClickHouse/pull/108101) ([Groene AI](https://github.com/groeneai)).
* `ALTER TABLE ... REPLACE PARTITION ... FROM ...` no longer silently drops the destination partition's data when the source table has no parts in the requested partition. Previously such a request removed the destination partition and wrote nothing in its place — a data-loss footgun. It is now rejected with `BAD_ARGUMENTS` by default. To restore the previous silent-clear behavior, set the new setting `allow_replace_partition_from_empty_source = 1`, or set `compatibility` to `26.5` or lower; to explicitly drop destination data, use `ALTER TABLE ... DROP PARTITION`. [#104939](https://github.com/ClickHouse/ClickHouse/pull/104939) ([Groene AI](https://github.com/groeneai)).
* The default of the server setting `insert_deduplication_version` changes from `compatible_double_hashes` to `new_unified_hash`. Insert deduplication now works on the whole inserted block (per insert) rather than per part/partition: a retry of the same insert is still deduplicated, but two different inserts that produce an identical part are no longer cross-deduplicated, and reordered inserts of the same rows are no longer deduplicated. Set `insert_deduplication_version = compatible_double_hashes` to restore the previous behavior. Instances upgrading directly from a release that defaulted to `old_separate_hashes` should first run with `compatible_double_hashes` until the longest relevant deduplication window has elapsed before relying on `new_unified_hash`. [#107886](https://github.com/ClickHouse/ClickHouse/pull/107886) ([Sema Checherinda](https://github.com/CheSema)).

#### New Feature
* Added support for continuous queries over `MergeTree` tables, implemented via a series of snapshot reads. This is a first step toward general support for streaming queries. [#105114](https://github.com/ClickHouse/ClickHouse/pull/105114) ([Mikhail Artemenko](https://github.com/Michicosun)).
* Added hypothetical (what-if) skip indexes. Use `CREATE HYPOTHETICAL INDEX ... ON t (expr) TYPE ...` to define a session-scoped virtual skip index, then `EXPLAIN WHATIF SELECT ...` to estimate its skip ratio and cost without materializing it. Defined indexes are visible in the new `system.hypothetical_indexes` table. [#104608](https://github.com/ClickHouse/ClickHouse/pull/104608) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* Add an embedded `/schema` web UI to `clickhouse-server` that visualizes the dependency graph between tables, materialized views, refreshable materialized views, dictionaries, distributed tables and views. [#105276](https://github.com/ClickHouse/ClickHouse/pull/105276) ([Nikita Mikhaylov](https://github.com/nikitamikhaylov)).
* Added the `PNG` output format support, allowing query output results to be directly rendered as PNG images. [#74691](https://github.com/ClickHouse/ClickHouse/pull/74691) ([Maksim Dergousov](https://github.com/m7kss1)).
* Added detection of the AI coding agent (Claude Code, Cursor, Codex, Gemini CLI, Goose, etc.) that invoked `clickhouse-client` or `clickhouse-local`, based on environment variables. The detected agent is reported in the new `client_agent` column of `system.query_log`, `system.query_thread_log` and `system.processes`. [#106619](https://github.com/ClickHouse/ClickHouse/pull/106619) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Added a new system table `system.documentation` that collects the embedded reference documentation of the uniform components of the system (functions, table engines, data types, settings, formats, and others) into a single table, with the documentation rendered as Markdown. [#107463](https://github.com/ClickHouse/ClickHouse/pull/107463) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Add the `GeoJSON` input format for reading [GeoJSON](https://geojson.org/) `FeatureCollection` documents, producing one row per feature with `id` (`String`), `geometry` (`Geometry`), and `properties` (`Nullable(JSON)`) columns. `Point`, `LineString`, `MultiLineString`, `Polygon`, and `MultiPolygon` geometries are read into ClickHouse's native `Geometry` type. `GeometryCollection` and `MultiPoint`, which the `Geometry` type cannot represent, raise an exception by default, or can be stored as `NULL` via the `input_format_geojson_unsupported_geometry_handling` setting. Contributes to [#91533](https://github.com/ClickHouse/ClickHouse/issues/91533). [#98124](https://github.com/ClickHouse/ClickHouse/pull/98124) ([Mark Needham](https://github.com/mneedham)).
* Added functions for serving Mapbox Vector Tiles directly from SQL: `MVTEncodeGeom` projects a geometry into the pixel space of a slippy-map tile and clips it, `MVTEncode` aggregates the projected geometries of a group into the binary bytes of a single-layer tile, and `MVTBoundingBox` / `MVTBoundingBoxMercator` return the bounding box of a tile for restricting rows to it. Point, line and polygon geometry is supported. Also available under the PostGIS aliases `ST_AsMVTGeom` and `ST_AsMVT`. [#106107](https://github.com/ClickHouse/ClickHouse/pull/106107) ([Saarthak Gupta](https://github.com/saarthak2002)).
* `clickhouse-local` now supports `SYSTEM START LISTEN` and `SYSTEM STOP LISTEN` queries, allowing it to be transformed into a server accepting TCP and HTTP connections. [#101143](https://github.com/ClickHouse/ClickHouse/pull/101143) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Added an interactive `help` command to `clickhouse-client` and `clickhouse-local`. Typing `help <name>` (also `/help`, `man`, `/man`) shows the documentation of a function, table engine, data type, format, setting, or other component, rendered from Markdown in the terminal with syntax-highlighted SQL. When the word is ambiguous all matches are shown, and when it is not found, similar names are suggested. [#108042](https://github.com/ClickHouse/ClickHouse/pull/108042) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Support writing into Azure Data Lake Storage Gen2. [#105406](https://github.com/ClickHouse/ClickHouse/pull/105406) ([Konstantin Vedernikov](https://github.com/scanhex12)).
* Adding `RowBinaryWithNamesAndTypesAndDefaults` format to get better support for schema evolution. [#105736](https://github.com/ClickHouse/ClickHouse/pull/105736) ([Mark Zitnik](https://github.com/mzitnik)).
* Implement `ADD ENUM VALUES` in `ALTER TABLE` queries to simplify appending new values to an existing `Enum` type without the need to specify all current `Enum` values again. [#93830](https://github.com/ClickHouse/ClickHouse/pull/93830) ([Ilya Golshtein](https://github.com/ilejn)).
* Refreshable materialized view now supports `REFRESH DEPENDS ON` to trigger refreshes on another RMV's refreshes instead of time-based schedule. (`REFRESH EVERY ... DEPENDS ON` already existed, but couldn't be used reliably for this use case.) See `CREATE MATERIALIZED VIEW` documentation. [#104440](https://github.com/ClickHouse/ClickHouse/pull/104440) ([Michael Kolupaev](https://github.com/al13n321)).
* Add support for selecting columns by name pattern with `* LIKE '<pattern>'` and `* ILIKE '<pattern>'`, including qualified forms such as `table.* LIKE '<pattern>'` and `table.* ILIKE '<pattern>'`. `LIKE` matches column names case-sensitively, `ILIKE` case-insensitively. [#104569](https://github.com/ClickHouse/ClickHouse/pull/104569) ([Yue Ni](https://github.com/niyue)).
* Added `ESCAPE` syntax that defines a custom escape character in a `LIKE` pattern, allowing you to treat `%` and `_` as literal characters instead of wildcards. [#99774](https://github.com/ClickHouse/ClickHouse/pull/99774) ([Ilya Yatsishin](https://github.com/qoega)).
* Add `materialize_projections_on_insert` and `materialize_projections_on_merge` `MergeTree` table settings. When `materialize_projections_on_insert = 0`, `INSERT`s skip building projection parts, which improves insert throughput for tables with many projections. When `materialize_projections_on_merge = 1`, a merge rebuilds a projection that is missing from all of its source parts, so projections can be built during merges instead of on insert. Merges still combine only parts that share the same set of projections. [#100993](https://github.com/ClickHouse/ClickHouse/pull/100993) ([Christoph Wurm](https://github.com/cwurm)).
* Add a new immutable `MergeTree` setting `allow_tuple_element_aggregation`, disabled by default. When enabled, `SummingMergeTree`, `AggregatingMergeTree` and `CoalescingMergeTree` recursively flatten `Tuple` columns and aggregate each leaf element independently during merges, exactly as if it were a top-level column — `SummingMergeTree` sums it, `AggregatingMergeTree` merges its aggregate-function state, and `CoalescingMergeTree` keeps its last non-NULL value. The setting must be specified at table creation time and is silently ignored by engines that do not support it. [#98039](https://github.com/ClickHouse/ClickHouse/pull/98039) ([johnjing](https://github.com/JingYanchao)).
* New functions `quantizeBFloat16ToInt8` and `dequantizeInt8ToBFloat16`: a scalar codec that compresses embedding components to 8-bit using a 256-level Gaussian Lloyd-Max quantizer, from which Int4/Int2/binary codes can be extracted by bit-truncation. [#108102](https://github.com/ClickHouse/ClickHouse/pull/108102) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Add functions `arrayTopK` and `arrayBottomK`: - `arrayTopK(k, array)` returns the K largest elements in descending order - `arrayBottomK(k, array)` returns the K smallest elements in ascending order. [#104563](https://github.com/ClickHouse/ClickHouse/pull/104563) ([Vitaly Baranov](https://github.com/vitlibar)).
* Added a new system table `system.iceberg_files` exposing per-file metadata for `Iceberg` tables, with one row per data or delete file in each table's current snapshot. This closes [#98777](https://github.com/ClickHouse/ClickHouse/issues/98777). [#104415](https://github.com/ClickHouse/ClickHouse/pull/104415) ([Asya Shneerson](https://github.com/asya-ch)).
* Added `system.constraints` table that provides information about all `CHECK` and `ASSUME` constraints across all tables, including constraint name, type, and expression. [#105337](https://github.com/ClickHouse/ClickHouse/pull/105337) ([Pedro Ferreira](https://github.com/PedroTadim)).
* Added a new `system.dictionary_layouts` table that lists the available dictionary layouts together with embedded documentation (`description`, `syntax`, `examples`, `introduced_in`, `related`). [#106182](https://github.com/ClickHouse/ClickHouse/pull/106182) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Added a new `system.dictionary_sources` table that lists the available dictionary sources together with embedded documentation (`description`, `syntax`, `examples`, `introduced_in`, `related`). [#106184](https://github.com/ClickHouse/ClickHouse/pull/106184) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Added a new `system.data_skipping_index_types` table that lists the available data skipping index types together with embedded documentation (`description`, `syntax`, `examples`, `introduced_in`, `related`). [#106186](https://github.com/ClickHouse/ClickHouse/pull/106186) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Added a new `system.disk_types` table that lists the available disk types together with embedded documentation (`description`, `syntax`, `examples`, `introduced_in`, `related`). [#106187](https://github.com/ClickHouse/ClickHouse/pull/106187) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Implemented `SYSTEM RESTART DISK <name>`: it now reloads a disk's in-memory metadata and re-scans the data parts of readonly-replica tables located on it. This lets a readonly replica of a table on shared `plain_rewritable` storage observe data written by another server on demand, without waiting for `refresh_parts_interval` or restarting the server. [#106645](https://github.com/ClickHouse/ClickHouse/pull/106645) ([Jordi Villar](https://github.com/jrdi)).
* PostgreSQL-style `expr OP SOME(array)` / `expr OP ALL(array)` (non-subquery right-hand side) is now supported and rewritten to `has` / `NOT has` for `=`/`<>`, or to `arrayExists` / `arrayAll` lambdas for other comparison operators. `ANY` is not accepted for the array form because `any` is also an aggregate function; use `SOME` instead. The subquery form of `ANY`/`SOME`/`ALL` continues to be lowered to `IN` / `NOT IN`. [#105129](https://github.com/ClickHouse/ClickHouse/pull/105129) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Added two new `load_balancing` strategies, `hostname_longest_common_prefix` and `hostname_longest_common_suffix`, which prefer the replica whose hostname shares the longest common prefix (respectively, suffix) with the initiator's hostname. They are useful when the data center is encoded as a prefix or suffix of hostnames whose numeric segments have variable length, where the existing `nearest_hostname` and `hostname_levenshtein_distance` strategies pick the wrong replica. [#107360](https://github.com/ClickHouse/ClickHouse/pull/107360) ([Denny [DBA at Innervate]](https://github.com/den-crane)).
* Added TLS client certificate information (subjects, serial number, issuer, and validity period) to the `system.session_log` table to improve observability of certificate-based authentication. [#107679](https://github.com/ClickHouse/ClickHouse/pull/107679) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Add an optional `external_id` credential for `S3` role-based access. [#106941](https://github.com/ClickHouse/ClickHouse/pull/106941) ([Elian Gidoni](https://github.com/eliangidoni)).
* Added a new `S3Queue` setting `after_processing_move_preserve_path`. When enabled together with `after_processing='move'` and `after_processing_move_prefix`, processed objects are moved while preserving their full source path under the destination prefix instead of being flattened to just the file name. [#105354](https://github.com/ClickHouse/ClickHouse/pull/105354) ([Asya Shneerson](https://github.com/asya-ch)).
* Add `message_queue_disable_insertion` server setting to disable insertion from message queue engines (`Kafka`, `RabbitMQ`, `NATS`) into attached materialized views. Useful for read-only replica scenarios. [#104911](https://github.com/ClickHouse/ClickHouse/pull/104911) ([JIaQi Tang](https://github.com/JiaQiTang98)).
* Added `LOCALTIME` and `LOCALTIMESTAMP` (SQL-standard / PostgreSQL syntax). `LOCALTIMESTAMP` is an alias for `now()` (returns `DateTime`); `LOCALTIME` returns the current time of day as a `Time` value. [#106139](https://github.com/ClickHouse/ClickHouse/pull/106139) ([Thomas Cabral](https://github.com/thomas-cabral)).
* Added `date_part('unit', expr)` as syntactic sugar for `EXTRACT(unit FROM expr)`. Standard interval kinds and the PostgreSQL extras (`epoch`, `dow`, `doy`, `isodow`, `isoyear`, `century`, `decade`, `millennium`) are all supported. [#105127](https://github.com/ClickHouse/ClickHouse/pull/105127) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* PostgreSQL-compatible `EXTRACT(TIMEZONE_HOUR FROM dt)` and `EXTRACT(TIMEZONE_MINUTE FROM dt)` for the hour and minute parts of a timezone offset, and `EXTRACT(<unit> FROM INTERVAL n <unit>)` / `date_part('<unit>', INTERVAL n <unit>)` for extracting the value out of an interval. [#106227](https://github.com/ClickHouse/ClickHouse/pull/106227) ([Vinayak Joshi](https://github.com/vinayakj592)).
* Added `min_by` and `max_by` aggregate aliases for `argMin` and `argMax`. [#105712](https://github.com/ClickHouse/ClickHouse/pull/105712) ([Joey Yu](https://github.com/itsjoeoui)). These aliases are stupid, real engineers use the original ClickHouse names.
* Added `REGEXP_SUBSTR` as a case-insensitive alias of `regexpExtract` for Oracle/MySQL/Snowflake compatibility. [#105122](https://github.com/ClickHouse/ClickHouse/pull/105122) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Added `SESSION_USER` as a case-insensitive alias of `currentUser()` for PostgreSQL / SQL-standard compatibility. [#106081](https://github.com/ClickHouse/ClickHouse/pull/106081) ([Takumi Hara](https://github.com/takumihara)).
* Support a trailing `NULL` / `NOT NULL` modifier in `ALTER TABLE ... ADD/MODIFY COLUMN`, mirroring `CREATE TABLE`. [#106150](https://github.com/ClickHouse/ClickHouse/pull/106150) ([Takumi Hara](https://github.com/takumihara)).
* You can now use `h3PolygonToCellsWithContainment` function from h3 to use their new algorithm which supports center-based, fully-contained, and overlapping containment modes. [#104455](https://github.com/ClickHouse/ClickHouse/pull/104455) ([Youssef Kadry](https://github.com/yousefQadry)).
* Adds `IPV4_PREFIX_BITS and IPV6_PREFIX_BITS` flags when Keying done by `IP_ADDRESS` or `FORWARDED_IP_ADDRESS`. [#89270](https://github.com/ClickHouse/ClickHouse/pull/89270) ([Aditya Chopra](https://github.com/adityachopra29)).
* `formatReadableTimeDelta` now accepts an `INTERVAL` expression of type other than `Month` and `Year` as input. [#64315](https://github.com/ClickHouse/ClickHouse/pull/64315) ([Francisco J. Jurado Moreno](https://github.com/Beetelbrox)).
* User can now specify an optional precision argument to the `formatReadableSize`, `formatReadableDecimalSize` and `formatReadableQuantity` functions, controlling the number of digits after the decimal point. Default is 2, preserving the prior behavior. [#104648](https://github.com/ClickHouse/ClickHouse/pull/104648) ([Antonio Filipovic](https://github.com/antoniofilipovic)).
* Add `output_format_float_precision` setting to control the number of decimal digits in floating-point text output. [#99721](https://github.com/ClickHouse/ClickHouse/pull/99721) ([phulv94](https://github.com/phulv94)).
* Added a setting `output_format_always_write_decimal_point_in_float_and_decimal` to always print a decimal point for floating-point and `Decimal` numbers in text formats, even when the value is a whole number. For example, output `1.` instead of `1`. Disabled by default. [#62614](https://github.com/ClickHouse/ClickHouse/pull/62614) ([Ilya Yatsishin](https://github.com/qoega)).
* Add support for new HTTP handler configuration elements `<url_prefix>` and `<full_url_prefix>` (match all paths under a base path, useful e.g. for Prometheus handlers), as well as `<url_regexp>`, `<full_url_regexp>`, and `<headers_regexp>`. The old `<url>regex:...</url>` form is now obsolete. [#107492](https://github.com/ClickHouse/ClickHouse/pull/107492) ([Vitaly Baranov](https://github.com/vitlibar)).
* Support `basic` statistics, a compact per-column statistic that stores numeric min/max, average string length, and NULL counts where applicable. [#106048](https://github.com/ClickHouse/ClickHouse/pull/106048) ([Han Fei](https://github.com/hanfei1991)).
* Support TTL nodes in ClickHouse Keeper, opt-in via the `create_ttl` feature flag. [#100397](https://github.com/ClickHouse/ClickHouse/pull/100397) ([Konstantin Vedernikov](https://github.com/scanhex12)).
* Introduce a memory reservation feature for workloads. See the [workload scheduling](https://clickhouse.com/docs/operations/workload-scheduling) documentation. [#82414](https://github.com/ClickHouse/ClickHouse/pull/82414) ([Sergei Trifonov](https://github.com/serxa)).

#### Experimental Feature
* Multi-stage distributed query execution: the planner splits the query plan into stages connected by scatter / broadcast / gather / shuffle exchanges and dispatches the plan fragments to worker nodes. The data between stages is streamed via TCP or passed via temporary files in shared object storage, the path supports distributed shuffle and broadcast hash joins, shuffle aggregation, and distributed sort. The feature is experimental and is disabled by default. [#106020](https://github.com/ClickHouse/ClickHouse/pull/106020) ([Alexander Gololobov](https://github.com/davenger)). The experimental distributed query plan engine (`make_distributed_plan`) can now use a different task-dispatch and streaming-exchange port per worker, configured per replica in `<remote_servers>` with `stateless_worker_port` and `streaming_exchange_port`. When unset, the previous server-level ports (`stateless_worker_client.port` and `distributed_query.streaming_exchange_port`) are used. This makes it possible to run several workers on one host. [#107885](https://github.com/ClickHouse/ClickHouse/pull/107885) ([Alexander Gololobov](https://github.com/davenger)).
* Added the experimental `dphyp` join reordering algorithm for inner joins as an option for the `query_plan_optimize_join_order_algorithm` setting, and the `query_plan_optimize_join_order_max_searched_plans` setting, which bounds the join-order search and falls back to the next algorithm in the chain when the bound is exceeded; set it to `0` to keep the previous unbounded search behavior. [#98798](https://github.com/ClickHouse/ClickHouse/pull/98798) ([Alexander Gololobov](https://github.com/davenger)).
* Add `aiEmbed` function for using LLM APIs to generate embeddings from within ClickHouse. [#102922](https://github.com/ClickHouse/ClickHouse/pull/102922) ([George Larionov](https://github.com/george-larionov)).
* Added an experimental Linux OOM canary: a sacrificial child process that the Linux OOM killer targets before the main server process. When enabled with `oom_canary_enable`, it sheds memory pressure by purging allocator caches, cancelling queries, cancelling merges, and recording an event in `system.crash_log`. The OOM response requires cgroup v2 `memory.events` OOM-kill evidence. [#101942](https://github.com/ClickHouse/ClickHouse/pull/101942) ([Peng](https://github.com/fastio)).
* The web terminal interface at `/webterminal` is now a production feature and is enabled by default. It is controlled by the new `enable_webterminal` server setting; the former `allow_experimental_webterminal` setting is deprecated but still honored for backward compatibility. To disable the endpoint, set `enable_webterminal` to `false`. [#106255](https://github.com/ClickHouse/ClickHouse/pull/106255) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* PromQL HTTP endpoints now support specifying the database and table via URL query parameters (`database=`, `table=`, or `table=db.table`). The previous implicit `default.prometheus` table fallback is removed: if neither the handler config nor the URL specifies a table, the handler now returns `The time series table name is not set`. To keep the old behavior, configure `<table>default.prometheus</table>` or pass `table=...` in the URL. [#107553](https://github.com/ClickHouse/ClickHouse/pull/107553) ([Vitaly Baranov](https://github.com/vitlibar)).
* Added support for the PromQL `histogram_quantile` function in `prometheusQuery` and `prometheusQueryRange` table functions. This enables computing quantiles over classic Prometheus histogram buckets identified by the `le` label. [#103477](https://github.com/ClickHouse/ClickHouse/pull/103477) ([Joe Smith](https://github.com/Yasumoto)).
* Added lazy posting list apply mode for the text index. When enabled via `SET allow_experimental_text_index_lazy_apply = 1` and `SET text_index_posting_list_apply_mode = 'lazy'`, posting lists are decoded on demand at packed-block granularity using a cursor-based approach instead of being fully materialized into Roaring Bitmaps, reducing memory usage and CPU time for selective text index queries. [#100035](https://github.com/ClickHouse/ClickHouse/pull/100035) ([Peng](https://github.com/fastio)).
* Added support for the [AssemblyScript](https://www.assemblyscript.org) ABI for WebAssembly UDFs. You can try the AssemblyScript ABI without installing the toolchain locally by using the browser-based [playground](https://pastila.nl/?0009878e/b9768c4e2144d0c2f3dd512e7a1aaf69.html), which compiles AssemblyScript code and loads the resulting WebAssembly module into local ClickHouse. [#104606](https://github.com/ClickHouse/ClickHouse/pull/104606) ([Vladimir Cherkasov](https://github.com/vdimir)).
* Allow for attaching Prometheus handlers on the main HTTP port with an optional prefix. [#104975](https://github.com/ClickHouse/ClickHouse/pull/104975) ([James Cunningham](https://github.com/JTCunning)).
* Added an experimental `MergeTree` setting `packed_skip_index_max_bytes` that bundles small skip-index substreams into a single `skp_idx.packed` archive per part, reducing inode pressure when many skip indices are defined on a table. The decision is per substream at write time: substreams whose serialized size stays under the threshold go into the archive, anything larger keeps the standalone `skp_idx_<name>.idx2` / `.mrk2` layout. A single part can mix layouts. Full-text indices are not supported and are always per-file. Default is 0 (packing disabled). [#105321](https://github.com/ClickHouse/ClickHouse/pull/105321) ([Raúl Marín](https://github.com/Algunenano)).
* Support `Buffers` serialization for WebAssembly UDFs using `ABI BUFFERED_V1`, and add `webassembly_udf_enable_fuel` as a persisted WASM UDF function setting. [#105574](https://github.com/ClickHouse/ClickHouse/pull/105574) ([Antonio Andelic](https://github.com/antonio2368)).
* Add an experimental `use_reader_executor` setting (default off) that routes reads through a new pipeline-based `ReaderExecutor` instead of the legacy chain of read buffers. [#106570](https://github.com/ClickHouse/ClickHouse/pull/106570) ([Sema Checherinda](https://github.com/CheSema)). Added observability metrics for the experimental `use_reader_executor` read path, including a modeled read-cost KPI (`ReaderExecutorModeledCostMsPerRequestedMiB`). [#106968](https://github.com/ClickHouse/ClickHouse/pull/106968) ([Sema Checherinda](https://github.com/CheSema)). Introduced the `ChainedBuffers` buffer behind the experimental `use_reader_executor` read path, with a `ReaderExecutorChainedBufferBytes` metric. [#107210](https://github.com/ClickHouse/ClickHouse/pull/107210) ([Sema Checherinda](https://github.com/CheSema)).
* Descending sort order in `MergeTree` sorting keys (e.g. `ORDER BY (time DESC, key)`) is now always supported and no longer requires the experimental setting `allow_experimental_reverse_key`, which became obsolete. [#106440](https://github.com/ClickHouse/ClickHouse/pull/106440) ([Nikita Mikhaylov](https://github.com/nikitamikhaylov)).
* `Nullable(Tuple(...))` is now Beta. Disabled by default, set `enable_nullable_tuple_type = 1` to use it. [#107754](https://github.com/ClickHouse/ClickHouse/pull/107754) ([Nihal Z. Miaji](https://github.com/nihalzp)).

#### Performance Improvement
* Various changes to Keeper that make it around 2x faster overall (better batching, pipelining messages to leader, pipelining log appends). [#101757](https://github.com/ClickHouse/ClickHouse/pull/101757) ([Michael Kolupaev](https://github.com/al13n321)).
* Reduce per-query overhead for simple `SELECT` queries (parsing, analysis and planning). For example, `SELECT count() FROM hits` from a single connection is roughly 50% faster. [#104513](https://github.com/ClickHouse/ClickHouse/pull/104513) ([Raúl Marín](https://github.com/Algunenano)).
* Optimize primary key index analysis for long and high-cardinality primary keys. For a long primary key, the run time of index analysis now mainly depends on the complexity of the query's filter (the key columns it actually uses), not on the length of the primary key — so extending the sorting key has negligible extra overhead on index analysis for queries that filter on only a few of its columns. For a high-cardinality primary key, where ClickHouse keeps only a selective prefix of the key columns in memory and does not load the trailing ones, index analysis now works on just that in-memory prefix instead of the whole key. The optimization is enabled by default and can be turned off with the new setting `use_lightweight_primary_key_index_analysis`. Closes [#65103](https://github.com/ClickHouse/ClickHouse/issues/65103). [#91836](https://github.com/ClickHouse/ClickHouse/pull/91836) ([Nihal Z. Miaji](https://github.com/nihalzp)).
* The default x86 build now targets x86-64-v3 (AVX2) instead of x86-64-v2 (SSE4.2). This requires a CPU with AVX2 support (Intel Haswell or later, AMD Excavator or later). If your CPU does not support AVX2, use the `amd64compat` build which targets plain x86-64. [#105019](https://github.com/ClickHouse/ClickHouse/pull/105019) ([Raúl Marín](https://github.com/Algunenano)).
* Use `ipnsort` and `driftsort` (stable sorting) — C++ ports of the Rust standard library's sort implementations — for the general-purpose comparison sorts. Speeds up `ORDER BY` on non-numeric columns and stable sorts, and removes a worst case on reverse-sorted input. [#106650](https://github.com/ClickHouse/ClickHouse/pull/106650) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* New `GROUP BY` optimization for high cardinality evenly distributed keys that scatters rows across threads by hashing the grouping key, so each thread aggregates a disjoint subset of keys without a merge phase. Set `enable_sharding_aggregator = 1` to enable it. [#104233](https://github.com/ClickHouse/ClickHouse/pull/104233) ([Nihal Z. Miaji](https://github.com/nihalzp)).
* Enable hash table prefetching for string key `GROUP BY` queries, improving high-cardinality string aggregation performance by ~8%. [#101007](https://github.com/ClickHouse/ClickHouse/pull/101007) ([Le Zhang](https://github.com/damahua)).
* Reduced peak memory usage when merging partial two-level aggregation results with large aggregate states (e.g. `groupArray`), by freeing each bucket's source states incrementally during the merge instead of keeping them all alive until the merge completes. [#102330](https://github.com/ClickHouse/ClickHouse/pull/102330) ([Yuri Fedoseev](https://github.com/yurifedoseev)).
* Memory representation of `Enum` `DataType` was optimized. Memory footprint of tables that have `Enum` type in it can improve up to 10x times for `Enum` component. Operation time to retrieve name by value(number) is similar or faster. Search by name is slightly slower, but this access direction is less common. [#95668](https://github.com/ClickHouse/ClickHouse/pull/95668) ([Ilya Yatsishin](https://github.com/qoega)).
* Add identifier resolution caching to prevent duplicate identifier resolution during query analysis. [#88043](https://github.com/ClickHouse/ClickHouse/pull/88043) ([Max Justus Spransy](https://github.com/maxjustus)).
* Improve performance of query analysis for queries over tables with many columns: avoid computing column node hashes (which include the whole source table expression) when not needed. Analyzing nested `SELECT *` subqueries over a table with ~1200 columns is now about 50 times faster. [#106957](https://github.com/ClickHouse/ClickHouse/pull/106957) ([Dmitry Novik](https://github.com/novikd)).
* Sped up query analysis for queries with many or deeply nested function calls by removing a redundant query-tree hash from the function resolution cache. [#107516](https://github.com/ClickHouse/ClickHouse/pull/107516) ([Dmitry Novik](https://github.com/novikd)).
* Fixed long login and query-startup stalls with replicated access storage when many access entities (row policies, roles, quotas, settings profiles) change at once. Each per-entity cache now recomputes once per notification batch instead of once per changed entity, removing quadratic work that could hold the access lock for minutes. [#107672](https://github.com/ClickHouse/ClickHouse/pull/107672) ([Azat Khuzhin](https://github.com/azat)).
* Share the hash join's `FixedHashMap` as the join runtime filter on the probe side. When the build-side hash table is (or can be converted to) a `FixedHashMap`, it is published as the runtime filter and replaces the `Set`/`BloomFilter` that `BuildRuntimeFilterStep` would otherwise install. Controlled by the new setting `join_runtime_filter_from_fixed_hash_table` (default `true`). [#105640](https://github.com/ClickHouse/ClickHouse/pull/105640) ([Xiaozhe Yu](https://github.com/wudidapaopao)).
* Lazy application of selector and replication indexes in case of `JOIN` followed by a selective `LIMIT` or `TopN` or another `JOIN`. To control the number of payload columns for enabling lazy selector indexes use the setting `query_plan_min_columns_for_join_lazy_indexing` (0 means the optimization is disabled). To control the `LIMIT` for which the optimization is applied use the setting `query_plan_max_limit_for_join_lazy_indexing`. [#106566](https://github.com/ClickHouse/ClickHouse/pull/106566) ([Hechem Selmi](https://github.com/m-selmi)).
* DP (dynamic programming) JOIN reordering is now allowed with parallel replicas. [#105889](https://github.com/ClickHouse/ClickHouse/pull/105889) ([Nikita Taranov](https://github.com/nickitat)).
* Improved query plan when JOIN uses runtime filters (default-on `enable_join_runtime_filters`): the join-reorder cost model now sees through `WindowTransform` (and other row-preserving plan steps) on the right subtree and uses the underlying row count and per-column NDV instead of falling back to no statistics. [#107229](https://github.com/ClickHouse/ClickHouse/pull/107229) ([UnamedRus](https://github.com/UnamedRus)).
* De-virtualize the emission of non-joined rows in RIGHT and FULL join by batching them. [#105679](https://github.com/ClickHouse/ClickHouse/pull/105679) ([Hechem Selmi](https://github.com/m-selmi)).
* Support packed `keys32` and `keys64` methods in `HashJoin`. [#107202](https://github.com/ClickHouse/ClickHouse/pull/107202) ([Nikita Taranov](https://github.com/nickitat)).
* Support packed `keys32` and `keys64` methods in `Set`. [#107564](https://github.com/ClickHouse/ClickHouse/pull/107564) ([Nikita Taranov](https://github.com/nickitat)).
* More optimal handling of nullable columns in aggregation. [#106015](https://github.com/ClickHouse/ClickHouse/pull/106015) ([Nikita Taranov](https://github.com/nickitat)).
* Improve performance of `LIMIT BY` queries. [#103349](https://github.com/ClickHouse/ClickHouse/pull/103349) ([Nihal Z. Miaji](https://github.com/nihalzp)).
* Speed up `ORDER BY ... LIMIT BY` queries by running `LIMIT BY` inside each parallel sorted stream during `Sort` when `LIMIT BY`'s columns are a prefix of the `ORDER BY`. This reduces the number of rows flowing through the final sort merge and any downstream pipeline steps. This optimization is controlled by the new setting `query_plan_push_limit_by_into_sort` (enabled by default). [#104000](https://github.com/ClickHouse/ClickHouse/pull/104000) ([Nihal Z. Miaji](https://github.com/nihalzp)).
* Speed up `SELECT ... LIMIT N BY <cols>` queries when `<cols>` are a prefix of the table's sorting key, or become one after `WHERE col = const` fixes leading columns. With this enabled the `MergeTree` reads data in primary-key order and `LIMIT BY` first filters in streaming mode with O(1) memory per sorted stream which filters out most of the data, then finally running normal `LIMIT BY` on reduced data to get the final result. Controlled by the new setting `optimize_limit_by_in_order` (enabled by default). [#105135](https://github.com/ClickHouse/ClickHouse/pull/105135) ([Nihal Z. Miaji](https://github.com/nihalzp)).
* Speed up `LIMIT BY` queries on partitioned `MergeTree` tables by running `LIMIT BY` inside each partition's stream in parallel, instead of merging all streams into one before applying the limit. This applies when the partition expression is a deterministic function of the `LIMIT BY` columns, so no `LIMIT BY` group can span two partitions. Controlled by the new setting `allow_limit_by_partitions_independently` (enabled by default). [#105126](https://github.com/ClickHouse/ClickHouse/pull/105126) ([Nihal Z. Miaji](https://github.com/nihalzp)).
* Speed up `LIMIT BY` queries by removing redundant key expressions: a key that is a deterministic function of the other keys is dropped (e.g. `LIMIT 5 BY x, f(x)` becomes `LIMIT 5 BY x`), and an injective function of a key is replaced by its argument (e.g. `LIMIT 5 BY toString(x)` becomes `LIMIT 5 BY x`). This evaluates fewer and cheaper expressions per row. Controlled by the new settings `optimize_limit_by_function_keys` and `optimize_injective_functions_in_limit_by`, both enabled by default. [#106818](https://github.com/ClickHouse/ClickHouse/pull/106818) ([Nihal Z. Miaji](https://github.com/nihalzp)).
* Speed up sharded aggregation, `grace_hash` join bucketing, and parallel window partitioning by replacing per-chunk column hashing with a kernel that uses hardware CRC32C. [#106538](https://github.com/ClickHouse/ClickHouse/pull/106538) ([Harikrishnan Prabakaran](https://github.com/harikrishnan94)).
* Optimize `L1Distance`, `L2Distance`, `L2SquaredDistance`, `LinfDistance`, and `cosineDistance` for array arguments with multi-target auto-vectorization on x86-64-v4/v3. For non-const array arguments, all of these except `LpDistance`, which uses `std::pow` with a runtime exponent, can now use compiler-vectorized kernels. The existing AVX-512 and Sapphire Rapids `BFloat16` const-argument fast paths for `L2Distance` and `cosineDistance` are preserved. [#101310](https://github.com/ClickHouse/ClickHouse/pull/101310) ([Peng](https://github.com/fastio)).
* Improved performance of the `{Norm}Distance` and `dotProduct` functions. [#106007](https://github.com/ClickHouse/ClickHouse/pull/106007) ([Nikita Taranov](https://github.com/nickitat)).
* Improved performance of the `arrayNorm` function. [#106211](https://github.com/ClickHouse/ClickHouse/pull/106211) ([Nikita Taranov](https://github.com/nickitat)).
* The performance of `dotProduct` improved in some cases. [#106210](https://github.com/ClickHouse/ClickHouse/pull/106210) ([Nikita Taranov](https://github.com/nickitat)).
* Improved performance of the AVX-512 const-left paths for `L2Distance` and `cosineDistance` on `Array(Float32)`, `Array(Float64)`, and `Array(BFloat16)` when the array length is exactly divisible by the vectorized processing width. [#104625](https://github.com/ClickHouse/ClickHouse/pull/104625) ([Sergey Kuznetsov](https://github.com/skuznetsov)).
* Enabled AVX-512 codegen for amd and better codegen for `arrayDistance`. [#106505](https://github.com/ClickHouse/ClickHouse/pull/106505) ([Nikita Taranov](https://github.com/nickitat)).
* Improved performance of the `L2DistanceTransposed` and `cosineDistanceTransposed` functions for the `QBit` data type. [#106701](https://github.com/ClickHouse/ClickHouse/pull/106701) ([Raufs Dunamalijevs](https://github.com/rienath)).
* Improve performance of the `encrypt`, `decrypt`, `tryDecrypt`, `aes_encrypt_mysql`, and `aes_decrypt_mysql` functions by up to an order of magnitude, recovering the performance lost in the BoringSSL to OpenSSL 3.x migration (24.4). [#107339](https://github.com/ClickHouse/ClickHouse/pull/107339) ([Konstantin Bogdanov](https://github.com/thevar1able)).
* Improve performance of the `encrypt`, `decrypt`, and `halfMD5` functions by avoiding implicit per-row OpenSSL provider lookups in OpenSSL 3.x. [#99105](https://github.com/ClickHouse/ClickHouse/pull/99105) ([Konstantin Bogdanov](https://github.com/thevar1able)).
* Add SIMD implementation of `SHA1` that hashes multiple inputs in parallel using AVX-512, improving throughput. [#105459](https://github.com/ClickHouse/ClickHouse/pull/105459) ([Joanna Hulboj](https://github.com/jh0x)).
* Added an AArch64 ASIMD/NEON backend for the multi-buffer `MD5` implementation. [#105563](https://github.com/ClickHouse/ClickHouse/pull/105563) ([Venkata  Vineel ](https://github.com/vyalamar)).
* Squash source blocks before calculating projection during `MATERIALIZE PROJECTION` to reduce the number of temporary projection parts and merge overhead. ~3.4x speedup on a 50M-row table. [#100047](https://github.com/ClickHouse/ClickHouse/pull/100047) ([Amos Bird](https://github.com/amosbird)).
* Reduced `INSERT` latency for `MergeTree` tables with skip indices on `ORDER BY` columns by avoiding redundant column permutations during part writing (~17% on traces-shaped workloads). [#101101](https://github.com/ClickHouse/ClickHouse/pull/101101) ([Amos Bird](https://github.com/amosbird)).
* Enabled Arrow's SIMD code paths (NEON on ARM, SSE4.2/AVX2/AVX512 on x86) and used them to speed up decoding of `BYTE_STREAM_SPLIT`-encoded Parquet `FLOAT`/`DOUBLE` columns. [#106376](https://github.com/ClickHouse/ClickHouse/pull/106376) ([Raúl Marín](https://github.com/Algunenano)).
* Improved insertion performance for `LowCardinality` columns with `bloom_filter` indexes. [#106410](https://github.com/ClickHouse/ClickHouse/pull/106410) ([Michael Jarrett](https://github.com/EmeraldShift)).
* Parallelize blob copies in `DiskObjectStorageTransaction::copyFile` using a per-disk thread pool. [#105089](https://github.com/ClickHouse/ClickHouse/pull/105089) ([Asya Shneerson](https://github.com/asya-ch)).
* Avoid reading file contents when using the `One` input format with file-like table functions such as `file` and `s3`. [#105157](https://github.com/ClickHouse/ClickHouse/pull/105157) ([Yue Ni](https://github.com/niyue)).
* Speed up `clickhouse` startup on macOS by about 3x by not exporting dynamic symbols, which the dynamic linker would otherwise process on every launch. [#107768](https://github.com/ClickHouse/ClickHouse/pull/107768) ([Raúl Marín](https://github.com/Algunenano)).
* Speed up filesystem cache loading on startup by avoiding a redundant directory open per cache key. [#107414](https://github.com/ClickHouse/ClickHouse/pull/107414) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Speed up filesystem cache loading on startup by letting directory-listing threads help load cache metadata once listing is finished, instead of leaving half the threads idle. [#107416](https://github.com/ClickHouse/ClickHouse/pull/107416) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Reduced `clickhouse` process startup overhead by updating the bundled WasmEdge library, which no longer generates a random hash secret in a global initializer at every startup. [#107869](https://github.com/ClickHouse/ClickHouse/pull/107869) ([Raúl Marín](https://github.com/Algunenano)).
* The `MergeTree` primary key and skip indexes can now prune granules for filters where `ifNull` or `coalesce` wraps a condition, such as `ifNull(key = 0, 0)` or `coalesce(key = 0, 0)`. Such predicates — often emitted by query generators to turn a possibly-`NULL` comparison into a definite boolean — were previously opaque to index analysis and could not skip granules. This extends the existing `allow_key_condition_coalesce_rewrite` setting (enabled by default). Closes [#106264](https://github.com/ClickHouse/ClickHouse/issues/106264). [#106272](https://github.com/ClickHouse/ClickHouse/pull/106272) ([Andy Zhao](https://github.com/andyzzhao)).
* Skip index evaluation on `DateTime64` types should consume lesser CPU in 26.6. [#107707](https://github.com/ClickHouse/ClickHouse/pull/107707) ([Shankar Iyer](https://github.com/shankar-iyer)).
* Improved performance of text index analysis in multi-token searches by optimizing handling of rare tokens. [#98226](https://github.com/ClickHouse/ClickHouse/pull/98226) ([Anton Popov](https://github.com/CurtizJ)).
* Use a cache for the posting-list compressed segments of the text index. [#106299](https://github.com/ClickHouse/ClickHouse/pull/106299) ([Anton Popov](https://github.com/CurtizJ)).
* Improved the performance of generic exclusion search for queries that select large consecutive ranges of the table. [#93813](https://github.com/ClickHouse/ClickHouse/pull/93813) ([Michael Jarrett](https://github.com/EmeraldShift)).
* `S3` clients with the same endpoint and bucket share a cache, avoiding duplicate region discovery. Closes [#92482](https://github.com/ClickHouse/ClickHouse/issues/92482). [#96802](https://github.com/ClickHouse/ClickHouse/pull/96802) ([Andrey Zvonov](https://github.com/zvonand)).
* If a query contains a `has(<constant array>, <expr>)`, the analyzer will transform the node to use a faster `in` implementation if it is feasible to do so. [#97341](https://github.com/ClickHouse/ClickHouse/pull/97341) ([Shankar Iyer](https://github.com/shankar-iyer)).
* When a new job is scheduled in `ThreadPool`, wake the most recently idle worker thread (LIFO) instead of an arbitrary one. This reduces memory fragmentation from per-thread allocator caches. The order in which jobs are processed is not changed. [#100177](https://github.com/ClickHouse/ClickHouse/pull/100177) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Improved performance of approximate runtime filters and bloom filter indexes. [#100201](https://github.com/ClickHouse/ClickHouse/pull/100201) ([Christoph Viebig](https://github.com/cv4g)).
* Allow `ASOF JOIN` to use the `parallel_hash` join algorithm, parallelizing the build across distinct equality-key values. Previously `ASOF` was unconditionally opted out of `parallel_hash`. [#105375](https://github.com/ClickHouse/ClickHouse/pull/105375) ([Greg Maher](https://github.com/gregakinman)).
* Avoid reading unbounded inputs for `INTERSECT` and `EXCEPT` queries when an empty input makes the result known to be empty. [#105393](https://github.com/ClickHouse/ClickHouse/pull/105393) ([Yue Ni](https://github.com/niyue)).
* Add `constinit` for various `MemoryTracker` blockers. [#105490](https://github.com/ClickHouse/ClickHouse/pull/105490) ([Azat Khuzhin](https://github.com/azat)).
* Improve performance of `bitmapContains` for non-`UInt64` `groupBitmap` states by avoiding repeated `rb_max` calls during range checks. [#105960](https://github.com/ClickHouse/ClickHouse/pull/105960) ([Yue Ni](https://github.com/niyue)).
* Faster discontinuous queries for `LowCardinality` columns backed by a single dictionary. [#103662](https://github.com/ClickHouse/ClickHouse/pull/103662) ([Ivan Babrou](https://github.com/bobrik)).
* Added a fast path for the `HashJoin` probe when the block has a single row. [#106008](https://github.com/ClickHouse/ClickHouse/pull/106008) ([Nikita Taranov](https://github.com/nickitat)).
* Predicates from queries like `SELECT ... FROM view(SELECT ... FROM remote(...)) WHERE ... ` are now pushed into the query sent to the remote shard. The optimization `allow_push_predicate_ast_for_distributed_subqueries` lacked a case for table functions. [#105986](https://github.com/ClickHouse/ClickHouse/pull/105986) ([Nikolai Kochetov](https://github.com/KochetovNicolai)).
* Turn on `enable_join_transitive_predicates` by default. [#103724](https://github.com/ClickHouse/ClickHouse/pull/103724) ([Alexander Gololobov](https://github.com/davenger)).
* Added support for functions `multiSearchAny`, `multiSearchAnyUTF8`, and `multiMatchAny` in text indexes. Also improved text index analysis for the function `match`: now patterns with alternative groups can skip more granules. [#106279](https://github.com/ClickHouse/ClickHouse/pull/106279) ([Anton Popov](https://github.com/CurtizJ)).
* Allow filters introduced after the initial PREWHERE selection (predicate pushdown, runtime filters, or explicit PREWHERE plus a WHERE set by the planner) to be merged into the existing PREWHERE on a second optimizer pass instead of staying as a separate Filter step above the `MergeTree` read. [#105445](https://github.com/ClickHouse/ClickHouse/pull/105445) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* The `QueryConditionCache` now records individually filtered-out granules even within read batches that partially pass PREWHERE, reducing the number of marks re-read by subsequent queries with the same condition. [#105335](https://github.com/ClickHouse/ClickHouse/pull/105335) ([Han Fei](https://github.com/hanfei1991)).
* Added Keeper setting `nuraft_use_bg_thread_for_snapshot_io`, enabled by default, to make `NuRaft` read snapshot objects from a background thread instead of Raft worker threads. [#106285](https://github.com/ClickHouse/ClickHouse/pull/106285) ([Antonio Andelic](https://github.com/antonio2368)).
* Reduce peak memory usage when applying received snapshots in ClickHouse Keeper with `KeeperMemoryStorage`. [#105851](https://github.com/ClickHouse/ClickHouse/pull/105851) ([Antonio Andelic](https://github.com/antonio2368)).
* Route LLVM/JIT allocations to a dedicated jemalloc arena. Reduces RSS fragmentation caused by interleaving long-lived JIT bookkeeping with short-lived query allocations. Adds new asynchronous metrics `jemalloc.jit_arena.active_bytes`, `jemalloc.jit_arena.dirty_bytes`, `CompiledExpressionCacheBytesMax`, and `CompiledExpressionCacheCountMax` for observability. `SYSTEM DROP COMPILED EXPRESSION CACHE` now also drops the underlying CHJIT instances and purges the JIT arena. [#104113](https://github.com/ClickHouse/ClickHouse/pull/104113) ([Raúl Marín](https://github.com/Algunenano)).
* Fix excessive memory reservation when reading sparse dictionary-encoded `Nullable(String)` columns from `Parquet` with the native V3 reader. [#102805](https://github.com/ClickHouse/ClickHouse/pull/102805) ([Francisco](https://github.com/Milias)).
* Fixed `CREATE TABLE ... CLONE AS (and REPLACE / ATTACH PARTITION ... FROM)` on encrypted disks copying data instead of hardlinking it. [#106731](https://github.com/ClickHouse/ClickHouse/pull/106731) ([Nikita Mikhaylov](https://github.com/nikitamikhaylov)).
* Improve cardinality estimation in the query plan optimizer: a column produced by a deterministic single-argument function (e.g. `toYear(date)`) now inherits its argument's number of distinct values as an upper bound instead of being left without statistics, leading to more accurate join reordering. [#107757](https://github.com/ClickHouse/ClickHouse/pull/107757) ([Alexander Gololobov](https://github.com/davenger)).
* Reduced CPU overhead of asynchronous logging under high log rates by notifying the log consumer only on the empty-to-non-empty queue transition instead of on every message. [#107352](https://github.com/ClickHouse/ClickHouse/pull/107352) ([Nikita Mikhaylov](https://github.com/nikitamikhaylov)).
* Remove duplicate calculations during query execution in more scenarios. [#106113](https://github.com/ClickHouse/ClickHouse/pull/106113) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* Parallelize the processing of a recursive CTE's result: a `GROUP BY` or other operation over a large `WITH RECURSIVE` result is no longer limited to a single thread. [#107694](https://github.com/ClickHouse/ClickHouse/pull/107694) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Improved the performance of case-insensitive substring search (`positionCaseInsensitiveUTF8`, `ILIKE`, `multiSearchAnyCaseInsensitiveUTF8`, and related functions) by adding a NEON SIMD path on ARM and a wider AVX2 kernel on x86. [#107882](https://github.com/ClickHouse/ClickHouse/pull/107882) ([Raúl Marín](https://github.com/Algunenano)).
* Fixed a ~16% throughput regression of the `FPC` floating-point codec on ARM that was introduced when its predictor tables started using `VectorWithMemoryTracking`. [#108182](https://github.com/ClickHouse/ClickHouse/pull/108182) ([Groene AI](https://github.com/groeneai)).

#### Improvement
* The background `MemoryWorker` now periodically updates the server's hard memory limit based on the current memory usage and the amount of memory the kernel reports as available, so ClickHouse leaves room for other processes running on the same host. The formula is `(resident memory + system MemAvailable) * max_server_memory_usage_to_ram_ratio`. The same `max_server_memory_usage_to_ram_ratio` server setting controls both the startup cap and the dynamic adjustment; set it to `0` to disable both. To keep only the static startup/reload cap (the behavior of previous versions), set the new server setting `memory_worker_dynamic_hard_limit` to `0`. [#104964](https://github.com/ClickHouse/ClickHouse/pull/104964) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Support C# PostgreSQL client in `PostgreSQL` protocol. This closes [#18611](https://github.com/ClickHouse/ClickHouse/issues/18611). [#80785](https://github.com/ClickHouse/ClickHouse/pull/80785) ([Konstantin Vedernikov](https://github.com/scanhex12)).
* Mutations now use the analyzer. [#98884](https://github.com/ClickHouse/ClickHouse/pull/98884) ([Nikolai Kochetov](https://github.com/KochetovNicolai)).
* Added granular control over query echoing in the CLI. The `--echo` option now accepts an optional boolean value and works in both interactive and batch mode. New options `--echo-formatted` and `--echo-query-id` control whether echoed queries are formatted and whether the `query_id` is printed, respectively. The `--hilite`/`--highlight` option now also controls highlighting of echoed queries. As a side effect, `--echo` is now a boolean-value option, so a positional query directly after a bare `--echo` is treated as its value; use `--echo --query "..."` or `--echo=false` instead. [#106191](https://github.com/ClickHouse/ClickHouse/pull/106191) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Support schema evolution together with concurrent consistency checks for data lake catalogs. [#106102](https://github.com/ClickHouse/ClickHouse/pull/106102) ([Konstantin Vedernikov](https://github.com/scanhex12)).
* Allow cache disk for datalake table engines. [#102017](https://github.com/ClickHouse/ClickHouse/pull/102017) ([RinChanNOW](https://github.com/RinChanNOWWW)).
* Fix `DataLakeCatalog` databases with `catalog_type = 'onelake'` reading table data by using the OneLake Blob endpoint (`.blob.fabric.microsoft.com`) by default. Set `onelake_use_blob_endpoint = false` to keep the previous DFS endpoint (`.dfs.fabric.microsoft.com`) behavior. [#106843](https://github.com/ClickHouse/ClickHouse/pull/106843) ([Konstantin Vedernikov](https://github.com/scanhex12)).
* Update default of `S3(Azure)Queue` setting `persistent_processing_node_ttl_seconds` from `1 hour` to `6 hours` (which stands for cleanup time due to service unclean restart etc). The previous default was fine for processing nodes ttl, but it is also used for bucket lock ttl, which can be hold for longer time, therefore 1 hour was not enough. [#106838](https://github.com/ClickHouse/ClickHouse/pull/106838) ([Kseniia Sumarokova](https://github.com/kssenii)).
* Decreased the default size of the `Iceberg` metadata cache from 1 GB to 128 MB. [#106492](https://github.com/ClickHouse/ClickHouse/pull/106492) ([Konstantin Vedernikov](https://github.com/scanhex12)).
* Propagate the `S3Queue` streaming task `query_id` to dependent table inserts. [#106494](https://github.com/ClickHouse/ClickHouse/pull/106494) ([Christoph Wurm](https://github.com/cwurm)).
* Populate `used_storages` in `system.query_log` with the storage engine name when querying tables via `DataLakeCatalog`. [#100706](https://github.com/ClickHouse/ClickHouse/pull/100706) ([Melvyn Peignon](https://github.com/melvynator)).
* You can check which 'operation' and what 'summary' Iceberg's snapshots have. Useful for testing and debugging. [#106246](https://github.com/ClickHouse/ClickHouse/pull/106246) ([Den Kalantaevskii](https://github.com/Diskein)).
* Complete the final `S3` multipart upload request asynchronously via the task tracker, so it can overlap with the last part upload instead of running serially in finalize. [#105487](https://github.com/ClickHouse/ClickHouse/pull/105487) ([Asya Shneerson](https://github.com/asya-ch)).
* Added four new `MergeTree` table settings to control default parameters of text indexes: `text_index_dictionary_block_size`, `text_index_dictionary_block_frontcoding_compression`, `text_index_posting_list_block_size`, and `text_index_posting_list_codec`. These settings allow tuning text index behavior at the table level without specifying parameters in every index definition. Explicit per-index arguments still take precedence. [#100626](https://github.com/ClickHouse/ClickHouse/pull/100626) ([Anton Popov](https://github.com/CurtizJ)).
* Allow projections to override additional `MergeTree` settings (compression, part format, serialization) beyond just `index_granularity`, with an allow-list of allowed settings and validation. [#101170](https://github.com/ClickHouse/ClickHouse/pull/101170) ([Amos Bird](https://github.com/amosbird)).
* Add `current_projection`, `current_projection_progress`, `projections_completed`, and `projections_remaining` columns to `system.merges` to expose projection merge progress. [#102611](https://github.com/ClickHouse/ClickHouse/pull/102611) ([Amos Bird](https://github.com/amosbird)).
* Fixed `PREWHERE` with `IN` subquery on primary key columns not using primary key index for granule pruning, causing full table scans instead of reading only relevant granules. [#102570](https://github.com/ClickHouse/ClickHouse/pull/102570) ([Nikita Mikhaylov](https://github.com/nikitamikhaylov)).
* Function `h3PolygonToCells` now enforces the maximum array size across all polygons of a `MultiPolygon`, validates the underlying H3 library return codes, and rejects `MultiLineString` arguments instead of silently returning an empty result. [#106399](https://github.com/ClickHouse/ClickHouse/pull/106399) ([Raúl Marín](https://github.com/Algunenano)).
* Add a new keeper-only `system.keeper_snapshots` table with information about local ClickHouse Keeper snapshots. [#105571](https://github.com/ClickHouse/ClickHouse/pull/105571) ([Miсhael Stetsyuk](https://github.com/mstetsyuk)).
* Add a new keeper-only `system.keeper_changelogs` table with information about local ClickHouse Keeper changelog (Raft log) files. [#105617](https://github.com/ClickHouse/ClickHouse/pull/105617) ([Miсhael Stetsyuk](https://github.com/mstetsyuk)).
* Add a keeper-only `system.keeper_cluster` table. Contains one row per Raft cluster member as seen by the current Keeper. [#105646](https://github.com/ClickHouse/ClickHouse/pull/105646) ([Miсhael Stetsyuk](https://github.com/mstetsyuk)).
* Add more Keeper profile (server-side + client-side) events for watches. Closes [#97703](https://github.com/ClickHouse/ClickHouse/issues/97703). [#105336](https://github.com/ClickHouse/ClickHouse/pull/105336) ([Konstantin Vedernikov](https://github.com/scanhex12)).
* Added Keeper `coordination_settings` for `NuRaft` uncommitted log entry admission limiting and append-entries backward-probe throttling. [#106108](https://github.com/ClickHouse/ClickHouse/pull/106108) ([Antonio Andelic](https://github.com/antonio2368)).
* Add `enable_compression` setting for the `mysql` table function, the `MySQL` table engine, the `MySQL` database engine, dictionary `SOURCE(MYSQL)`, and named collections. When enabled, ClickHouse negotiates MySQL protocol-level compression for all data transferred over the connection. [#103229](https://github.com/ClickHouse/ClickHouse/pull/103229) ([Bernard Lim](https://github.com/bernardlim)).
* Reduced cancellation latency for queries running over the PostgreSQL wire protocol: `KILL QUERY` now interrupts output serialization within a single chunk instead of waiting for the entire chunk to be sent to the client. [#106535](https://github.com/ClickHouse/ClickHouse/pull/106535) ([Roman Vasin](https://github.com/rvasin)).
* Reduced cancellation latency for queries running over the MySQL wire protocol: `KILL QUERY` now interrupts output serialization within a single chunk instead of waiting for the entire chunk to be sent to the client. [#107228](https://github.com/ClickHouse/ClickHouse/pull/107228) ([Roman Vasin](https://github.com/rvasin)).
* Fixed reading of the `auth_response` length in the MySQL handshake, where a length byte `>= 128` was interpreted as a multi-gigabyte value because it was read as a signed `char`. [#107384](https://github.com/ClickHouse/ClickHouse/pull/107384) ([uwezkhan](https://github.com/uwezkhan)).
* `MaterializedPostgreSQL` now maps PostgreSQL `numeric(p, 0)` columns with precision greater than 76 (e.g. `numeric(78, 0)` used for 256-bit integers) to ClickHouse `Int256` instead of failing with "Precision too big". Values that do not fit into `Int256` are rejected with a clear error. [#107431](https://github.com/ClickHouse/ClickHouse/pull/107431) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Send an exception to the client when TCP connection setup fails. [#107317](https://github.com/ClickHouse/ClickHouse/pull/107317) ([Nikolai Kochetov](https://github.com/KochetovNicolai)).
* Users can now insert `Avro` `Fixed` fields for 8-bit/16-bit/32-bit/64-bit integer variants. [#98139](https://github.com/ClickHouse/ClickHouse/pull/98139) ([Patrick Pichler](https://github.com/patrickpichler)).
* The `AvroConfluent` format now retries the Confluent Schema Registry HTTP client on transient failures (transport timeouts, connection refused, DNS errors, HTTP `5xx`/`408`/`429`) with exponential backoff, instead of aborting the INSERT on the first network glitch. New settings `format_avro_schema_registry_max_retries` (default `5`) and `format_avro_schema_registry_retry_initial_backoff_ms` (default `100`) control the policy. Schema-validation errors (HTTP `409`, malformed Avro JSON) remain fatal. [#106661](https://github.com/ClickHouse/ClickHouse/pull/106661) ([Groene AI](https://github.com/groeneai)).
* Record privileges in `system.query_log.used_privileges` for all granted access checks, including those that go through the non-throwing `isGranted` path (`checkAccessWithFilter`). Previously only privileges checked via throwing entry points (`checkAccess` / `checkGrantOption`) were recorded, which made `READ ON FILE` / `READ ON S3` / `READ ON AZURE` / `READ ON URL` invisible in the audit log for `DESCRIBE`, `CREATE TABLE AS`, and similar queries that use `file` / `s3` / `azure` / `url` table functions. Access enforcement is unchanged. [#104693](https://github.com/ClickHouse/ClickHouse/pull/104693) ([Alexey Bakharew](https://github.com/alexbakharew)).
* Added asynchronous metrics `TotalUncompressedBytesOfMergeTreeTables` and `TotalUncompressedBytesOfMergeTreeTablesSystem`, reporting the total uncompressed size of data stored in MergeTree-family tables. [#106364](https://github.com/ClickHouse/ClickHouse/pull/106364) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Adds the `GlobalMemoryLimitExceeded` profile event so operators can monitor when the server-wide memory limit is hit. [#106466](https://github.com/ClickHouse/ClickHouse/pull/106466) ([Sacheendra Talluri](https://github.com/sacheendra)).
* Populate the `ExecutableUserDefinedFunction*` `ProfileEvents` counters for `executable_pool` UDFs. Per-call invocation count, wall and pool-wait time, child-process CPU and peak memory, and stdin/stdout bytes are now visible in `system.query_log.ProfileEvents`. [#105010](https://github.com/ClickHouse/ClickHouse/pull/105010) ([Xu Jia](https://github.com/XuJia0210)) [#105618](https://github.com/ClickHouse/ClickHouse/pull/105618) ([Ilya Andreev](https://github.com/andreev-io)).
* Added asynchronous metrics `ExecutableUserDefinedFunctionMemoryResidentBytes` and `ExecutableUserDefinedFunctionProcesses`, reporting the resident memory (`VmRSS`) and number of live processes of `executable` and `executable_pool` user-defined functions, including descendant processes and idle pool workers. [#107300](https://github.com/ClickHouse/ClickHouse/pull/107300) ([Hanzi Jiang](https://github.com/HanziJiang)).
* Added three Linux-only async metrics — `MemoryThreadStacksCount`, `MemoryThreadStacksVirtual`, and `MemoryThreadStacksResident` — that report pthread stack memory separately from the rest of anonymous memory. Enabled via `asynchronous_metrics_enable_heavy_metrics`. Requires Linux 5.17+ (`prctl(PR_SET_VMA_ANON_NAME)`) and readable `/proc/self/smaps`; otherwise the metrics are absent and the limitation is reported in `system.warnings`. [#106230](https://github.com/ClickHouse/ClickHouse/pull/106230) ([Raúl Marín](https://github.com/Algunenano)).
* Expose the `MemoryThreadStacks*` asynchronous metrics (resident/virtual size and count of thread stacks) on macOS. [#107752](https://github.com/ClickHouse/ClickHouse/pull/107752) ([Raúl Marín](https://github.com/Algunenano)).
* Table engines now carry embedded documentation, introspectable via the new `description`, `syntax`, `examples`, `introduced_in`, and `related` columns of the `system.table_engines` table. [#106177](https://github.com/ClickHouse/ClickHouse/pull/106177) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Database engines now carry embedded documentation, introspectable via the new `description`, `syntax`, `examples`, `introduced_in`, and `related` columns of the `system.database_engines` table. [#106178](https://github.com/ClickHouse/ClickHouse/pull/106178) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Data types now carry embedded documentation, introspectable via the new `description`, `syntax`, `examples`, `introduced_in`, and `related` columns of the `system.data_type_families` table. [#106180](https://github.com/ClickHouse/ClickHouse/pull/106180) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Input/output formats now carry embedded documentation, introspectable via the new `description`, `examples`, `introduced_in`, and `related` columns of the `system.formats` table. [#106181](https://github.com/ClickHouse/ClickHouse/pull/106181) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Aggregate function combinators now carry embedded documentation, introspectable via the new `description`, `syntax`, `examples`, `introduced_in`, and `related` columns of the `system.aggregate_function_combinators` table. [#106185](https://github.com/ClickHouse/ClickHouse/pull/106185) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Added the `--chime` command-line option to `clickhouse-client`, `clickhouse-local`, and the embedded client. When a query finishes (on success or on error) after running for at least N seconds, the client writes the ASCII `BEL` control character (`\x07`) to stderr. Terminals decide whether to make a sound or a visual flash based on the user's preferences. Enabled by default with a 5-second threshold; pass `--chime N` for a custom threshold or `--chime 0` to disable. Closes [#92718](https://github.com/ClickHouse/ClickHouse/issues/92718). [#104545](https://github.com/ClickHouse/ClickHouse/pull/104545) ([Groene AI](https://github.com/groeneai)).
* In `clickhouse-client`, when the terminal does not support bracketed paste, embedded newlines from a pasted multi-line query are now folded into the same edit buffer instead of switching to the continuation prompt for every line. The pasted query stays under a single prompt and the arrow keys navigate across its lines. This is a best-effort improvement that relies on the typical TTY-buffered paste behavior. [#104299](https://github.com/ClickHouse/ClickHouse/pull/104299) ([Alexey Milovidov](https://github.com/alexey-milovidov)). Now also works with syntax highlighting disabled (`--highlight 0`). [#106665](https://github.com/ClickHouse/ClickHouse/pull/106665) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Add MySQL-style runtime pager control for `clickhouse-client`/`clickhouse-local`. [#105706](https://github.com/ClickHouse/ClickHouse/pull/105706) ([Azat Khuzhin](https://github.com/azat)).
* `clickhouse-client` now respects non-UTF-8 terminals: when the terminal character encoding is not UTF-8 (e.g. with `LANG=C`), the `Pretty` formats fall back to ASCII grid borders instead of printing Unicode box-drawing characters that would corrupt the terminal. [#106213](https://github.com/ClickHouse/ClickHouse/pull/106213) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Sanitize server-supplied display strings in `clickhouse-client`'s `Hello` packet handling (server name, time zone, display name, password-rule patterns and messages) so a hostile server cannot inject bytes that the client renders verbatim, and cap their size to defend against unbounded allocation. [#105243](https://github.com/ClickHouse/ClickHouse/pull/105243) ([Raúl Marín](https://github.com/Algunenano)).
* The Web UI now displays the result as an image when a query uses an image output format such as `FORMAT PNG`, instead of showing the raw bytes as a table. [#107638](https://github.com/ClickHouse/ClickHouse/pull/107638) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Add setting `output_format_pretty_use_nbsp_for_padding` to render table-layout padding in table-style `Pretty` formats as `U+00A0` NO-BREAK SPACE when `output_format_pretty_grid_charset` is `UTF-8`. This helps copied `Pretty` output keep table alignment in tools that collapse regular spaces. The setting is disabled by default, and `ASCII` charset output keeps regular spaces. [#103559](https://github.com/ClickHouse/ClickHouse/pull/103559) ([Ashrith Bandla](https://github.com/ashrithb)).
* The universal install script now also installs `clickhousectl` into `~/.local/bin` on Linux and macOS, with a `chctl` symlink. Set `CLICKHOUSE_ONLY=1` to skip. [#105399](https://github.com/ClickHouse/ClickHouse/pull/105399) ([Alasdair Brown](https://github.com/sdairs)).
* Fixed a spurious `Syntax error: Unterminated quoted string` that could occur intermittently when installing ClickHouse via `curl https://clickhouse.com/ | sh` while a `clickhouse` binary already existed in the current directory. [#106417](https://github.com/ClickHouse/ClickHouse/pull/106417) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix the left panel height on the `play.html` page when the web terminal is open, so the terminal toggle button at the bottom stays visible. [#105087](https://github.com/ClickHouse/ClickHouse/pull/105087) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Avoid selecting the only query in the Web UI after running it. [#105711](https://github.com/ClickHouse/ClickHouse/pull/105711) ([Joey Yu](https://github.com/itsjoeoui)).
* The Web SQL UI now expands the query editor when a query is at most 30% taller than the current editor height. [#105713](https://github.com/ClickHouse/ClickHouse/pull/105713) ([Joey Yu](https://github.com/itsjoeoui)).
* In the Web UI, lay out the bottom menu icons (Web Terminal and GitHub) horizontally when the left panel is expanded, giving the list of databases and tables more vertical space. [#106427](https://github.com/ClickHouse/ClickHouse/pull/106427) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* In the Web UI (`play.html`), pressing `Escape` now deactivates the currently selected result-table cell. [#107777](https://github.com/ClickHouse/ClickHouse/pull/107777) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Improvements to the database panel in the Web SQL UI (Play): a tooltip on the database icon, a button to hide the panel, full-width clickable database/table names, and a fix for the panel width shifting when the scrollbar appears. [#108013](https://github.com/ClickHouse/ClickHouse/pull/108013) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Add a server setting (`min_allocation_size_to_throw_on_memory_limit`) to allow any allocation to throw `MEMORY_LIMIT_EXCEEDED`, this should help with preventing OOMs. [#105265](https://github.com/ClickHouse/ClickHouse/pull/105265) ([Azat Khuzhin](https://github.com/azat)).
* Allow `NONE` authentication for SSH (prevents asking password for `no_password` users). [#105476](https://github.com/ClickHouse/ClickHouse/pull/105476) ([Azat Khuzhin](https://github.com/azat)).
* Reset the supplementary group list in `clickhouse su` before dropping privileges, matching the behavior of `/bin/su` and `sudo`. Previously the dropped process inherited the invoker's supplementary groups. [#105247](https://github.com/ClickHouse/ClickHouse/pull/105247) ([Raúl Marín](https://github.com/Algunenano)).
* Add `BFloat16` support for numeric predicate (`isFinite`, `isNaN`) functions. [#105391](https://github.com/ClickHouse/ClickHouse/pull/105391) ([Mohamed Hussain S](https://github.com/mohhddhassan)).
* Reduce memory usage of polygon dictionaries (`polygon_index_cell`, `polygon_index_each`) and make `system.dictionaries.bytes_allocated` correctly reflect the lookup index they build. [#105431](https://github.com/ClickHouse/ClickHouse/pull/105431) ([Raúl Marín](https://github.com/Algunenano)).
* Fixes Kafka table engine consumers that kept using a short poll interval after partition assignment, so they return to the configured `kafka_poll_timeout_ms` and avoid excessive empty polls, smaller inserted parts, and extra merge overhead after rebalances. [#100431](https://github.com/ClickHouse/ClickHouse/pull/100431) ([sugaf1204](https://github.com/sugaf1204)).
* Identify columns by position (instead of by name) when removing unused columns in the query plan. This enables unused-column removal when duplicated column names are present. [#100586](https://github.com/ClickHouse/ClickHouse/pull/100586) ([János Benjamin Antal](https://github.com/antaljanosbenjamin)).
* ClickHouse throws a proper exception for attempts to use `table_readonly` for replicated engines, with better exception handling for DDL queries (and `DatabaseReplicated`) related to this setting. [#100950](https://github.com/ClickHouse/ClickHouse/pull/100950) ([alesapin](https://github.com/alesapin)). `OPTIMIZE TABLE ... ON CLUSTER` and other DDL no longer hang when the target table has `table_readonly = 1`. The setting now throws a new dedicated error code `TABLE_IS_PERMANENTLY_READ_ONLY`, which `DDLWorker` treats as non-retriable (distinct from the transient `TABLE_IS_READ_ONLY` that arises during temporary `ReplicatedMergeTree` ZooKeeper disconnects). The `table_readonly` setting is also now explicitly rejected for `ReplicatedMergeTree`, both at creation and via `ALTER MODIFY SETTING`. Follow-up to [#97652](https://github.com/ClickHouse/ClickHouse/issues/97652). [#105109](https://github.com/ClickHouse/ClickHouse/pull/105109) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fixed refreshable materialized view refreshes that could fail with `UNKNOWN_TABLE` after the target table had been replaced (for example via `EXCHANGE TABLES` or drop-and-recreate): the refresh now resolves the target table by name instead of relying on a stale UUID. [#102724](https://github.com/ClickHouse/ClickHouse/pull/102724) ([Seva Potapov](https://github.com/seva-potapov)).
* Added a setting `wait_for_part_commit_in_dependent_materialized_views` (default `false`). When a materialized view's `SELECT` reads back from its own source table (for example via an `INNER JOIN` to the source), the cascade could miss the row currently being inserted, because the inserted part is committed only after the dependent views run. Enabling this setting commits the part before the dependent views are triggered, so they observe the in-flight row, at the cost of less insert parallelism. [#105943](https://github.com/ClickHouse/ClickHouse/pull/105943) ([Elmi Ahmadov](https://github.com/ahmadov)).
* Do not swallow fatal errors (e.g. `MEMORY_LIMIT_EXCEEDED`) in `tryDeserialize`. [#106808](https://github.com/ClickHouse/ClickHouse/pull/106808) ([Azat Khuzhin](https://github.com/azat)).
* Check `CREATE TEMPORARY TABLE` grant lazily in `InverseDictionaryLookupPass`. [#107098](https://github.com/ClickHouse/ClickHouse/pull/107098) ([Azat Khuzhin](https://github.com/azat)).
* Fix an `ILLEGAL_TYPE_OF_ARGUMENT` error for distributed queries with `serialize_query_plan = 1` that contain a lambda with a constant argument (e.g. `arrayMap(t -> t.2, ...)`). Constant columns of `ActionsDAG` `INPUT` nodes are now preserved during query plan serialization. [#107124](https://github.com/ClickHouse/ClickHouse/pull/107124) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Deserialization of the states of the `contingency`, `cramersV`, `cramersVBiasCorrected`, and `theilsU` aggregate functions now validates that the stored counts form a consistent contingency table and throws a `CORRUPTED_DATA` exception otherwise. Closes [#106899](https://github.com/ClickHouse/ClickHouse/issues/106899). [#107185](https://github.com/ClickHouse/ClickHouse/pull/107185) ([Nihal Z. Miaji](https://github.com/nihalzp)).
* Preserve original error codes for exceptions wrapped in `arrow::Status`. [#107267](https://github.com/ClickHouse/ClickHouse/pull/107267) ([Azat Khuzhin](https://github.com/azat)).
* Support `keyed_by_normalized_query_hash` for quotas defined in the static server configuration (`users.xml`), matching the existing `CREATE QUOTA ... KEYED BY normalized_query_hash` DDL syntax. [#107654](https://github.com/ClickHouse/ClickHouse/pull/107654) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* The compatibility setting no longer applies obsolete settings, so it does not mark them as changed or produce obsolete-setting warnings. [#107737](https://github.com/ClickHouse/ClickHouse/pull/107737) ([Maxim Orlovsky](https://github.com/UberDever)).
* Async inserts no longer log the full list of `query_id`s at `trace`/`debug` level, which since 26.2 could blow up `text_log` on services with heavy async insert traffic. Detailed lines are now at `test` level. [#107852](https://github.com/ClickHouse/ClickHouse/pull/107852) ([Sema Checherinda](https://github.com/CheSema)).
* Filesystem cache improvement: stop invalidated priority entries from pinning `KeyMetadata`. Follow up to [#106387](https://github.com/ClickHouse/ClickHouse/pull/106387). [#107903](https://github.com/ClickHouse/ClickHouse/pull/107903) ([Kseniia Sumarokova](https://github.com/kssenii)).
* `FileCache` metrics improvement. [#106116](https://github.com/ClickHouse/ClickHouse/pull/106116) ([Kseniia Sumarokova](https://github.com/kssenii)).
* Do not print the "Stack trace (when copying this message, always include the lines below):" preamble in exception messages when the stack trace is actually empty. [#106524](https://github.com/ClickHouse/ClickHouse/pull/106524) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix a potential overflow in `roundUpToMultiple` when computing filesystem cache boundary alignment for very large offsets. [#92579](https://github.com/ClickHouse/ClickHouse/pull/92579) ([Bharat Nallan](https://github.com/bharatnc)).
* `EXPLAIN SYNTAX` now formats operators as function calls consistently in explain output (for example `plus(1, 2)` instead of `1 + 2`). [#94681](https://github.com/ClickHouse/ClickHouse/pull/94681) ([Mohamed Abdelhalim ](https://github.com/1abdelhalim)).
* Improved table name hints in error messages: no longer suggests the exact same name, and includes the database name in the suggestion (e.g., "Maybe you meant `other_db.my_table`?"). [#95116](https://github.com/ClickHouse/ClickHouse/pull/95116) ([Mathuranath Metivier](https://github.com/matt-metivier)).
* Improved error message for unresolved identifiers in queries without a `FROM` clause to suggest adding one. [#101769](https://github.com/ClickHouse/ClickHouse/pull/101769) ([Yash ](https://github.com/Onyx2406)).
* Add `EXPLAIN PIPELINE` option to compact repeated processor chains. [#104662](https://github.com/ClickHouse/ClickHouse/pull/104662) ([Yue Ni](https://github.com/niyue)).
* Fix a heap-buffer-overflow read in syntax-error message construction (`UTF8::computeWidthImpl` via `parseQuery.cpp`) that occurred when the parser had backtracked past the first semicolon / end-of-stream token; release builds were splicing bytes from neighboring heap memory into the displayed error, ASan builds aborted. [#105086](https://github.com/ClickHouse/ClickHouse/pull/105086) ([Groene AI](https://github.com/groeneai)).
* Make hive partition strategy a default under compatibility setting `file_like_engine_default_partition_strategy`. [#86746](https://github.com/ClickHouse/ClickHouse/pull/86746) ([Kseniia Sumarokova](https://github.com/kssenii)).
* Use a larger (8 MiB) thread stack on macOS to match the Linux default, fixing rare server crashes from stack overflow during JIT compilation. [#107033](https://github.com/ClickHouse/ClickHouse/pull/107033) ([Raúl Marín](https://github.com/Algunenano)).
* The temporary storage size limit of `clickhouse-local` is no longer hard-coded to 1 GiB. The default is raised to 1 TiB and can be configured with the `max_temporary_data_on_disk_size` server setting. [#106689](https://github.com/ClickHouse/ClickHouse/pull/106689) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Add `read-checksums` command to `clickhouse-disks`. It reads the `checksums.txt` file of a `MergeTreeDataPart` and prints it as a human-readable, tab-separated table. [#106901](https://github.com/ClickHouse/ClickHouse/pull/106901) ([Asya Shneerson](https://github.com/asya-ch)).
* Added a `read-bitmap` command to `clickhouse-disks`. [#107834](https://github.com/ClickHouse/ClickHouse/pull/107834) ([murphy-4o](https://github.com/murphy-4o)).
* Chdig: enable TLS for secure connections (previous leads to either "unknown setting `skip_verify`" or "connection reset by peer"). [#105864](https://github.com/ClickHouse/ClickHouse/pull/105864) ([Azat Khuzhin](https://github.com/azat)).
* [`chdig` v26.5.1](https://github.com/azat/chdig/releases/tag/v26.5.1). [#105918](https://github.com/ClickHouse/ClickHouse/pull/105918) ([Azat Khuzhin](https://github.com/azat)).
* [`chdig` v26.6.1](https://github.com/azat/chdig/releases/v26.6.1) - `{asynchronous_,}metric_log`, query patterns, heatmaps, logs/traces stored on disk (previously it can use >40GiB for 1 hour of traces). [#107678](https://github.com/ClickHouse/ClickHouse/pull/107678) ([Azat Khuzhin](https://github.com/azat)).
* The server config (`programs/server/config.xml`) now sets `keep_alive_timeout` to 30 (formerly 10), aligning with the actual documented and implemented default. [#107779](https://github.com/ClickHouse/ClickHouse/pull/107779) ([Dan Checkoway](https://github.com/dcheckoway)).
* The default for the server setting `disk_connections_rcvbuf` changed from `0` (kernel TCP autotuning) to `204800` (200 KB), capping the per-socket TCP receive buffer for object-storage (`S3`/`Azure`/`GCS`) disk connections. [#107859](https://github.com/ClickHouse/ClickHouse/pull/107859) ([Sema Checherinda](https://github.com/CheSema)).
* The `PREWHERE` optimizer now groups conjuncts that reference the same column set before estimating selectivity, so that conditions like `a > 2500 AND a < 2502` are evaluated together as a combined range rather than as two independent predicates, producing a more accurate selectivity estimate. [#106337](https://github.com/ClickHouse/ClickHouse/pull/106337) ([Han Fei](https://github.com/hanfei1991)).
* Add silk fiber aware secure and plain socket implementations. [#107680](https://github.com/ClickHouse/ClickHouse/pull/107680) ([Miсhael Stetsyuk](https://github.com/mstetsyuk)).
* Fixed a garbled error message (swapped arguments) and a typo in the `nested` function. [#108031](https://github.com/ClickHouse/ClickHouse/pull/108031) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Added a `sed` command to `clickhouse-disks` that applies a sed expression to a given path, in-place. [#107131](https://github.com/ClickHouse/ClickHouse/pull/107131) ([Asya Shneerson](https://github.com/asya-ch)).
* Added the create-time `materialized_postgresql_use_extended_date_and_time_types` setting for the `MaterializedPostgreSQL` database engine. By default (enabled), PostgreSQL `date`/`timestamp` columns are inferred as `Date32`/`DateTime64`; setting it to `0` at `CREATE DATABASE` time infers the narrower `Date`/`DateTime` types. [#107428](https://github.com/ClickHouse/ClickHouse/pull/107428) ([Alexey Milovidov](https://github.com/alexey-milovidov)).

#### Bug Fix (user-visible misbehavior in an official stable release)
* Make possible to drop detached parts with the `tryN` suffix. [#58957](https://github.com/ClickHouse/ClickHouse/pull/58957) ([János Benjamin Antal](https://github.com/antaljanosbenjamin)).
* Fix a `MULTIPLE_EXPRESSIONS_FOR_ALIAS` exception for queries with duplicate projection aliases (for example `SELECT *, day + 365 AS day`) inside nested subqueries when running with parallel replicas. [#80310](https://github.com/ClickHouse/ClickHouse/pull/80310) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix a bug with `splitMultipartQuery` throwing an "Empty query" error for queries that end with comment after semicolon. [#85491](https://github.com/ClickHouse/ClickHouse/pull/85491) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* Fix an exception with `ARRAY JOIN`s: `Function writeSlice expects same column types for GenericArraySlice and GenericArraySink` which happens when `LowCardinality` numeric types are used (issue [#57243](https://github.com/ClickHouse/ClickHouse/issues/57243)). [#91784](https://github.com/ClickHouse/ClickHouse/pull/91784) ([Jimmy Aguilar Mena](https://github.com/Ergus)).
* Fix `NOT_FOUND_COLUMN_IN_BLOCK` exception when using `LIMIT BY` with constant columns alongside `DISTINCT` and `ORDER BY` with the new analyzer. [#93195](https://github.com/ClickHouse/ClickHouse/pull/93195) ([Ashrith Bandla](https://github.com/ashrithb)).
* Fix `NOT NULL` columns being silently created as `Nullable` when `data_type_default_nullable = 1` and the table is created in a `Replicated` database or via `ON CLUSTER`. [#97572](https://github.com/ClickHouse/ClickHouse/pull/97572) ([xiaohuanlin](https://github.com/xiaohuanlin)).
* Fixed HiveCatalog connection stability by adding automatic retry mechanism and reconnection logic for handling TTransportException errors when communicating with Hive Metastore. [#98471](https://github.com/ClickHouse/ClickHouse/pull/98471) ([Dmitriy Borisenko](https://github.com/otselnik)).
* Fixed `nested` function (used internally by `ARRAY JOIN`) stripping `LowCardinality` from column types, causing `Array(LowCardinality(String))` to become `Array(String)` in output. Closes [#95582](https://github.com/ClickHouse/ClickHouse/issues/95582). [#98974](https://github.com/ClickHouse/ClickHouse/pull/98974) ([Yash ](https://github.com/Onyx2406)).
* Fix "Distributed task iterator is not initialized" exception when using `url`, `s3`, or similar table functions in queries with parallel replicas enabled. [#100146](https://github.com/ClickHouse/ClickHouse/pull/100146) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix logical error exception when reading Iceberg tables whose format version was upgraded by an external tool (e.g. Spark). [#100407](https://github.com/ClickHouse/ClickHouse/pull/100407) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Functions `like`, `ilike`, `notLike`, `notILike`, and `match` now support constant haystack with non-constant needle (e.g. `'foo' LIKE pattern_column`), which previously threw `ILLEGAL_COLUMN`. [#100479](https://github.com/ClickHouse/ClickHouse/pull/100479) ([Yash ](https://github.com/Onyx2406)).
* Fixed wrong row count returned by a `MaterializedView` query with `query_plan_enable_optimizations = 0` when the view maps an integer column to a `Bool` column. [#100692](https://github.com/ClickHouse/ClickHouse/pull/100692) ([Maksim Moisiuk](https://github.com/Maximus5)).
* Fix an exception (`LOGICAL_ERROR: 'PREWHERE passed to format that doesn't support it'`) when reading Iceberg tables containing ORC data files with PREWHERE optimization enabled. [#101206](https://github.com/ClickHouse/ClickHouse/pull/101206) ([Groene AI](https://github.com/groeneai)).
* Fix race in RestCatalog. [#101216](https://github.com/ClickHouse/ClickHouse/pull/101216) ([Smita Kulkarni](https://github.com/SmitaRKulkarni)).
* Fix `NOT_FOUND_COLUMN_IN_BLOCK` error when selecting from a VIEW over a table with a normal projection. [#101218](https://github.com/ClickHouse/ClickHouse/pull/101218) ([Amos Bird](https://github.com/amosbird)).
* Fix stale metadata in FileLog when a file is deleted and recreated. [#101408](https://github.com/ClickHouse/ClickHouse/pull/101408) ([Azat Khuzhin](https://github.com/azat)).
* Fix join reordering silently dropping unmatched rows of a `RIGHT`/`LEFT JOIN` when it is comma-joined (cross) with another table, e.g. `t1 RIGHT JOIN t2 ON t1.c = t2.c, t3`. The query previously returned the inner-join result instead of the outer-join one. [#101684](https://github.com/ClickHouse/ClickHouse/pull/101684) ([Groene AI](https://github.com/groeneai)).
* Fixed `FORMAT` clause being consumed by `INSERT` instead of applying to `EXPLAIN` output in `EXPLAIN INSERT INTO ... SELECT ... FORMAT ...`. [#101772](https://github.com/ClickHouse/ClickHouse/pull/101772) ([Yash ](https://github.com/Onyx2406)).
* Fixed incorrect compression codec selection for `MergeTree` parts when the table-level `default_compression_codec` setting was explicitly configured. Parts written on insert, during merges, and for projections used the server-wide default codec instead of the table-level setting (the empty part produced by a fully-deleting mutation is now covered as well). [#101784](https://github.com/ClickHouse/ClickHouse/pull/101784) ([Yash ](https://github.com/Onyx2406)).
* Reject negative `Float64` values (e.g. `-100.5`) in workload settings like `max_bytes_per_second`, `max_cpus`, etc. Previously only negative integers were validated, allowing negative floats to silently create broken scheduler nodes. Closes [#101825](https://github.com/ClickHouse/ClickHouse/issues/101825). [#101842](https://github.com/ClickHouse/ClickHouse/pull/101842) ([Groene AI](https://github.com/groeneai)).
* Fix a `LOGICAL_ERROR` ("Port is not connected", code 49) that could occur when executing queries involving a VIEW with aggregation inside a JOIN. [#102574](https://github.com/ClickHouse/ClickHouse/pull/102574) ([Jimmy Aguilar Mena](https://github.com/Ergus)).
* Fix inconsistent part metadata after mutations of columns with non-default serializations. [#102817](https://github.com/ClickHouse/ClickHouse/pull/102817) ([Eduard Karacharov](https://github.com/korowa)).
* Fix updating metadata before executing mutation resolves [#96806](https://github.com/ClickHouse/ClickHouse/issues/96806). [#102882](https://github.com/ClickHouse/ClickHouse/pull/102882) ([Smita Kulkarni](https://github.com/SmitaRKulkarni)).
* Fix SELECT queries being significantly slower when concurrent INSERTs are running. Previously an INSERT pipeline reserved CPU slots up to `max_threads` at query start even when most slots were never used, starving concurrent SELECTs. CPU slot allocation is now demand-driven: the pipeline only requests slots as it actually pushes parallelizable work. Applies both to concurrency control and to the preemptive CPU scheduler for workloads. New server setting `concurrent_threads_lazy_allocation` (default `true`) acts as a rollback lever. [#102928](https://github.com/ClickHouse/ClickHouse/pull/102928) ([Seva Potapov](https://github.com/seva-potapov)).
* Fix `NULL` propagation when reading subcolumns extracted from `Nullable(Tuple(...))` columns. For example, for `tup Nullable(Tuple(s Nullable(String)))`, `SELECT tup.s` now correctly returns `NULL` in rows where the outer tuple is `NULL` instead of garbage values. This covers all element types that can represent `NULL`: `Nullable`, `Dynamic`, `Variant` and `LowCardinality(Nullable(...))`. Closes [#105356](https://github.com/ClickHouse/ClickHouse/issues/105356). [#102942](https://github.com/ClickHouse/ClickHouse/pull/102942) ([Nihal Z. Miaji](https://github.com/nihalzp)).
* Throw `INCORRECT_DATA` instead of `LOGICAL_ERROR` when client-supplied data in the Native format is truncated or malformed. [#102975](https://github.com/ClickHouse/ClickHouse/pull/102975) ([János Benjamin Antal](https://github.com/antaljanosbenjamin)).
* Added cancellation check to ObjectStorage read operation. Closes [#98165](https://github.com/ClickHouse/ClickHouse/issues/98165). [#103016](https://github.com/ClickHouse/ClickHouse/pull/103016) ([Smita Kulkarni](https://github.com/SmitaRKulkarni)).
* Respect `input_format_binary_max_type_complexity` in decoding aggregate function parameters. Closes [#102903](https://github.com/ClickHouse/ClickHouse/issues/102903). [#103026](https://github.com/ClickHouse/ClickHouse/pull/103026) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix nullable inference for geo columns in Arrow-based Parquet reader. Closes [#101845](https://github.com/ClickHouse/ClickHouse/issues/101845). [#103032](https://github.com/ClickHouse/ClickHouse/pull/103032) ([Pavel Kruglov](https://github.com/Avogar)).
* Fixed `recursiveRemoveLowCardinality` erasing custom geometry type names (e.g. `LineString` vs `Ring`, `MultiLineString` vs `Polygon`), which caused misinterpretation of the geometry type. Closes [#103207](https://github.com/ClickHouse/ClickHouse/issues/103207). [#103041](https://github.com/ClickHouse/ClickHouse/pull/103041) ([Joanna Hulboj](https://github.com/jh0x)).
* Fixed `input_format_max_block_size_bytes` being silently ignored during `INSERT` parsing when `max_insert_block_size_bytes` is `0` (the default). The setting now correctly limits the size of blocks produced by row input formats. [#103068](https://github.com/ClickHouse/ClickHouse/pull/103068) ([Kirill Kopnev](https://github.com/Fgrtue)).
* Fixed ClickHouse occasionally producing invalid GSSAPI tokens due to incorrect stripping of trailing null bytes. [#103114](https://github.com/ClickHouse/ClickHouse/pull/103114) ([Michael Jarrett](https://github.com/EmeraldShift)).
* Fix analyzer-time constant folding for short-circuit functions (`if`, `multiIf`, `and`, `or`, etc.) so that statically unreachable branches no longer raise exceptions at analysis time. For example, `WITH 0 AS n SELECT multiIf(n = 0, 0, intDiv(100, n))` now correctly returns `0` instead of failing with a division-by-zero error. [#103157](https://github.com/ClickHouse/ClickHouse/pull/103157) ([Peng](https://github.com/fastio)).
* `EXPLAIN SYNTAX` expands parameterized views. [#103263](https://github.com/ClickHouse/ClickHouse/pull/103263) ([Jordi Villar](https://github.com/jrdi)).
* Fix data corruption when writing Parquet (and other trailer-bearing formats such as ORC and Arrow) to HDFS via `INSERT INTO FUNCTION hdfs(...)`. Since 26.1, `WriteBufferFromHDFS` did not flush its working buffer on `finalize()`, so the last up to `DBMS_DEFAULT_BUFFER_SIZE` bytes of every file were silently lost, including the Parquet `PAR1` footer. Reading such files returned `Not a Parquet file (wrong magic bytes at the end of file)`. [#103268](https://github.com/ClickHouse/ClickHouse/pull/103268) ([Groene AI](https://github.com/groeneai)).
* Fix wrong results and a possible logical error for correlated subqueries when a join size limit (`max_rows_in_join` / `max_bytes_in_join`) is set together with `join_overflow_mode = 'break'`. The join created internally to evaluate a correlated subquery now ignores those user limits, so it can no longer stop early and drop rows. [#103322](https://github.com/ClickHouse/ClickHouse/pull/103322) ([Groene AI](https://github.com/groeneai)).
* Fix a bug where `ALTER TABLE ... MODIFY SETTING` on an `EmbeddedRocksDB` table could persist an invalid setting value to the table metadata file even when the server rejected the query. On the next server restart the table would fail to attach with `CANNOT_PARSE_BOOL` (or a similar parsing error), and in databases where load failures are fatal the server would refuse to start. Invalid setting values are now rejected before any metadata is written. [#103417](https://github.com/ClickHouse/ClickHouse/pull/103417) ([Groene AI](https://github.com/groeneai)).
* Fixed a server abort when creating a table with an object-storage engine (`AzureBlobStorage`, `DeltaLakeAzure`, `S3`, `HDFS`) using an unsupported number of arguments. The server now returns a clean `NUMBER_OF_ARGUMENTS_DOESNT_MATCH` error instead of aborting in debug/sanitizer builds. [#103544](https://github.com/ClickHouse/ClickHouse/pull/103544) ([Groene AI](https://github.com/groeneai)).
* Fix a server crash in `JSON` and `Dynamic` data type parameter parsing when the abstract syntax tree (AST) was structurally malformed (for example produced by the AST fuzzer): the `equals(name, value)` parameter expression could be left with fewer than two children, which `DataTypeObject` and `DataTypeDynamic` then dereferenced without bounds checking. [#103545](https://github.com/ClickHouse/ClickHouse/pull/103545) ([Groene AI](https://github.com/groeneai)).
* Fix logical errors in analyzer with column names collision in lambda used in prewhere. Closes [#103584](https://github.com/ClickHouse/ClickHouse/issues/103584). [#103627](https://github.com/ClickHouse/ClickHouse/pull/103627) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix sporadic `Logical error: 'Database <name> not found'` from `DataLakeConfiguration::getCatalog` when an `Iceberg` engine table is loaded inside a regular database during async metadata loading. [#103775](https://github.com/ClickHouse/ClickHouse/pull/103775) ([Groene AI](https://github.com/groeneai)).
* Fix `MULTIPLE_EXPRESSIONS_FOR_ALIAS` errors thrown by remote replicas when running queries that reference projection aliases inside `PREWHERE` / `WHERE` / `HAVING` / `QUALIFY` (e.g. `SELECT x AS a, y AS b, (a AND b) AS c FROM t PREWHERE c`) or `SELECT *` over self-joins with overlapping column names, with parallel replicas and `parallel_replicas_local_plan = 0`. Closes [#74324](https://github.com/ClickHouse/ClickHouse/issues/74324). [#103806](https://github.com/ClickHouse/ClickHouse/pull/103806) ([Groene AI](https://github.com/groeneai)).
* Fix server abort when a query uses nested `coalesce`/`ifNull` comparisons (e.g. `WHERE coalesce(a, b, coalesce(c, d), e) = const`) on a `MergeTree` table with multiple `minmax` skip indexes and `use_skip_indexes_for_disjunctions = 1`. The skip-index rewrite of `<op>(coalesce(...), const)` is now applied recursively to inner coalesce arguments, so the per-index `KeyCondition` RPN matches the template's RPN as the disjunction-tracking code already assumes. [#103929](https://github.com/ClickHouse/ClickHouse/pull/103929) ([Groene AI](https://github.com/groeneai)).
* Fix `max_rows_to_transfer` and `max_bytes_to_transfer` being silently ignored for `GLOBAL IN` and `GLOBAL JOIN` queries under the new analyzer. The settings now raise `SET_SIZE_LIMIT_EXCEEDED` (or break, depending on `transfer_overflow_mode`) when the materialised external table exceeds the configured limit, matching the behavior of the old analyzer. Closes [#103333](https://github.com/ClickHouse/ClickHouse/issues/103333). [#104119](https://github.com/ClickHouse/ClickHouse/pull/104119) ([Groene AI](https://github.com/groeneai)).
* Fix excessive catalog/S3 metadata reads when an INSERT or DDL statement references a non-existent table in a DataLake catalog database with `show_data_lake_catalogs_in_system_tables` enabled. The typo-hint suggestion path loaded full per-table Iceberg metadata for the whole catalog, which could exhaust memory on large catalogs. [#104124](https://github.com/ClickHouse/ClickHouse/pull/104124) ([DQ](https://github.com/il9ue)).
* Fix a crash (`LOGICAL_ERROR` "Columns are assumed to be of identical types, but they are different in Nullable" in debug builds, a `ColumnString::compareAt` null-pointer SIGSEGV in release builds) and a wrong result that could occur in queries using `direct` `join_algorithm` with a `MergeTree` right-side table when the lookup plan reordered columns during optimization. The right-side columns could land in wrong-named slots, so a filter or comparison on the join key saw a column of the wrong type. Surfaced by AST fuzzer as STID 2139-5111 and reported in [#107272](https://github.com/ClickHouse/ClickHouse/issues/107272). [#104174](https://github.com/ClickHouse/ClickHouse/pull/104174) ([Groene AI](https://github.com/groeneai)).
* Reject out-of-range integer partition ID for `Date` instead of silent overflow or `LOGICAL_ERROR` on `ALTER`. [#104250](https://github.com/ClickHouse/ClickHouse/pull/104250) ([Azat Khuzhin](https://github.com/azat)).
* Disable `additional_table_filters` with parallel replicas and the analyzer without query plan serialization. Previously it could lead to incorrect results. [#104296](https://github.com/ClickHouse/ClickHouse/pull/104296) ([Azat Khuzhin](https://github.com/azat)).
* Fix `dictGetOrNull` silently overwriting other columns in the `SELECT` projection with `NULL` when called with a `Nullable` key column whose values are missing in the dictionary. The function was mutating an input-aliased null map in place; it now deep-clones the result column before mutation. Closes [#73633](https://github.com/ClickHouse/ClickHouse/issues/73633). [#104327](https://github.com/ClickHouse/ClickHouse/pull/104327) ([Groene AI](https://github.com/groeneai)).
* Fix a broken patch part after `ALTER TABLE ... DROP PARTITION ID 'patch-...'` followed by `DETACH`/`ATTACH TABLE`. Previously the empty covering part was written without `partition.dat` and `source_parts.dat`, leading to a `broken-on-start_patch-...` entry in `system.detached_parts` after the next attach or server restart. Closes [#93132](https://github.com/ClickHouse/ClickHouse/issues/93132). Closes [#102103](https://github.com/ClickHouse/ClickHouse/issues/102103). [#104353](https://github.com/ClickHouse/ClickHouse/pull/104353) ([Groene AI](https://github.com/groeneai)).
* Fixed streaming `INSERT` with `input_format_max_block_wait_ms` for the `HTTP` interface and for `INSERT SELECT FROM input`, so partial input blocks are flushed before the request finishes. [#104534](https://github.com/ClickHouse/ClickHouse/pull/104534) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fixed a bug where queries combining `arrayJoin` with `ORDER BY ... LIMIT` after a `JOIN` could silently return zero rows. The query plan optimization that lifts function evaluation above the `SortingStep` no longer applies when the lifted expression contains `arrayJoin`, since `arrayJoin` can change the number of rows. Closes [#82279](https://github.com/ClickHouse/ClickHouse/issues/82279). [#104558](https://github.com/ClickHouse/ClickHouse/pull/104558) ([Groene AI](https://github.com/groeneai)).
* Fix a rare server abort during `MergeTree` family table destruction. The abort could occur when `shutdown` raised an exception before the background-job scheduler was fully stopped: a background task firing in that narrow window would dispatch a virtual call through a partially-destroyed storage object and hit `__cxa_pure_virtual`. [#104561](https://github.com/ClickHouse/ClickHouse/pull/104561) ([Groene AI](https://github.com/groeneai)).
* Fix inconsistent result in `JSON` combined subcolumn with a type hint containing null value. [#104584](https://github.com/ClickHouse/ClickHouse/pull/104584) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix wrong results or missed projection when an aggregate projection contains multiple `sumIf` aggregates with different `IN (...)` conditions. [#104765](https://github.com/ClickHouse/ClickHouse/pull/104765) ([Jimmy Aguilar Mena](https://github.com/Ergus)).
* Fix wrong row count from `arrayJoin()` used inside `JOIN ON`: the result was multiplied by the array length an extra time. [#104785](https://github.com/ClickHouse/ClickHouse/pull/104785) ([Shaohua Wang](https://github.com/tiandiwonder)).
* Fix `deltaSumTimestamp` returning wrong results for signed integer types crossing zero. Resolves [#104750](https://github.com/ClickHouse/ClickHouse/issues/104750). [#104830](https://github.com/ClickHouse/ClickHouse/pull/104830) ([Konstantin Bogdanov](https://github.com/thevar1able)).
* Fix block structure mismatch in UnionStep after filter push-down with NULL constants. Closes [#104821](https://github.com/ClickHouse/ClickHouse/issues/104821). [#104853](https://github.com/ClickHouse/ClickHouse/pull/104853) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix `Logical error: 'Metadata is not initialized'` raised by `DELETE FROM` on a freshly-attached `Iceberg`, `DeltaLake`, or `Hudi` table whose metadata file is corrupted or unloadable. A regular user-facing exception is reported instead, and the server keeps running. Closes [#104891](https://github.com/ClickHouse/ClickHouse/issues/104891). [#104917](https://github.com/ClickHouse/ClickHouse/pull/104917) ([Groene AI](https://github.com/groeneai)).
* Fixed the `max_memory_usage_soft_limit` was not updated on-the-fly when the configuration changed. The soft memory limit was calculated once at startup and cached, so subsequent config reloads had no effect. After this fix, the limit is recalculated and applied immediately on every config reload, no Keeper restart required. [#104940](https://github.com/ClickHouse/ClickHouse/pull/104940) ([Kai Zhu](https://github.com/nauu)).
* Fix JIT symbol resolution on macOS so that sort, expression, and aggregate JIT compilation no longer fail with `CANNOT_COMPILE_CODE: Could not find symbol _<name>`. [#104946](https://github.com/ClickHouse/ClickHouse/pull/104946) ([Alexei Fedotov](https://github.com/leshikus)).
* Fix an exception (`Received signal 6 (abort)` in vector hardening, observable as `Tuple::back()` on an empty vector) when executing a query of the form `SELECT ... FROM <Distributed table> WHERE/HAVING/GROUP BY ... (sharding_key_column IN tuple())` with `optimize_skip_unused_shards_rewrite_in` enabled under the new analyzer. [#104966](https://github.com/ClickHouse/ClickHouse/pull/104966) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix a `Logical error: 'Inconsistent AST formatting'` server abort (STID 1941-1bfa) on queries like `CREATE TABLE t (c0 Int CODEC(not((not(materialize(1), materialize(2)))), ZSTD)) ENGINE = Memory` in debug / sanitiser builds. The formatter no longer emits redundant outer parens around a multi-argument `tuple(...)` function call that appears inside `CODEC` / `STATISTICS` / `BACKUP_NAME` argument lists (where the operator form `(a, b)` is disabled), keeping the format-parse-format round-trip stable. [#104991](https://github.com/ClickHouse/ClickHouse/pull/104991) ([Groene AI](https://github.com/groeneai)).
* Fix `NOT_FOUND_COLUMN_IN_BLOCK` thrown by `ALTER TABLE ... MATERIALIZE INDEX` on parts that were created in 25.8 and contain a skip index over a column that was added with a separate `ALTER TABLE ... ADD COLUMN`. The mutation now correctly reads every column required by every pre-existing skip index and projection on the part during force-recalculation. Closes [#104872](https://github.com/ClickHouse/ClickHouse/issues/104872). [#105039](https://github.com/ClickHouse/ClickHouse/pull/105039) ([Groene AI](https://github.com/groeneai)).
* Fixed two `LOGICAL_ERROR: Reading from materialized CTE 'X' before it has been materialized` shapes thrown by queries with `enable_materialized_cte`: (1) a reused materialized CTE filtered by `IN (subquery)` over another materialized CTE, and (2) a materialized CTE referenced both directly and inside a `WHERE ... IN (...)` filter that hits a MergeTree primary key through a nested IN-subquery. `EXPLAIN` on the same queries was affected too because the bugs fired during plan optimization. Closes [#101940](https://github.com/ClickHouse/ClickHouse/issues/101940), closes [#102320](https://github.com/ClickHouse/ClickHouse/issues/102320). [#105041](https://github.com/ClickHouse/ClickHouse/pull/105041) ([Dmitry Novik](https://github.com/novikd)).
* Fix `countmin` statistics `PREWHERE` selectivity estimation for `Float32` columns. Two bugs caused `countmin` statistics to silently produce wrong estimates for `Float32` columns: `ConditionSelectivityEstimator` skipped statistics entirely when the column type (`Float32`) was narrower than the literal type (`Float64`), falling back to default selectivity and ignoring the sketch; and `StatisticsCountMinSketch::estimateEqual` hashed the first N bytes of a `Field` object, but `Field` stores `Float32` as `Float64` (`NearestFieldType<Float32>` = `Float64`), so the byte pattern used at query time differed from the actual `Float32` bytes stored during build. [#105047](https://github.com/ClickHouse/ClickHouse/pull/105047) ([Han Fei](https://github.com/hanfei1991)).
* `ATTACH TABLE name <clauses>;` queries that supply storage clauses (`ORDER BY`, `PARTITION BY`, `PRIMARY KEY`, `SAMPLE BY`, `TTL`, `UNIQUE KEY`, or engine `SETTINGS`) without an `ENGINE` now throw `BAD_ARGUMENTS` instead of silently re-attaching the table with its stored definition and discarding the user-supplied clauses. Query-level session `SETTINGS` (such as `log_comment`) are still applied. Use `ATTACH TABLE t;` to re-attach with stored metadata, or `ALTER TABLE t MODIFY SETTING ...` after `ATTACH` to change settings. [#105068](https://github.com/ClickHouse/ClickHouse/pull/105068) ([Groene AI](https://github.com/groeneai)).
* Fixes a use-after-free in `runningAccumulate` when called on a column whose aggregate function returns its own state (e.g. `uniqStateOrDefaultState`, `sumStateOrDefaultState`, `uniqStateForEachState`). [#105085](https://github.com/ClickHouse/ClickHouse/pull/105085) ([János Benjamin Antal](https://github.com/antaljanosbenjamin)).
* Fixed a bug in the Web UI (`play.html`): running a query while the cursor was past the only trailing `;` reported "empty query" instead of running the query. [#105107](https://github.com/ClickHouse/ClickHouse/pull/105107) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix `LOGICAL_ERROR: 'No user in current context, it's a bug'` when a `CREATE TABLE ... AS SELECT` inside a `Replicated` database reads from `system.current_roles` or `system.enabled_roles`. The query now succeeds and returns an empty result set in this internal DDL worker context. [#105150](https://github.com/ClickHouse/ClickHouse/pull/105150) ([Groene AI](https://github.com/groeneai)).
* Fixed `ILLEGAL_TYPE_OF_ARGUMENT` when merging `quantileExactWeightedInterpolated`, `quantileDD`, or `quantilePrometheusHistogram` aggregate states with their plural `quantilesXxxMerge` counterparts (and vice versa). The singular and plural variants of these three quantile families share the same internal aggregate state but were not listed in the internal name-mapping table, so cross-function state merge — and the function-fusion optimization for these families — were rejected. [#105189](https://github.com/ClickHouse/ClickHouse/pull/105189) ([Groene AI](https://github.com/groeneai)).
* Fix incorrect results of `toStartOfWeek`, `toLastDayOfWeek`, `toMonday`, `toStartOfMonth`, `toLastDayOfMonth`, `toStartOfQuarter` and `toStartOfYear` for `Date32` and `DateTime64` arguments whose result falls outside the `Date` range: instead of overflowing into arbitrary dates, results before `1970-01-01` are now clamped to `1970-01-01` and results after `2149-06-06` are clamped to `2149-06-06`. This also fixes wrong query results (incorrectly pruned parts and granules) when such functions were used in `WHERE` over a `Date32` or `DateTime64` key containing out-of-range values. [#105244](https://github.com/ClickHouse/ClickHouse/pull/105244) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* Fix a logical error in `arrayRemove` when the first argument is an array of `Variant` whose alternatives are all incompatible with the type of the second argument and `variant_throw_on_type_mismatch` is disabled. The function now treats the comparison as "never equal" and returns the array unchanged instead of triggering a server-side `assertTypeEquality` failure. [#105248](https://github.com/ClickHouse/ClickHouse/pull/105248) ([Groene AI](https://github.com/groeneai)).
* Query can be executed successfully even if `FileCache` fails to create some directory on disk for caching. [#105250](https://github.com/ClickHouse/ClickHouse/pull/105250) ([Den Kalantaevskii](https://github.com/Diskein)).
* Fix server abort with `Assertion 'px != 0' failed` in `ExtremesTransform` when a query with `extremes = 1` hits an exception (for example `MEMORY_LIMIT_EXCEEDED`) while the transform is building its extremes columns from the first chunk. The client now receives the original exception instead of crashing the server. [#105264](https://github.com/ClickHouse/ClickHouse/pull/105264) ([Groene AI](https://github.com/groeneai)).
* `LEFT ANTI JOIN` now correctly returns the right-side join key column with default values for unmatched rows, instead of duplicating the left key value. Previously, `SELECT a.x AS l, b.x AS r FROM a LEFT ANTI JOIN b ON a.x = b.x` could return `r = a.x` for the unmatched rows when it should return the default (`0` for `Int32`, `''` for `String`, `NULL` for `Nullable`). Only the join key column was affected; non-key right columns were already defaulted correctly. The same bug appeared in `RIGHT ANTI JOIN` whenever the optimizer swapped sides. Closes [#99959](https://github.com/ClickHouse/ClickHouse/issues/99959). [#105278](https://github.com/ClickHouse/ClickHouse/pull/105278) ([Groene AI](https://github.com/groeneai)).
* Fix data loss in `clickhouse-local` when started repeatedly with a non-default `--default_database` (for example `clickhouse-local --path X -- --default_database=mydb`): the lookup for the persisted database UUID was hardcoded to `metadata/default`, so each restart minted a fresh UUID and the previous run's tables became invisible. Closes [#101831](https://github.com/ClickHouse/ClickHouse/issues/101831). [#105284](https://github.com/ClickHouse/ClickHouse/pull/105284) ([Groene AI](https://github.com/groeneai)).
* Fix a logical error `Mutation of `Memory` table produced incomplete output` raised when running `ALTER TABLE <memory_table> APPLY PATCHES` or `ALTER TABLE <memory_table> APPLY DELETED MASK`. `Memory` tables do not own patch parts or deletion masks, so both commands are now correctly treated as no-ops. [#105286](https://github.com/ClickHouse/ClickHouse/pull/105286) ([Groene AI](https://github.com/groeneai)).
* Fix long-running queries with Unity Catalog by passing a `table_id` parameter in the query request. [#105303](https://github.com/ClickHouse/ClickHouse/pull/105303) ([Konstantin Vedernikov](https://github.com/scanhex12)).
* Fix `CANNOT_CONVERT_TYPE` for `Merge` over `Merge` over `Distributed` with `distributed_group_by_no_merge=1`. [#105330](https://github.com/ClickHouse/ClickHouse/pull/105330) ([Azat Khuzhin](https://github.com/azat)).
* Fix `clickhouse local` and `clickhouse client` silently ignoring `--query`/`-q` when a positional file argument was also given. Both forms now produce `BAD_ARGUMENTS` consistently. [#105334](https://github.com/ClickHouse/ClickHouse/pull/105334) ([Raúl Marín](https://github.com/Algunenano)).
* Fix `REPLACE TEMPORARY TABLE` silently creating a new table when the target didn't exist. It now throws `UNKNOWN_TABLE`, matching `REPLACE TABLE` semantics. Use `CREATE OR REPLACE TEMPORARY TABLE` to keep the create-or-replace behavior. [#105373](https://github.com/ClickHouse/ClickHouse/pull/105373) ([Groene AI](https://github.com/groeneai)).
* Fixed long-running reads (e.g. `INSERT ... SELECT`) from a `DataLakeCatalog` database with `catalog_type = 'glue'` failing with an `ExpiredToken` error once the STS session credentials captured at table-metadata load time crossed their expiry. The AWS STS credentials are now refreshed mid-query, so such reads continue past the token's expiry. [#105381](https://github.com/ClickHouse/ClickHouse/pull/105381) ([Pratima Patel](https://github.com/pratimapatel2008)).
* Fix logical error in negative `LIMIT BY` in some cases when used with `ARRAY JOIN`. [#105403](https://github.com/ClickHouse/ClickHouse/pull/105403) ([Nihal Z. Miaji](https://github.com/nihalzp)).
* Fix inflated `read_bytes` (and the derived bytes/s shown in `system.query_log`, progress bar, etc.) when reading Parquet files. The previous implementation reported the row group's total compressed size on every chunk, so reading K of N columns overcounted by `N / K`. It is now summed only across the selected columns. Also fixes file-level progress tracking for Iceberg tables, which previously never reported the data file size. [#105413](https://github.com/ClickHouse/ClickHouse/pull/105413) ([Groene AI](https://github.com/groeneai)).
* Fixed a possible server segfault in cluster table functions (`s3Cluster`, `urlCluster`, `fileCluster`, ...) when the planner produces a `SELECT` with the `recursive_with` flag set but no `WITH` expression. Closes [#105370](https://github.com/ClickHouse/ClickHouse/issues/105370). [#105433](https://github.com/ClickHouse/ClickHouse/pull/105433) ([Groene AI](https://github.com/groeneai)).
* Fix wrong result of `countDistinct` / `uniqExact` on `Nullable` columns when `count_distinct_optimization = 1` (the NULL group was incorrectly counted). [#105439](https://github.com/ClickHouse/ClickHouse/pull/105439) ([Raúl Marín](https://github.com/Algunenano)).
* Fixed a heap-buffer-overflow when reading Arrow or ArrowStream files with corrupted intermediate offsets in a binary or string column, and a null-pointer dereference when reading geo-tagged Arrow columns. [#105449](https://github.com/ClickHouse/ClickHouse/pull/105449) ([Raúl Marín](https://github.com/Algunenano)).
* Validate `Dynamic`/`Variant` types in window `PARTITION BY`, it was not checked before when `allow_suspicious_types_in_group_by` is disabled. Closes [#105028](https://github.com/ClickHouse/ClickHouse/issues/105028). [#105450](https://github.com/ClickHouse/ClickHouse/pull/105450) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix `input_format_json_empty_as_default` not working in JSONStrings* formats. Closes [#104913](https://github.com/ClickHouse/ClickHouse/issues/104913). [#105453](https://github.com/ClickHouse/ClickHouse/pull/105453) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix `NULL` insert into `Variant` column via `VALUES` format during expression parsing. Closes [#104909](https://github.com/ClickHouse/ClickHouse/issues/104909). [#105455](https://github.com/ClickHouse/ClickHouse/pull/105455) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix `dictGetOrDefault` throwing `CANNOT_INSERT_NULL_IN_ORDINARY_COLUMN` when the default argument is a `Nullable` expression and `short_circuit_function_evaluation` is enabled with a mix of found and not-found dictionary keys. [#105461](https://github.com/ClickHouse/ClickHouse/pull/105461) ([Raúl Marín](https://github.com/Algunenano)).
* Fix silent value truncation in `Dynamic` columns when the `Quoted` (Values) text reader falls back to `String` for incomplete inferred types like `Map(Array(Nothing), ...)`. Previously the fallback wrapped the raw field with naive `'...'` concatenation, so an inner single quote (always present for such fallbacks) prematurely terminated the quoted string and the rest of the value was lost. [#105463](https://github.com/ClickHouse/ClickHouse/pull/105463) ([Groene AI](https://github.com/groeneai)).
* Fix SIGSEGV when reading `Dynamic` subcolumns from compressed `Memory` table after `ALTER`. Closes [#104901](https://github.com/ClickHouse/ClickHouse/issues/104901). [#105464](https://github.com/ClickHouse/ClickHouse/pull/105464) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix `toFloat64`/`toUInt32`/`toString`/etc. on `Dynamic` ignoring `cast_keep_nullable`. Closes [#104789](https://github.com/ClickHouse/ClickHouse/issues/104789). [#105467](https://github.com/ClickHouse/ClickHouse/pull/105467) ([Pavel Kruglov](https://github.com/Avogar)).
* Include `skip_first_lines` in schema cache key for `WithNames` formats. Closes [#104527](https://github.com/ClickHouse/ClickHouse/issues/104527). [#105469](https://github.com/ClickHouse/ClickHouse/pull/105469) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix a server segfault in `uniqStateOrNull` / `uniqStateOrDefault` / `uniqOrNullState` (and similar combinator chains over `uniq`) when used with `GROUP BY ... WITH ROLLUP`, `WITH CUBE`, or `WITH TOTALS` and a Nullable argument. [#105470](https://github.com/ClickHouse/ClickHouse/pull/105470) ([Groene AI](https://github.com/groeneai)).
* Fix `NOT_FOUND_COLUMN_IN_BLOCK` exception when combining `ORDER BY ... WITH FILL INTERPOLATE` and `LIMIT N BY` with the analyzer enabled. Closes [#103474](https://github.com/ClickHouse/ClickHouse/issues/103474). [#105481](https://github.com/ClickHouse/ClickHouse/pull/105481) ([Yakov Olkhovskiy](https://github.com/yakov-olkhovskiy)).
* Fix `toStartOfMillisecond` and `toStartOfMicrosecond` returning a result off by nearly a second for negative (pre-epoch) `DateTime64` values, and fix `UndefinedBehaviorSanitizer` signed-integer-overflow in `toStartOfSecond`, `toStartOfMillisecond`, and `toStartOfMicrosecond` for `DateTime64` inputs near `INT64_MIN`. [#105482](https://github.com/ClickHouse/ClickHouse/pull/105482) ([Groene AI](https://github.com/groeneai)).
* Add a new compatibility setting `analyzer_compatibility_prefer_alias_over_subcolumn` (disabled by default). When enabled, the new analyzer prefers the alias-prefix interpretation over `Tuple`-subcolumn / dotted-column matches for multi-part identifiers, restoring the previous interpreter's behavior. This avoids `AMBIGUOUS_IDENTIFIER` (and related) errors when a query joins a table whose name matches an inner table of a CTE/subquery that uses `SELECT *` over a join, where asterisk-renamed columns (e.g. `b.id`) would otherwise leak the inner table identifiers into the outer scope. [#105491](https://github.com/ClickHouse/ClickHouse/pull/105491) ([Vladimir Cherkasov](https://github.com/vdimir)).
* A vector search query executed with the _index only_ optimization now returns the correct value for `L2Distance()` if it is in the `SELECT` list. The function was incorrectly returning the _L2-squared_ distance value. Note that the vector search query was returning the correctly ranked results, only applications **explicitly retrieving and interpreting** the `L2Distance()` value would have seen the squared value. [#105495](https://github.com/ClickHouse/ClickHouse/pull/105495) ([Shankar Iyer](https://github.com/shankar-iyer)).
* Fixed a rare issue in new Kafka table engine where messages could be incorrectly handled during topic partition reassignment, potentially leading to skipped messages after offset rollback. [#105500](https://github.com/ClickHouse/ClickHouse/pull/105500) ([János Benjamin Antal](https://github.com/antaljanosbenjamin)).
* Fix an exception (`Trying to execute PLACEHOLDER action` logical error) when a `MATERIALIZED` CTE whose body is a correlated subquery is used as the right-hand side of `IN`. Such a CTE is now rejected at analysis time, consistent with how the same pattern is already rejected when the CTE is referenced directly in `FROM`. [#105518](https://github.com/ClickHouse/ClickHouse/pull/105518) ([Groene AI](https://github.com/groeneai)).
* Fix stdout/stdin compression not applied when format is explicitly specified. Closes [#104441](https://github.com/ClickHouse/ClickHouse/issues/104441). [#105528](https://github.com/ClickHouse/ClickHouse/pull/105528) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix SEGFAULT in `singleValueOrNull` deserialization for `JSON` type. Closes [#103630](https://github.com/ClickHouse/ClickHouse/issues/103630). [#105535](https://github.com/ClickHouse/ClickHouse/pull/105535) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix `clickhouse-format --backslash` silently dropping `INSERT` `VALUES` data. Closes [#103533](https://github.com/ClickHouse/ClickHouse/issues/103533). [#105536](https://github.com/ClickHouse/ClickHouse/pull/105536) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix `variant_throw_on_type_mismatch/dynamic_throw_on_type_mismatch=false` not catching exceptions during function execution. Closes [#103484](https://github.com/ClickHouse/ClickHouse/issues/103484). [#105543](https://github.com/ClickHouse/ClickHouse/pull/105543) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix ignoring `input_format_try_infer_datetimes` during insertion into shared data in `JSON`. Closes [#103221](https://github.com/ClickHouse/ClickHouse/issues/103221). [#105544](https://github.com/ClickHouse/ClickHouse/pull/105544) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix `histogram` producing wrong results for small unsorted inputs. Closes [#103109](https://github.com/ClickHouse/ClickHouse/issues/103109). [#105548](https://github.com/ClickHouse/ClickHouse/pull/105548) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix `DateTime` wrapping around for out-of-range values in `JSONExtract` and text deserializations. Closes [#103094](https://github.com/ClickHouse/ClickHouse/issues/103094). [#105551](https://github.com/ClickHouse/ClickHouse/pull/105551) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix usage of insertion table in table functions when `optimize_trivial_insert_select` is enabled. Closes [#103083](https://github.com/ClickHouse/ClickHouse/issues/103083). [#105555](https://github.com/ClickHouse/ClickHouse/pull/105555) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix `CASE` expression returning the `ELSE` branch instead of the matching `THEN` when both the expression and a `WHEN` value were `NULL`. [#105556](https://github.com/ClickHouse/ClickHouse/pull/105556) ([Raúl Marín](https://github.com/Algunenano)).
* Fixed a crash in `replxx` caused by hitting the `FD_SETSIZE` limitation of `select` (now replaced with `poll`). Previously, with SSH or the web terminal enabled, this could crash the server. [#105559](https://github.com/ClickHouse/ClickHouse/pull/105559) ([Azat Khuzhin](https://github.com/azat)).
* Materialize subcolumns in `executePartitionByExpression` before executing expression. Closes [#103057](https://github.com/ClickHouse/ClickHouse/issues/103057). [#105573](https://github.com/ClickHouse/ClickHouse/pull/105573) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix `NOT_FOUND_COLUMN_IN_BLOCK` exception when `TTL` expression references a subcolumn. [#105578](https://github.com/ClickHouse/ClickHouse/pull/105578) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix a server crash (SIGSEGV) reachable by any user with `CREATE TABLE` rights when sending `CREATE TABLE ... TO INNER UUID '...'` without an `ENGINE` clause over HTTP or the native protocol. The same bug also crashed the client. The parser now reports a proper `BAD_ARGUMENTS` error instead of dereferencing a null pointer. [#105579](https://github.com/ClickHouse/ClickHouse/pull/105579) ([Groene AI](https://github.com/groeneai)).
* Fix `estimateCompressionRatio` window function losing accumulated data between rows. Closes [#101738](https://github.com/ClickHouse/ClickHouse/issues/101738). [#105581](https://github.com/ClickHouse/ClickHouse/pull/105581) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix crash when inserting tuples of different sizes in the same VALUES clause into a `String` column. Closes [#101727](https://github.com/ClickHouse/ClickHouse/issues/101727). [#105582](https://github.com/ClickHouse/ClickHouse/pull/105582) ([Pavel Kruglov](https://github.com/Avogar)).
* Hive partition value extraction now honors the `cast_string_to_date_time_mode` setting and accepts ISO 8601 timestamps with timezone suffixes (e.g. `+0000`, `+00:00`, `Z`) in partition keys by default. [#105584](https://github.com/ClickHouse/ClickHouse/pull/105584) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fixes `NOT_IMPLEMENTED` error on `toString` from `DateTime` with Timezone containing `NULL` value. Closes [#103712](https://github.com/ClickHouse/ClickHouse/issues/103712). [#105587](https://github.com/ClickHouse/ClickHouse/pull/105587) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* Fix OOB read in flattened `Dynamic` column `Native` deserialization. [#105666](https://github.com/ClickHouse/ClickHouse/pull/105666) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix a `LOGICAL_ERROR` (`Unexpected return type from if`) raised during query planning for `if` expressions whose result type is `Variant` and whose second-or-third branch is a constant-condition `if` over a `UInt64` literal that fits into `Int64`. Closes [#105649](https://github.com/ClickHouse/ClickHouse/issues/105649). [#105680](https://github.com/ClickHouse/ClickHouse/pull/105680) ([Groene AI](https://github.com/groeneai)).
* Fix wrong results when reading an Iceberg table with `iceberg_use_version_hint = 1` after another writer (such as the `icebergLocal`/`icebergS3` table function) without the setting advances the table. `version-hint.text` is now kept in sync by every writer once the file exists, so subsequent readers using the hint see the latest snapshot. [#105682](https://github.com/ClickHouse/ClickHouse/pull/105682) ([Groene AI](https://github.com/groeneai)).
* Fixed a silent under-count in `SELECT` queries when `use_query_condition_cache = 1` (default). A query of the shape `PREWHERE pk_prefix = X WHERE non_pk IN (...)` against a column with a bloom-filter skip index poisoned the `QueryConditionCache` for the `pk_prefix = X` predicate, so a subsequent benign `SELECT count() ... WHERE pk_prefix = X` returned an incorrect, under-counted result. Affected all 26.x releases. [#104781](https://github.com/ClickHouse/ClickHouse/issues/104781). [#105686](https://github.com/ClickHouse/ClickHouse/pull/105686) ([Groene AI](https://github.com/groeneai)).
* Fixed `singleValueOrNullMerge` returning a concrete value instead of `NULL` when merging a state that had already observed multiple distinct values. [#105734](https://github.com/ClickHouse/ClickHouse/pull/105734) ([Minh Vu](https://github.com/fallintoplace)).
* Fix `Template` input format error recovery after malformed rows. [#105735](https://github.com/ClickHouse/ClickHouse/pull/105735) ([Yue Ni](https://github.com/niyue)).
* Fix a crash in the `mongodb` table function, MongoDB storage and MongoDB dictionary source when the collection name is empty or contains NUL bytes. [#105776](https://github.com/ClickHouse/ClickHouse/pull/105776) ([Raúl Marín](https://github.com/Algunenano)).
* Fix `Keeper` snapshot cleanup after failed writes so partial snapshots are cleaned up safely and failed writes can be retried without advancing `latest_snapshot_meta`. [#105779](https://github.com/ClickHouse/ClickHouse/pull/105779) ([Antonio Andelic](https://github.com/antonio2368)).
* Fix `ALTER TABLE ... CLEAR COLUMN` being rejected for explicit `SummingMergeTree` and `CoalescingMergeTree` `columns_to_sum` columns. [#105785](https://github.com/ClickHouse/ClickHouse/pull/105785) ([Antonio Andelic](https://github.com/antonio2368)).
* Fixed an assertion in `DatabaseCatalog::tryGetDatabase` (and resulting `UNKNOWN_DATABASE` error in release builds) when creating a parameterized view whose database name is supplied via a query parameter, for example `CREATE VIEW {db:Identifier}.v AS SELECT {p:UInt64}`. Parameters in the DDL parts of the `CREATE` statement are now substituted at create time, while parameters in the SELECT body remain available for substitution at view-call time. [#105799](https://github.com/ClickHouse/ClickHouse/pull/105799) ([Groene AI](https://github.com/groeneai)).
* Fix `Bad get: has Decimal32, requested Decimal128` from `sumMap` and `sumMapWithOverflow` over a `Nested(... Nullable(Decimal(P, S)))` column when the aggregate state is serialised (e.g. parallel replicas, `sumMapState` via a binary-state formatter, external aggregation). [#105816](https://github.com/ClickHouse/ClickHouse/pull/105816) ([Groene AI](https://github.com/groeneai)).
* Fix `Expected ColumnLowCardinality, got String` / `Bad cast from type DB::ColumnString to DB::ColumnLowCardinality` errors when `apply_mutations_on_fly = 1` is used on a table with pending on-fly `UPDATE`/`DELETE` mutations queued before an `ALTER MODIFY COLUMN ... LowCardinality(...)` mutation. [#105847](https://github.com/ClickHouse/ClickHouse/pull/105847) ([Raúl Marín](https://github.com/Algunenano)).
* Iceberg writes now preserve NULL values in `Nullable(T)` partition columns. Previously, a NULL written by ClickHouse showed up as the default value of the inner type (`0` for `int`) when read back by Spark or other Iceberg readers. Closes [#105852](https://github.com/ClickHouse/ClickHouse/issues/105852). [#105862](https://github.com/ClickHouse/ClickHouse/pull/105862) ([Groene AI](https://github.com/groeneai)).
* Fixed `Parquet` and `ORC` filter pushdown for `IN (subquery)` predicates, allowing row-group/page/bloom-filter pruning to work for `file`, `url`, `s3`, and object-storage reads. [#105863](https://github.com/ClickHouse/ClickHouse/pull/105863) ([Arsen Muk](https://github.com/arsenmuk)).
* Fix read-in-order for `Merge` tables (with a new analyzer). [#105867](https://github.com/ClickHouse/ClickHouse/pull/105867) ([Nikolai Kochetov](https://github.com/KochetovNicolai)).
* Fixed Iceberg v2 merge-on-read position deletes returning wrong rows when a single delete file references multiple data files and several such delete files apply to the same data file. The streaming reader (`use_roaring_bitmap_iceberg_positional_deletes = 0`) now filters delete-file rows by `file_path` in C++ instead of relying on Parquet row-group pruning, restoring the ascending-positions invariant. [#105888](https://github.com/ClickHouse/ClickHouse/pull/105888) ([Groene AI](https://github.com/groeneai)).
* Fix `Cannot find column` error for distributed queries with `IN Array(...)` filter for the new analyzer. [#105894](https://github.com/ClickHouse/ClickHouse/pull/105894) ([Nikolai Kochetov](https://github.com/KochetovNicolai)).
* Fix a SIGSEGV in `ALTER TABLE ... MODIFY COLUMN ... Nullable(...)` on `MergeTree` tables when a column with `STATISTICS` is concurrently dropped by another `ALTER`. Closes [#105912](https://github.com/ClickHouse/ClickHouse/issues/105912). [#105917](https://github.com/ClickHouse/ClickHouse/pull/105917) ([Groene AI](https://github.com/groeneai)).
* Fixed a server crash that could occur when a query reading from PostgreSQL — via the postgresql table function, the PostgreSQL table engine, or a dictionary with a PostgreSQL source — was cancelled (for example with KILL QUERY) and cancelling the remote PostgreSQL query failed. [#105949](https://github.com/ClickHouse/ClickHouse/pull/105949) ([Rory Shanks](https://github.com/rorylshanks)).
* Fix `SYSTEM INSTRUMENT ADD` formatting so handler arguments are separated by a single space, and reject invalid `SLEEP` instrumentation argument lists with more than two values or a range where the minimum is greater than the maximum. [#105984](https://github.com/ClickHouse/ClickHouse/pull/105984) ([Pablo Marcos](https://github.com/pamarcos)).
* Fix possibly wrong results for queries that combine an outer join with a subsequent inner join referencing the outer join's null-supplying side. Join reordering could pick a plan that pulled inner-join conditions into the outer join's ON clause. [#105992](https://github.com/ClickHouse/ClickHouse/pull/105992) ([Vladimir Cherkasov](https://github.com/vdimir)).
* Fixed a possible crash due to a too-large string literal sent within the query. [#105996](https://github.com/ClickHouse/ClickHouse/pull/105996) ([Nikita Taranov](https://github.com/nickitat)).
* Fix `INVALID_WITH_FILL_EXPRESSION` exception when using `INTERPOLATE ()` (empty) with a sorting prefix in `ORDER BY` and `use_with_fill_by_sorting_prefix` enabled. Sorting prefix columns are now correctly excluded from the implicit interpolation set, matching the behavior of explicitly named `INTERPOLATE (col)`. [#106001](https://github.com/ClickHouse/ClickHouse/pull/106001) ([Yakov Olkhovskiy](https://github.com/yakov-olkhovskiy)).
* Fix `ALTER TABLE` partition operations silently failing for `Bool` partition keys. Closes [#101722](https://github.com/ClickHouse/ClickHouse/issues/101722). [#106004](https://github.com/ClickHouse/ClickHouse/pull/106004) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix `JSONExtractRaw` and `JSONHas` for typed `JSON` paths with default values. Closes [#101721](https://github.com/ClickHouse/ClickHouse/issues/101721). [#106005](https://github.com/ClickHouse/ClickHouse/pull/106005) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix incorrect '/'-prefix addition on empty basepaths in data lake configurations. Closes [#105989](https://github.com/ClickHouse/ClickHouse/issues/105989). [#106013](https://github.com/ClickHouse/ClickHouse/pull/106013) ([thewisenerd](https://github.com/thewisenerd)).
* Fix `IcebergLocal` table engine becoming read-only after a `DETACH` + `ATTACH` cycle or a server restart, which made every subsequent `INSERT` fail with `Local object storage Local is readonly. (READONLY)`. [#106016](https://github.com/ClickHouse/ClickHouse/pull/106016) ([Groene AI](https://github.com/groeneai)).
* Fix `Keeper` failures during follower catch-up when the new request dispatcher response queue could fill before the response thread started. [#106049](https://github.com/ClickHouse/ClickHouse/pull/106049) ([Antonio Andelic](https://github.com/antonio2368)).
* Better compatibility with the old analyzer. If the table has columns like `x.a Array, x.b Array, x String`, prefer arrays for `ARRAY JOIN x`. [#106069](https://github.com/ClickHouse/ClickHouse/pull/106069) ([Nikolai Kochetov](https://github.com/KochetovNicolai)).
* Fixed the filesystem cache being silently disabled for Azure Blob Storage (e.g. Delta Lake tables over Azure) because object metadata did not include the blob ETag. [#106091](https://github.com/ClickHouse/ClickHouse/pull/106091) ([thewisenerd](https://github.com/thewisenerd)).
* Fix `system.dictionaries` returning 0 rows with partial `SHOW DICTIONARIES` revoke. [#106105](https://github.com/ClickHouse/ClickHouse/pull/106105) ([Pavel Kruglov](https://github.com/Avogar)).
* Fixed a server crash when querying DeltaLake tables with `allow_experimental_delta_kernel_rs` enabled and a credential or option that contained invalid bytes (the Rust FFI panicked across the `extern "C"` boundary). [#106109](https://github.com/ClickHouse/ClickHouse/pull/106109) ([Raúl Marín](https://github.com/Algunenano)).
* Fix incorrect results for queries against tables whose `ORDER BY` contains a monotonically decreasing function such as `(c0 / -42)` or `intDiv(c0, -42)`. Predicates on the underlying column (for example, `c0 < 0`) could wrongly prune granules that contained matching rows, producing missing results. Closes [#106084](https://github.com/ClickHouse/ClickHouse/issues/106084). Closes [#106124](https://github.com/ClickHouse/ClickHouse/issues/106124). Closes [#106080](https://github.com/ClickHouse/ClickHouse/issues/106080). [#106136](https://github.com/ClickHouse/ClickHouse/pull/106136) ([Nihal Z. Miaji](https://github.com/nihalzp)).
* Fix support for using `WASM` SQL UDFs in `MATERIALIZED VIEW` definitions. [#106161](https://github.com/ClickHouse/ClickHouse/pull/106161) ([Yue Ni](https://github.com/niyue)).
* Iceberg partition pruning now correctly handles `WHERE partition_col = (SELECT ... FROM ...)` filters where the analyzer wraps the scalar subquery result in an internal `_CAST(Const, 'TargetType')` with matching source and target types. Previously such filters disabled partition pruning and triggered a full table scan. [#106204](https://github.com/ClickHouse/ClickHouse/pull/106204) ([Groene AI](https://github.com/groeneai)).
* Fix clickhouse local's `--query_id` parameter to allow it to specify custom query id. [#106205](https://github.com/ClickHouse/ClickHouse/pull/106205) ([Yue Ni](https://github.com/niyue)).
* Fixed the S3 storage class (`s3_storage_class` / `s3_storage_class_name`) being ignored for objects written via multipart upload on `S3` disks and object storage, which caused large objects to be created with the default `STANDARD` class. The option name is now accepted both as `s3_storage_class` and `s3_storage_class_name` for disks, object storage and backups. [#106214](https://github.com/ClickHouse/ClickHouse/pull/106214) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fixed Keeper sometimes getting stuck on startup when setting `nuraft_max_log_gap_in_stream` is set to non-default value (default is 0, i.e. disable pipelining of `append_entries` requests). [#106220](https://github.com/ClickHouse/ClickHouse/pull/106220) ([Michael Kolupaev](https://github.com/al13n321)).
* Validate corrupted `DDSketch` aggregate-function state (bin keys) on insertion instead of accepting malformed data. [#106236](https://github.com/ClickHouse/ClickHouse/pull/106236) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* Fixed coordinator mode mismatch when subqueries override in-order settings. [#106243](https://github.com/ClickHouse/ClickHouse/pull/106243) ([Nikita Taranov](https://github.com/nickitat)).
* Fix `optimize_skip_unused_shards` did not apply (and `force_optimize_skip_unused_shards` falsely failing) when a `Distributed` table is queried through a `Merge` table or the `merge` table function, with the predicate applied above it. [#106250](https://github.com/ClickHouse/ClickHouse/pull/106250) ([Nikolai Kochetov](https://github.com/KochetovNicolai)).
* Fix `INTERPOLATE ()` throwing `INVALID_WITH_FILL_EXPRESSION` when `ORDER BY` columns are aliased in the `SELECT` list with the old analyzer. Closes [#106248](https://github.com/ClickHouse/ClickHouse/issues/106248). [#106252](https://github.com/ClickHouse/ClickHouse/pull/106252) ([Yakov Olkhovskiy](https://github.com/yakov-olkhovskiy)).
* Fixed an abort when deserialising a malformed `AggregateFunction(uniqTheta, ...)` state from `RowBinary` input or a query parameter. The bad input is now rejected with `CORRUPTED_DATA` instead of escaping as a `std::exception` and aborting the process via `abortOnFailedAssertion`. [#106260](https://github.com/ClickHouse/ClickHouse/pull/106260) ([Groene AI](https://github.com/groeneai)).
* Reject out-of-range `IntervalKind` bytes during `RowBinaryWithNamesAndTypes` type decoding (`input_format_binary_decode_types_in_binary_format = 1`) with a clear `INCORRECT_DATA` error instead of constructing a `DataTypeInterval` with an invalid kind that could subsequently trip undefined behavior in hash paths. [#106261](https://github.com/ClickHouse/ClickHouse/pull/106261) ([Groene AI](https://github.com/groeneai)).
* Fix `SLRU` downgrade failure rollback issue in `26.1+`. Fix `System`/`Data` cache split priority with `keep_free_space_ratio` feature. [#106286](https://github.com/ClickHouse/ClickHouse/pull/106286) ([Kseniia Sumarokova](https://github.com/kssenii)).
* Read the `null` subcolumn as a `JSON` path in `Nullable(JSON)` instead of the null-map. Closes [#106085](https://github.com/ClickHouse/ClickHouse/issues/106085). [#106295](https://github.com/ClickHouse/ClickHouse/pull/106295) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix `RestCatalog::empty` returning the wrong result when an Iceberg REST catalog contains tables. [#106301](https://github.com/ClickHouse/ClickHouse/pull/106301) ([Lefteris](https://github.com/LefterisXefteris)).
* Fixed an exception for `INNER JOIN` queries with an empty left `MergeTree` table when `enable_parallel_replicas`, `query_plan_use_new_logical_join_step`, and `query_plan_optimize_join_order_algorithm = 'greedy'` are enabled. [#106338](https://github.com/ClickHouse/ClickHouse/pull/106338) ([Nikolai Kochetov](https://github.com/KochetovNicolai)).
* Fixed an incorrect conversion of subnormal `Float16` values to `Float32` (e.g. when reading them from Numpy `.npy` files), caused by an off-by-one mantissa shift. [#106343](https://github.com/ClickHouse/ClickHouse/pull/106343) ([Joanna Hulboj](https://github.com/jh0x)).
* Fix a crash and a possible `NOT_FOUND_COLUMN_IN_BLOCK` error when constraint-based optimization (`optimize_using_constraints`) is used with correlated subqueries. [#106349](https://github.com/ClickHouse/ClickHouse/pull/106349) ([Raúl Marín](https://github.com/Algunenano)).
* Fixed an out-of-bounds read in `sipHash64Keyed`, `sipHash128Keyed` and `sipHash128ReferenceKeyed` when hashing a column whose arrays are all empty and the key is not constant. [#106355](https://github.com/ClickHouse/ClickHouse/pull/106355) ([Raúl Marín](https://github.com/Algunenano)).
* Fixed `SYSTEM RELOAD CONFIG` discarding per-endpoint Azure Blob Storage settings (such as `use_native_copy`), which caused a disk's configured settings to be ignored for `BACKUP`/`RESTORE` until the server was restarted. [#106357](https://github.com/ClickHouse/ClickHouse/pull/106357) ([Julia Kartseva](https://github.com/jkartseva)).
* Fix `regexpExtract(haystack, pattern)` so that patterns without a capturing group return the whole match instead of throwing `INDEX_OF_POSITIONAL_ARGUMENT_IS_OUT_OF_RANGE`. [#106374](https://github.com/ClickHouse/ClickHouse/pull/106374) ([Groene AI](https://github.com/groeneai)).
* Fix `LOGICAL_ERROR` exception during cache predownload when a remote S3 object is overwritten with shorter content between listing and reading. [#106375](https://github.com/ClickHouse/ClickHouse/pull/106375) ([Nikita Fomichev](https://github.com/fm4v)).
* Fix memory usage growth in filesystem cache. [#106387](https://github.com/ClickHouse/ClickHouse/pull/106387) ([Kseniia Sumarokova](https://github.com/kssenii)).
* Fix multiple heap out-of-bounds reads in the Arrow IPC format reader (`ArrowColumnToCHColumn`). A malformed Arrow file could declare more rows than its buffers contain, declare list/struct/map child lengths inconsistent with their parent, supply non-monotonic list offsets, or truncate a child validity bitmap, causing reads past the end of heap allocations. This is reachable by any user with `SELECT` privilege via `file()`, `format()`, table functions, or ArrowFlight inputs. All data, offsets, view-struct, and validity-bitmap buffers are now validated before any raw pointer access, and list/struct/map shapes and offsets are checked for consistency. [#106395](https://github.com/ClickHouse/ClickHouse/pull/106395) ([Raúl Marín](https://github.com/Algunenano)).
* Fixed backups failing with `FILE_DOESNT_EXIST` when a refreshable materialized view's REPLACE target is collected on a Replicated or Shared database whose materialized view isn't yet instantiated on the backup-initiating replica. [#106411](https://github.com/ClickHouse/ClickHouse/pull/106411) ([Julia Kartseva](https://github.com/jkartseva)).
* Fix a logical error `Column identifier ... is already registered` when a mutation (`DELETE`/`UPDATE`) predicate contains an `IN`/`EXISTS` subquery that reads from a default table expression nested in another subquery. [#106414](https://github.com/ClickHouse/ClickHouse/pull/106414) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix a logical error (`Left and right columns have same names`) in the join order optimizer that could occur for joins executed with parallel replicas when two relations in the join graph share column names. [#106418](https://github.com/ClickHouse/ClickHouse/pull/106418) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix a logical error when building a polygon dictionary from source data containing `NaN` or infinite point coordinates. Such coordinates are now rejected with a clear error. [#106423](https://github.com/ClickHouse/ClickHouse/pull/106423) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fixed a bug where the `used_privileges` and `missing_privileges` columns of `system.query_log` could contain privilege strings leaked from unrelated earlier queries of a different user, database, or session. [#106425](https://github.com/ClickHouse/ClickHouse/pull/106425) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Functions `base58Encode`, `base58Decode` and `tryBase58Decode` now respect `max_execution_time` and query cancellation on large inputs, and reject inputs larger than 10 KB instead of running for a very long time. The limit is configurable via the new setting `function_base58_max_input_size` (`0` disables it). [#106428](https://github.com/ClickHouse/ClickHouse/pull/106428) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix sporadic incorrect results for `ORDER BY ... DESC` queries when reading wide parts in reverse order with `read_in_order_use_virtual_row_per_block = 1` and a small `max_block_size`. [#106429](https://github.com/ClickHouse/ClickHouse/pull/106429) ([Vladimir Cherkasov](https://github.com/vdimir)).
* Fixed a `NOT_FOUND_COLUMN_IN_BLOCK` exception when querying an Iceberg or S3 table with a compound `WHERE` containing `IS NOT NULL` on a column that is not in the `SELECT` list, using the Parquet V3 native reader. [#106443](https://github.com/ClickHouse/ClickHouse/pull/106443) ([Shaohua Wang](https://github.com/tiandiwonder)).
* Allows user to specify headers for `HTTPDictionary` using named collections. [#106459](https://github.com/ClickHouse/ClickHouse/pull/106459) ([Jan Rada](https://github.com/ZelvaMan)).
* Fix a case where a worker thread could stay attached to a stale thread group after `CurrentThread::attachToGroup` failed part way through, causing later tasks on the same thread to fail with `Thread is already attached to a group`. [#106462](https://github.com/ClickHouse/ClickHouse/pull/106462) ([Mikhail f. Shiryaev](https://github.com/Felixoid)).
* Fixed an exception when a vector search query uses a vector index and uses another skip index like `minmax` and `use_skip_indexes_on_data_read = 1`. [#106473](https://github.com/ClickHouse/ClickHouse/pull/106473) ([Shankar Iyer](https://github.com/shankar-iyer)).
* Malformed `Avro` enum values are now validated and rejected with an error instead of causing an out-of-bounds read and abort when deserializing corrupted `Avro` data. [#106476](https://github.com/ClickHouse/ClickHouse/pull/106476) ([Miсhael Stetsyuk](https://github.com/mstetsyuk)).
* Fix inflated progress reporting when reading from Iceberg tables with `_file` or `_path` filters. Previously, `total_bytes_to_read` progress included all files from the manifest regardless of filtering. [#106491](https://github.com/ClickHouse/ClickHouse/pull/106491) ([Pedro Ferreira](https://github.com/PedroTadim)).
* Fixed a `Bad cast exception` for Redis dictionaries that use `STORAGE_TYPE 'simple'` with a `cache`/`direct` layout and a single string (complex) key; such dictionaries now work, and composite keys over `simple` storage report a clear error. [#106501](https://github.com/ClickHouse/ClickHouse/pull/106501) ([Vladimir Cherkasov](https://github.com/vdimir)).
* Fix wrong-results bug where `WHERE c0 = const` returned no rows for tables with `ORDER BY f(c0)` when `f(const)` evaluates to NaN, e.g. `ORDER BY sqrt(c0)` with a negative constant. The primary-key analysis incorrectly pruned every granule and poisoned the query condition cache for subsequent queries. [#106507](https://github.com/ClickHouse/ClickHouse/pull/106507) ([Groene AI](https://github.com/groeneai)).
* Fix `LIMIT WITH TIES` and fractional `LIMIT WITH TIES` not respecting the collation from `ORDER BY ... COLLATE` when determining ties. Rows that are equal according to the collation (for example `'1'` and `'01'` under numeric collation) were compared byte-wise, so some tied rows were wrongly dropped from the result. [#106539](https://github.com/ClickHouse/ClickHouse/pull/106539) ([Nihal Z. Miaji](https://github.com/nihalzp)).
* Fix `DISTINCT` in order and `LIMIT BY` in order optimizations (including negative `LIMIT BY`) returning wrong results when the input is sorted with a collation (`ORDER BY ... COLLATE`). Rows that are equal according to the collation (for example `'a'` and `'A'` under a case-insensitive collation) are ordered by collation key and are not adjacent by value, so the in order optimization is now skipped when a collator is used. [#106564](https://github.com/ClickHouse/ClickHouse/pull/106564) ([Nihal Z. Miaji](https://github.com/nihalzp)).
* Fixed wrong results for `SELECT c, count() FROM t WHERE c GROUP BY c` against tables with the implicit `_minmax_count_projection`, an explicit aggregate projection, or a normal projection: every group used to collapse into one row with a constant key and the total row count. [#106590](https://github.com/ClickHouse/ClickHouse/pull/106590) ([Groene AI](https://github.com/groeneai)).
* Fixes a bug where users could not use scalar subqueries in the first argument of `IN` where the second argument is a non-constant tuple. [#106610](https://github.com/ClickHouse/ClickHouse/pull/106610) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* Fix exception `Mutation of `Memory` table produced incomplete output` raised when running `ALTER TABLE <memory_table>` commands that have no per-row data effect on a `Memory` engine, namely `APPLY PATCHES`, `APPLY DELETED MASK`, `MATERIALIZE STATISTICS`, `MATERIALIZE INDEX`, `MATERIALIZE PROJECTION`, and `REWRITE PARTS`. `Memory` tables do not own those structures, so such commands are now treated as no-ops. [#106621](https://github.com/ClickHouse/ClickHouse/pull/106621) ([Groene AI](https://github.com/groeneai)).
* Fix `session_timezone` being ignored when serializing `LowCardinality(DateTime)` columns to text formats (CSV, TSV, JSONEachRow, etc.). Previously, after the first write of a `LowCardinality(DateTime)` column on a server, every subsequent query that wrote such a column rendered the wall-clock string in whichever timezone was first seen, regardless of `session_timezone`. [#106634](https://github.com/ClickHouse/ClickHouse/pull/106634) ([Groene AI](https://github.com/groeneai)).
* Fixed a `LOGICAL_ERROR` "Trying to get name of not a column: `ExpressionList`" raised by queries that pass an asterisk inside `multiIf` to a table function argument, e.g. `numbers(multiIf(*, ...), 2)`. The query now rejects the unresolvable matcher with `UNSUPPORTED_METHOD`. [#106647](https://github.com/ClickHouse/ClickHouse/pull/106647) ([Groene AI](https://github.com/groeneai)).
* Fix server failing to start with `Too many marks in file ...skp_idx_idx.cmrk4, marks expected 0 (bytes size 0)` when a `MergeTree` table has a skip-index part with zero granules and a non-empty marks file on disk. [#106675](https://github.com/ClickHouse/ClickHouse/pull/106675) ([Groene AI](https://github.com/groeneai)).
* Reject pathological `file` glob patterns that would cause unbounded recursion in directory listing. A maximum recursion depth of 1000 is now enforced; queries that exceed it raise `TOO_DEEP_RECURSION` instead of crashing the server with a stack overflow. [#106676](https://github.com/ClickHouse/ClickHouse/pull/106676) ([Groene AI](https://github.com/groeneai)).
* Fix server abort `Bad cast from type DB::ColumnNothing to DB::ColumnVector<char8_t>` in `FunctionIf::executeForConstAndNullableCondition` when the `if`/`multiIf` condition constant-folds to `Const(Nullable(Nothing))` (for example, an out-of-range subscript on an empty array, like `arraySort(x -> x, [])[toNullable(1)]`). [#106678](https://github.com/ClickHouse/ClickHouse/pull/106678) ([Groene AI](https://github.com/groeneai)).
* Fix exception `'Trying to read from input() twice.'` raised when the table function `input` is wrapped in a non-MATERIALIZED CTE that is referenced from more than one place in the query. The query is now rejected with a clean `INVALID_USAGE_OF_INPUT` error at planning time. `input` is a one-shot client stream and can only be consumed by a single source in the query plan. [#106682](https://github.com/ClickHouse/ClickHouse/pull/106682) ([Groene AI](https://github.com/groeneai)).
* Make `FORMAT` apply to the `EXPLAIN` output of `EXPLAIN ... INSERT ... SELECT ... FORMAT ...` also when `SETTINGS` precede the `FORMAT` or the output format is `Values`. Follow-up to [#101772](https://github.com/ClickHouse/ClickHouse/issues/101772). [#106686](https://github.com/ClickHouse/ClickHouse/pull/106686) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fixed a rare spurious `RESOURCE_ACCESS_DENIED` error ("Scheduler queue with resource request is about to be destructed") for a query that was actually granted access to a workload resource, caused by a reused thread-local request object retaining a previous request's failure. [#106690](https://github.com/ClickHouse/ClickHouse/pull/106690) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix a race between destroying `INATSConsumer` objects and calling `INATSConsumer::onMsg` on them via callbacks in the NATS library. [#106692](https://github.com/ClickHouse/ClickHouse/pull/106692) ([Miсhael Stetsyuk](https://github.com/mstetsyuk)).
* Fixed `match`, `extract`, `extractAll` and `countMatches` returning wrong results for regular expressions containing hex or octal escapes. [#106709](https://github.com/ClickHouse/ClickHouse/pull/106709) ([ofeliacode](https://github.com/ofeliacode)).
* Keeper's internal Raft TLS now honors the `openSSL.client.verificationMode` setting. Previously peer certificate verification was always enabled for inter-Keeper Raft communication regardless of this setting, so `none` was silently ignored. Now `none` explicitly disables Raft peer-certificate verification, while an absent setting keeps the previous secure-by-default behavior. Configurations that explicitly set `none` will stop verifying Raft peer certificates after upgrade, matching the configured intent. [#106726](https://github.com/ClickHouse/ClickHouse/pull/106726) ([Antonio Andelic](https://github.com/antonio2368)).
* Fix logical error in startup scripts in `SYSTEM RELOAD CONFIG`. Additionally, load startup scripts on `SYSTEM RELOAD CONFIG` (currently private-only functionality). [#106727](https://github.com/ClickHouse/ClickHouse/pull/106727) ([Miсhael Stetsyuk](https://github.com/mstetsyuk)).
* Revert a change that made `sumMap` / the `-Map` combinator reject custom-named numeric value types (such as `SimpleAggregateFunction(sum, T)` and `Bool`) with `ILLEGAL_TYPE_OF_ARGUMENT: Values for -Map cannot be summed`, breaking previously-working aggregations. [#106729](https://github.com/ClickHouse/ClickHouse/pull/106729) ([Nikita Fomichev](https://github.com/fm4v)).
* Fixed multiple memory-safety and resource-exhaustion issues in format readers reachable from untrusted input: a heap out-of-bounds read in the native Parquet reader's `DataPageV2` definition/repetition level-length handling, a stack overflow on Parquet files with deeply nested schemas, and allocations that ignored `max_memory_usage` when parsing GeoParquet WKB/WKT geometry and Avro strings/bytes. [#106739](https://github.com/ClickHouse/ClickHouse/pull/106739) ([Raúl Marín](https://github.com/Algunenano)).
* Fixed a heap buffer overflow (server crash) in `decodeHTMLComponent` when decoding strings containing the expanding HTML entities `&nGt;` or `&nLt;`, reachable by any user with a single `SELECT`. [#106741](https://github.com/ClickHouse/ClickHouse/pull/106741) ([Raúl Marín](https://github.com/Algunenano)).
* Reject `CREATE TABLE`, `ALTER TABLE ADD INDEX`, and `CREATE INDEX` with `GRANULARITY 0` for skipping indexes with a clear `BAD_ARGUMENTS` error. Previously this triggered an `Inconsistent AST formatting` exception in debug builds. [#106783](https://github.com/ClickHouse/ClickHouse/pull/106783) ([Groene AI](https://github.com/groeneai)).
* Fixed Azure BACKUP/RESTORE ignoring endpoint settings for legacy-form `azure_blob_storage` disks. [#106784](https://github.com/ClickHouse/ClickHouse/pull/106784) ([Julia Kartseva](https://github.com/jkartseva)).
* Fixed a `Bad cast` exception while pruning parts by `MinMax` statistics when a key column is `LowCardinality` and the predicate constant is `LowCardinality(Nullable(...))`. [#106793](https://github.com/ClickHouse/ClickHouse/pull/106793) ([Groene AI](https://github.com/groeneai)).
* Fix inconsistent columns (that leads to `LOGICAL_ERROR` later) on exception (i.e. `MEMORY_LIMIT_EXCEEDED`) during parsing. [#106802](https://github.com/ClickHouse/ClickHouse/pull/106802) ([Azat Khuzhin](https://github.com/azat)).
* Fix after configuring `keeper_server.http_control.secure_port`, the server returned an HTTP response when making requests to HTTPS clients. [#106822](https://github.com/ClickHouse/ClickHouse/pull/106822) ([linjiayu1025-collab](https://github.com/linjiayu1025-collab)).
* Fix logical error in `parseDateTime` with non-ASCII input bytes. [#106856](https://github.com/ClickHouse/ClickHouse/pull/106856) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix `SHOW CREATE ROW POLICY` emitting `restrictive`/`permissive` in lowercase instead of uppercase, inconsistent with other keywords. [#106865](https://github.com/ClickHouse/ClickHouse/pull/106865) ([Valery Petrov](https://github.com/valerypetrov)).
* Fixes the case when parallel replicas wasn't applied for view with `UNION` due to empty table in the `UNION`. [#106900](https://github.com/ClickHouse/ClickHouse/pull/106900) ([Igor Nikonov](https://github.com/devcrafter)).
* Fix server crash (SIGSEGV) when reading truncated `Protobuf` data with `input_format_allow_errors_num > 0`. [#106905](https://github.com/ClickHouse/ClickHouse/pull/106905) ([Andrey Tsarevskiy | Андрей Царевский ](https://github.com/atsarevskiy)).
* Fix `THERE_IS_NO_COLUMN` exception for distributed queries involving `optimize_rewrite_aggregate_function_with_if` optimization when the aggregate function argument requires a cast to `Nullable` type. [#106908](https://github.com/ClickHouse/ClickHouse/pull/106908) ([Yakov Olkhovskiy](https://github.com/yakov-olkhovskiy)).
* Fix an exception (`LOGICAL_ERROR`) in the join runtime filter when the join key contains a `Variant` or `Dynamic` type nested inside a `Tuple`, `Array`, or `Map` and the right side of the join has a single distinct value. [#106931](https://github.com/ClickHouse/ClickHouse/pull/106931) ([Groene AI](https://github.com/groeneai)).
* Fixed a signed integer overflow (undefined behavior) in `arrayLevenshteinDistanceWeighted` and `arraySimilarity` when the weight arrays contain large integer values. The weighted distance is now accumulated in a wide integer for integral weights, so large integer weights no longer overflow and stay exact. [#106934](https://github.com/ClickHouse/ClickHouse/pull/106934) ([Groene AI](https://github.com/groeneai)).
* Fix a server crash (null pointer dereference) when running `TRUNCATE` or `DROP` on an `EmbeddedRocksDB` table whose RocksDB handle was released, for example a `read_only` table whose data directory was emptied by a prior `TRUNCATE`. [#106940](https://github.com/ClickHouse/ClickHouse/pull/106940) ([Groene AI](https://github.com/groeneai)).
* Fix an exception (`std::length_error` reported as a `LOGICAL_ERROR`) when reading from a `*Cluster` table function such as `urlCluster` with a very large `max_streams_for_files_processing_in_cluster_functions` setting. The number of streams is now bounded to a sane value. [#106946](https://github.com/ClickHouse/ClickHouse/pull/106946) ([Groene AI](https://github.com/groeneai)).
* Fix a server crash (null pointer dereference of `DB::IConnections`) in `RemoteQueryExecutor` when a distributed query is cancelled right before it is sent to a shard. [#106950](https://github.com/ClickHouse/ClickHouse/pull/106950) ([Groene AI](https://github.com/groeneai)).
* Fixed `elapsed_us` always being zero, and `read_rows`/`read_bytes` being undercounted, in `system.processors_profile_log` and `system.query_log` for asynchronous insert flush (`AsyncInsertFlush`) queries. [#106982](https://github.com/ClickHouse/ClickHouse/pull/106982) ([Christoph Wurm](https://github.com/cwurm)).
* Fix a crash (`Source column is not Map` / `SIGSEGV`) when merging sorted blocks that contain a `Variant` column with a `Map` variant whose local storage order differs from its global order. [#107011](https://github.com/ClickHouse/ClickHouse/pull/107011) ([Groene AI](https://github.com/groeneai)).
* Fix a logical error `conflicted_part_name.has_value()` raised during a synchronous insert into a `ReplicatedMergeTree` table when the inserted block was fully deduplicated and the conflicting part's deduplication node had already been removed (for example by a concurrent `DROP PARTITION`). [#107026](https://github.com/ClickHouse/ClickHouse/pull/107026) ([Groene AI](https://github.com/groeneai)).
* Fixed an exception (logical error `this->visited_views == right->visited_views`) on `INSERT` when two materialized views on the same source table write to the same target table and a dependent view reads that target, with `materialized_views_squash_parallel_inserts` enabled. [#107027](https://github.com/ClickHouse/ClickHouse/pull/107027) ([Groene AI](https://github.com/groeneai)).
* Fixed a `Block structure mismatch in UnionStep stream` logical error (server abort on debug/sanitizer builds, `Code: 49` on release builds) that occurred when one branch of a `UNION`/`INTERSECT`/`EXCEPT` read a `Sparse`-serialized column while the sibling branch read the same column as a full one (for example when pushing to a materialized view). [#107041](https://github.com/ClickHouse/ClickHouse/pull/107041) ([Groene AI](https://github.com/groeneai)).
* Fixed a `LOGICAL_ERROR` exception when inserting into a DeltaLake table with columns that do not match its write schema (for example a `Nested` column that flattens to subcolumns, or a table function with an explicit column subset). Such inserts now fail with a user-facing `INCOMPATIBLE_COLUMNS` error instead. Closes [#87402](https://github.com/ClickHouse/ClickHouse/issues/87402). [#107058](https://github.com/ClickHouse/ClickHouse/pull/107058) ([Groene AI](https://github.com/groeneai)).
* Fix `TYPE_MISMATCH` error ("Cannot convert string ... to type ...") for `ORDER BY <numeric column> ... LIMIT n` queries when lazy materialization placed another column before the sort column. The top-K threshold is now read from the correct sort column. [#107060](https://github.com/ClickHouse/ClickHouse/pull/107060) ([Groene AI](https://github.com/groeneai)).
* Fixed a syntax error when a `FORMAT`, `SETTINGS`, or `INTO OUTFILE` clause follows `SHOW ROW POLICIES` or `SHOW MASKING POLICIES` (e.g. `SHOW ROW POLICIES FORMAT TabSeparated`). [#107061](https://github.com/ClickHouse/ClickHouse/pull/107061) ([Groene AI](https://github.com/groeneai)).
* Fix a compound `ALTER TABLE ... RENAME COLUMN a TO b, RENAME COLUMN c TO a` that reuses a freed column name (a "swap") between columns of different types. The materialized part recorded the wrong column type, so a later `SELECT` failed with `Conversion between numeric types and IPv6 is not supported` (or aborted on part load in debug builds). [#107064](https://github.com/ClickHouse/ClickHouse/pull/107064) ([Groene AI](https://github.com/groeneai)).
* Fixed non-deterministic results of the `roundDown` function when the boundaries array contains `NaN`. The same input value could return a finite boundary or `NaN` depending on the surrounding rows in a batch. `NaN` boundaries are now ignored, so the result depends only on the finite boundaries. [#107065](https://github.com/ClickHouse/ClickHouse/pull/107065) ([Groene AI](https://github.com/groeneai)).
* Fixed `quantileTDigest` and `quantileTDigestWeighted` throwing `DECIMAL_OVERFLOW` for `Date` and `DateTime` arguments when the interpolated quantile is fractional but in range (for example `quantileTDigestWeighted(date, weight)` on values that all fit in the type). The fractional result is now truncated to the result type, matching `quantilesTDigestWeighted`; genuine out-of-range values still raise an error. Closes: [#106722](https://github.com/ClickHouse/ClickHouse/issues/106722). [#107066](https://github.com/ClickHouse/ClickHouse/pull/107066) ([Groene AI](https://github.com/groeneai)).
* Fix `trimLeft`, `trimRight`, and `trimBoth` (and aliases `ltrim`, `rtrim`, `trim`) throwing `TOO_LARGE_STRING_SIZE` when the custom trim character set is longer than 16 characters. Trim sets of any length are now supported again. [#107071](https://github.com/ClickHouse/ClickHouse/pull/107071) ([Nikita Fomichev](https://github.com/fm4v)).
* Fixed silent truncation of out-of-range integer values in `Enum8`/`Enum16` type definitions. `Enum8('a' = 200)` now throws `ARGUMENT_OUT_OF_BOUND` instead of silently creating `Enum8('a' = -56)`. [#107081](https://github.com/ClickHouse/ClickHouse/pull/107081) ([Groene AI](https://github.com/groeneai)).
* Fix wrong row order (and a `LOGICAL_ERROR` "Rows are not sorted with permutation" in debug builds) for multi-column `ORDER BY ... LIMIT` queries that sort by `Nullable` columns when several rows tie on the leading columns. [#107094](https://github.com/ClickHouse/ClickHouse/pull/107094) ([Groene AI](https://github.com/groeneai)).
* Fix a `LOGICAL_ERROR` (`Expected the argument N to have X rows, but it has Y`) when executing a function over a `Dynamic` column built by a JOIN over `Dynamic` (for example the non-joined rows of a `RIGHT`/`FULL JOIN`, or a correlated `EXISTS` subquery decorrelated into a join). [#107095](https://github.com/ClickHouse/ClickHouse/pull/107095) ([Groene AI](https://github.com/groeneai)).
* Fix spurious ZooKeeper session recreation on config reload. [#107096](https://github.com/ClickHouse/ClickHouse/pull/107096) ([Azat Khuzhin](https://github.com/azat)).
* Do not hold mutex across ZooKeeper reads in access entities refresh. [#107097](https://github.com/ClickHouse/ClickHouse/pull/107097) ([Azat Khuzhin](https://github.com/azat)).
* Fix a `Logical error: Too large size passed to allocator` exception on `INSERT` into a `MergeTree` table when `adaptive_write_buffer_initial_size` is set to an extremely large value. The adaptive write buffer initial size is now clamped to the buffer maximum. [#107104](https://github.com/ClickHouse/ClickHouse/pull/107104) ([Groene AI](https://github.com/groeneai)).
* Fix `LOGICAL ERROR` (`Bad cast from type DB::ColumnString to DB::ColumnLowCardinality`) when a `Variant` constant containing a `LowCardinality` member is compared to a key column whose key expression is a non-monotonic deterministic function (for example a `minmax` skip index over `sipHash64(col)`). [#107111](https://github.com/ClickHouse/ClickHouse/pull/107111) ([Groene AI](https://github.com/groeneai)).
* Fix a `Bad cast from type DB::IColumn const* to DB::ColumnNullable const*` logical error when a qualified asterisk (`t.*`) over a `JOIN ... USING` key is passed to an aggregate function and the other side of an outer JOIN has a `Nullable` key (with `join_use_nulls = 0`). [#107129](https://github.com/ClickHouse/ClickHouse/pull/107129) ([Groene AI](https://github.com/groeneai)).
* Fix `ALTER TABLE ... ON CLUSTER` batches that mix `MODIFY SETTING`/`RESET SETTING` with a comment change (for example `MODIFY COMMENT 'x', MODIFY SETTING old_parts_lifetime = 123`) being applied only on the leader replica, leaving the other replicas diverged. Also fix a positional or per-column-`SETTINGS` `MODIFY COLUMN ... COMMENT` being misclassified as a local comment-only metadata change, which left the column reorder out of the replicated metadata and could cause `INCOMPATIBLE_COLUMNS` on replica restart. [#107142](https://github.com/ClickHouse/ClickHouse/pull/107142) ([Groene AI](https://github.com/groeneai)).
* Fix a `LOGICAL_ERROR` ("Table expression ... data must be initialized") raised when a qualified asterisk matcher (for example `x.*`) referenced a recursive CTE by name inside its own recursive term. Such matchers now expand the recursive table's columns, the same way a qualified column (`x.a`) or an unqualified matcher (`*`) already does in that position. [#107144](https://github.com/ClickHouse/ClickHouse/pull/107144) ([Groene AI](https://github.com/groeneai)).
* Fixed wrong query results caused by the query condition cache when on-fly mutations (`apply_mutations_on_fly`) or patch parts filtered rows before `PREWHERE`. A query reading with `apply_mutations_on_fly = 1` could poison the cache so that a later query with `apply_mutations_on_fly = 0` and the same predicate skipped marks it should have read and returned too few rows. The same fix also covers row-level security policies, which are prepended as a filter ahead of `PREWHERE`: a query run under a restrictive row policy could poison the cache for a later query that uses the same predicate without that policy. [#107145](https://github.com/ClickHouse/ClickHouse/pull/107145) ([Groene AI](https://github.com/groeneai)).
* Fixed `BACKUP` to `AzureBlobStorage`: copying a data file inside a backup wrote the destination object outside the backup directory. Backup object existence checks on `S3` destinations now use exact `HeadObject` requests instead of prefix listing, preventing false matches of similarly-prefixed keys. [#107153](https://github.com/ClickHouse/ClickHouse/pull/107153) ([Pablo Marcos](https://github.com/pamarcos)).
* Fixed a signed integer overflow in `quantileExactExclusive`, `quantilesExactExclusive`, `quantileExactInclusive` and `quantilesExactInclusive` that could produce a wrong result for `Int64` inputs spanning a large range. [#107154](https://github.com/ClickHouse/ClickHouse/pull/107154) ([Groene AI](https://github.com/groeneai)).
* Fixed a `LOGICAL_ERROR` ("Unexpected exception in refresh scheduling") that could put the server into a crash-loop on restart when a refreshable materialized view has a `REFRESH ... DEPENDS ON <name>` dependency whose unqualified name matches a temporary table or a CTE name. [#107156](https://github.com/ClickHouse/ClickHouse/pull/107156) ([Groene AI](https://github.com/groeneai)).
* Make sure we don't run startup scripts on config reload, as that is semantically wrong and unexpected by users - and has been known to be error-prone. [#107187](https://github.com/ClickHouse/ClickHouse/pull/107187) ([Miсhael Stetsyuk](https://github.com/mstetsyuk)).
* Cap the max value for `queue_size` for pre-reserve. [#107205](https://github.com/ClickHouse/ClickHouse/pull/107205) ([Elian Gidoni](https://github.com/eliangidoni)).
* Fix the `Argument ... of GROUPING function is not a part of GROUP BY clause` error for queries that use the `grouping` function with the `group_by_use_nulls` setting enabled. [#107206](https://github.com/ClickHouse/ClickHouse/pull/107206) ([Nikolai Kochetov](https://github.com/KochetovNicolai)).
* Fix incorrect result order for `ORDER BY` over `UNION ALL` with `optimize_read_in_order` enabled when the union pipeline was narrowed due to `max_streams_for_union_step` settings; narrowing is now skipped when the plan relies on sorted UNION output streams. Closes [#106880](https://github.com/ClickHouse/ClickHouse/issues/106880). [#107208](https://github.com/ClickHouse/ClickHouse/pull/107208) ([Vladimir Cherkasov](https://github.com/vdimir)).
* Fixed a possible null pointer dereference while resolving proxy configuration during late server shutdown. [#107231](https://github.com/ClickHouse/ClickHouse/pull/107231) ([Pedro Ferreira](https://github.com/PedroTadim)).
* Fix lightweight `UPDATE` queries with legacy parallel replicas enabled for non-replicated `MergeTree` tables. [#107246](https://github.com/ClickHouse/ClickHouse/pull/107246) ([Groene AI](https://github.com/groeneai)).
* Fixed a server abort (`std::out_of_range` logical error) when inserting into an `Iceberg` table whose write block column names do not match the field ids of the latest schema (for example after a concurrent writer renames a column within the `iceberg_metadata_staleness_ms` window). The insert now fails with a clean query error instead of crashing the server. [#107279](https://github.com/ClickHouse/ClickHouse/pull/107279) ([Groene AI](https://github.com/groeneai)).
* Fix the stuck shutdown bug on server and local due to static thread pools keeping idle threads indefinitely if `max_*_thread_pool_free_size > 0`. [#107291](https://github.com/ClickHouse/ClickHouse/pull/107291) ([Miсhael Stetsyuk](https://github.com/mstetsyuk)).
* Fix the `s3` table function silently ignoring a lowercase positional `partition_strategy` (e.g. `hive`). [#107297](https://github.com/ClickHouse/ClickHouse/pull/107297) ([Julia Kartseva](https://github.com/jkartseva)).
* Fix `low_cardinality_allow_in_native_format=0` handling in parallel blocks marshalling. [#107319](https://github.com/ClickHouse/ClickHouse/pull/107319) ([Azat Khuzhin](https://github.com/azat)).
* Fix wrong (often empty) results from `ORDER BY <col> LIMIT n` when the `use_skip_indexes_for_top_k` optimization is active and a part with a `minmax` skip index on the sort column has had rows removed by a lightweight `DELETE`. The optimization no longer ranks the stale minmax of lightweight-deleted parts ahead of the parts that hold the live top rows. [#107320](https://github.com/ClickHouse/ClickHouse/pull/107320) ([Groene AI](https://github.com/groeneai)).
* Fixed a bug in ClickHouse Keeper where the snapshot metadata reported via `last_snapshot` (and `zk_latest_snapshot_size` in `mntr`) could move backwards after a stale or duplicated snapshot install, which could also let a same-index local snapshot overwrite a registered snapshot file in place while it was still being streamed to a peer or uploaded to S3. [#107321](https://github.com/ClickHouse/ClickHouse/pull/107321) ([Antonio Andelic](https://github.com/antonio2368)).
* Fixed possible server stack overflow (crash) when reading a deeply nested schema or value in the `MsgPack`, `BSON`, `ORC`, `Parquet`, `JSON`, `DeltaLake`, `Iceberg` and `Paimon` formats. Such deeply nested input is now rejected with an exception. [#107341](https://github.com/ClickHouse/ClickHouse/pull/107341) ([Raúl Marín](https://github.com/Algunenano)).
* Fix a possible logical error in `SYSTEM SYNC DATABASE REPLICA ... STRICT` and make the `STRICT` modifier actually take effect for database replicas. [#107344](https://github.com/ClickHouse/ClickHouse/pull/107344) ([Pedro Ferreira](https://github.com/PedroTadim)).
* Fixes a server abort in debug/sanitizer builds when reading a `DeltaLake` table whose ClickHouse schema names a column that is absent from the Delta column mapping, for example after a column was renamed or dropped in the Delta log. The query now fails with a catchable `INCORRECT_DATA` error instead. [#107347](https://github.com/ClickHouse/ClickHouse/pull/107347) ([Groene AI](https://github.com/groeneai)).
* Fix `ORDER BY ... WITH FILL` producing extra rows when an `ORDER BY` column before the fill column uses a `COLLATE` collation. The rows are now grouped by the sorting prefix using that collation, matching the sort order. [#107365](https://github.com/ClickHouse/ClickHouse/pull/107365) ([Groene AI](https://github.com/groeneai)).
* Fixed a crash (`LOGICAL_ERROR` in debug builds) and a silent wrong-results bug (in release builds) when reading an Iceberg table whose metadata re-binds an existing `schema-id` to a different schema across metadata versions. Such metadata is now rejected with `ICEBERG_SPECIFICATION_VIOLATION`. [#107370](https://github.com/ClickHouse/ClickHouse/pull/107370) ([Groene AI](https://github.com/groeneai)).
* Fix a `LOGICAL_ERROR` (`Variant N (T) has size X, but expected Y`) when a function such as `toString` or `concat` is applied to a `Variant` or `Dynamic` column that holds a single non-empty variant together with NULLs, and the function returns its input column unchanged. [#107374](https://github.com/ClickHouse/ClickHouse/pull/107374) ([Groene AI](https://github.com/groeneai)).
* Fix `Logical error: 'Duplicate announcement received for replica number N'` that could occur with parallel replicas when a scalar subquery contained nested subqueries reading the same table. [#107381](https://github.com/ClickHouse/ClickHouse/pull/107381) ([Groene AI](https://github.com/groeneai)).
* Fix `getServerSetting` to return the live effective value for runtime-changeable server settings (such as `max_server_memory_usage`, `mark_cache_size`, `max_concurrent_queries`, thread pool sizes, etc.), matching what `system.server_settings` reports. [#107388](https://github.com/ClickHouse/ClickHouse/pull/107388) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix `arrayResize` with a `Decimal` size argument: the size is now interpreted by its real value (e.g. `arrayResize([1, 2, 3], 1.5::Decimal(2, 1))` returns one element) instead of the raw unscaled representation. [#107389](https://github.com/ClickHouse/ClickHouse/pull/107389) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix a `LOGICAL_ERROR` (`block.rows() == getRows()`) raised on an async `INSERT` into an `Alias` table when `use_strict_insert_block_limits` was enabled. [#107400](https://github.com/ClickHouse/ClickHouse/pull/107400) ([Groene AI](https://github.com/groeneai)).
* Fix a logical error (`Unexpected return type from equals. Expected Nullable(UInt8). Got UInt8`) when the disjunction (partial predicate) push-down optimization pushes a condition over a `USING` key whose type is widened by the JOIN. Also fix a server crash (segmentation fault) in the analyzer when resolving identifiers in `JOIN ... USING` queries that contain constant-foldable `if`/`multiIf` branches referencing unknown identifiers. [#107407](https://github.com/ClickHouse/ClickHouse/pull/107407) ([Groene AI](https://github.com/groeneai)).
* Fixed a heap buffer overflow (server crash) in `windowFunnel` when finalizing a crafted aggregate-function state with an out-of-range event type, reachable by any user with a single `SELECT`. [#107412](https://github.com/ClickHouse/ClickHouse/pull/107412) ([uwezkhan](https://github.com/uwezkhan)).
* Fixed undefined behavior when a non-finite floating-point value (such as `nan` or `inf`) is passed as the timestamp/duration argument of the `prometheusQuery` / `prometheusQueryRange` table functions. Such an argument now raises `BAD_ARGUMENTS` instead of producing a garbage timestamp. [#107417](https://github.com/ClickHouse/ClickHouse/pull/107417) ([Groene AI](https://github.com/groeneai)).
* Fix `MaterializedPostgreSQL` silently stopping replication of changes when the PostgreSQL database or table name contains upper-case letters (the `pgoutput` consumer requested an unquoted, lower-cased publication name that did not match the case-preserving publication). [#107423](https://github.com/ClickHouse/ClickHouse/pull/107423) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix an exception (`Logical error: Not-ready Set is passed as the second argument for function 'in'`) when a key expression (`ORDER BY`, `PRIMARY KEY`, `PARTITION BY`, or a skip `INDEX`) contained an `IN` operator with a table on the right-hand side, e.g. `ORDER BY (x IN some_table)`. Such key expressions are now rejected at table creation time. [#107424](https://github.com/ClickHouse/ClickHouse/pull/107424) ([Groene AI](https://github.com/groeneai)).
* Fix incorrect results from the `optimize_rewrite_aggregate_function_with_if` optimization for aggregate functions that preserve `NULL` payload values (the `*_respect_nulls` family: `anyRespectNulls`, `first_value_respect_nulls`, `anyLast_respect_nulls`, `last_value_respect_nulls`). The optimization no longer rewrites `f(if(cond, x, NULL))` into the `-If` form for such functions. [#107430](https://github.com/ClickHouse/ClickHouse/pull/107430) ([Groene AI](https://github.com/groeneai)).
* Fix a spurious `filesystem error: in last_write_time: No such file or directory` exception when listing a local-disk object storage directory (e.g. an Iceberg table on a `local` disk) while files are being concurrently replaced. A concurrently removed entry is now omitted from the listing instead of aborting it. [#107432](https://github.com/ClickHouse/ClickHouse/pull/107432) ([Groene AI](https://github.com/groeneai)).
* Fix `THERE_IS_NO_COLUMN` error when `optimize_if_transform_strings_to_enum = 1` and the optimized `if`/`transform`-over-string-literals expression is a `GROUP BY` or `ORDER BY` key over a Distributed table or parallel replicas. [#107455](https://github.com/ClickHouse/ClickHouse/pull/107455) ([Groene AI](https://github.com/groeneai)).
* Fixed a rare server crash in `DISTINCT` processing that could occur when an allocation failed (for example, when hitting a memory limit) while the set of distinct keys was being initialized. [#107467](https://github.com/ClickHouse/ClickHouse/pull/107467) ([Groene AI](https://github.com/groeneai)).
* Fix `LOGICAL_ERROR: Unexpected return type from materialize` (and similar type-mismatch errors) when `apply_mutations_on_fly = 1` is used on a table with a pending on-fly `UPDATE` whose target column is also read as a function input by an earlier on-fly `UPDATE`, before an `ALTER MODIFY COLUMN ... LowCardinality(...)` mutation. [#107475](https://github.com/ClickHouse/ClickHouse/pull/107475) ([Groene AI](https://github.com/groeneai)).
* Fixed stale AWS STS credentials when reading `DeltaLake` tables over `S3`: the engine now keeps the freshly-credentialed `S3` client when refreshing its snapshot, so long-running reads no longer fail after the STS token's TTL expires. The STS assume-role credentials provider now also honors credential refresh for any `S3` access using STS. [#107480](https://github.com/ClickHouse/ClickHouse/pull/107480) ([Elmi Ahmadov](https://github.com/ahmadov)).
* Fixed `SELECT ... FINAL` and `OPTIMIZE TABLE ... FINAL` returning duplicate rows after `CREATE TABLE ... CLONE AS`, `ATTACH PARTITION ... FROM` or `MOVE PARTITION ... TO TABLE` adopted parts from a plain `MergeTree` into a `ReplacingMergeTree`, `SummingMergeTree` or `AggregatingMergeTree`. The adopted part's merge level is now reset to 0 when the source and destination engines differ, so the destination deduplicates it on the next merge. [#107481](https://github.com/ClickHouse/ClickHouse/pull/107481) ([Groene AI](https://github.com/groeneai)).
* Fix an integer underflow in the PostgreSQL wire protocol parser where a message with a length field smaller than 4 caused a `size - 4` wraparound and an oversized `resize`/`ignore`. [#107485](https://github.com/ClickHouse/ClickHouse/pull/107485) ([uwezkhan](https://github.com/uwezkhan)).
* Query cancellation is now better tracked while waiting for the quorum in ReplicatedMergeTree. [#107513](https://github.com/ClickHouse/ClickHouse/pull/107513) ([Nikita Taranov](https://github.com/nickitat)).
* Fixed a `Not-ready Set is passed as the second argument for function 'in'` (`LOGICAL_ERROR`) when querying a table with a `PARTITION BY` key and an `IN`/`NOT IN` subquery wrapped inside a larger expression, for example `WHERE (c0 IN (SELECT ...)) != 0`. [#107515](https://github.com/ClickHouse/ClickHouse/pull/107515) ([Groene AI](https://github.com/groeneai)).
* Fixed `currentUser()`, `user()`, `SESSION_USER` and `authenticatedUser()` evaluating to an empty string on the asynchronous insert flush path (with `async_insert = 1`). This affected `DEFAULT`/`MATERIALIZED` column expressions and materialized views that reference these functions, which silently stored an empty string instead of the inserting user. [#107541](https://github.com/ClickHouse/ClickHouse/pull/107541) ([Groene AI](https://github.com/groeneai)).
* With `enable_analyzer = 1` (the default), querying a table by its bare name when it only exists in another database now suggests the right table, e.g. `SELECT * FROM functions` reports `Maybe you meant system.functions?`. Previously the new analyzer gave a hint-less `Unknown table expression identifier` error, while the old analyzer already produced the helpful suggestion. [#107550](https://github.com/ClickHouse/ClickHouse/pull/107550) ([Groene AI](https://github.com/groeneai)).
* Account memory used by the rapidjson library (in `prettyPrintJSON`, `JSONMergePatch` and the rapidjson JSON parser) against the memory tracker, so pathological inputs are rejected with `MEMORY_LIMIT_EXCEEDED` instead of allocating without bound. [#107555](https://github.com/ClickHouse/ClickHouse/pull/107555) ([Raúl Marín](https://github.com/Algunenano)).
* Fix a `LOGICAL_ERROR` (`updateFormatPrewhereInfo called more than once`) raised when querying a `file()`, `url()`, or object-storage source with both an explicit `PREWHERE` and a `WHERE` while `optimize_prewhere_after_pushdown` was enabled. [#107568](https://github.com/ClickHouse/ClickHouse/pull/107568) ([Groene AI](https://github.com/groeneai)).
* Fix a crash (null pointer dereference) that could happen when a distributed query plan was executed locally (`make_distributed_plan` + `distributed_plan_execute_locally`) with `log_formatted_queries = 1`. [#107570](https://github.com/ClickHouse/ClickHouse/pull/107570) ([Groene AI](https://github.com/groeneai)).
* Fixed a server abort (`std::terminate`, signal 6) during teardown of a distributed-plan query (`make_distributed_plan = 1`) when a worker status-check failed to re-schedule the next check (for example `CANNOT_SCHEDULE_TASK` on shutdown or `MEMORY_LIMIT_EXCEEDED`). The query now fails cleanly and the server keeps running. [#107575](https://github.com/ClickHouse/ClickHouse/pull/107575) ([Groene AI](https://github.com/groeneai)).
* Added missing bounds checks in Elf and DWARF parsing. [#107579](https://github.com/ClickHouse/ClickHouse/pull/107579) ([Michael Kolupaev](https://github.com/al13n321)).
* Added missing bounds checks in ORC reader. [#107580](https://github.com/ClickHouse/ClickHouse/pull/107580) ([Michael Kolupaev](https://github.com/al13n321)).
* Fixed an exception (`Digest does not match` logical error) that could happen on `RENAME TABLE`, `RENAME DATABASE`, or `CREATE OR REPLACE TABLE` involving a `TimeSeries` table inside a `Replicated` database. Renaming a `TimeSeries` table is now supported. [#107583](https://github.com/ClickHouse/ClickHouse/pull/107583) ([Groene AI](https://github.com/groeneai)).
* Fix an unauthenticated memory-exhaustion denial of service on the MySQL protocol port. [#107599](https://github.com/ClickHouse/ClickHouse/pull/107599) ([Shaohua Wang](https://github.com/tiandiwonder)).
* Fix `DROP TABLE` of a `TimeSeries` table in a `Replicated` database, which previously leaked the inner tables and left the background drop task retrying forever (`DROP TABLE ... SYNC` would hang). [#107604](https://github.com/ClickHouse/ClickHouse/pull/107604) ([Groene AI](https://github.com/groeneai)).
* Fixed two path-traversal issues in the replicated part fetch protocol that could let a malicious replica write files outside the part directory. [#107606](https://github.com/ClickHouse/ClickHouse/pull/107606) ([Antonio Andelic](https://github.com/antonio2368)).
* Fixed 'Account must be specified error' when reading a Delta Lake table over Azure. [#107620](https://github.com/ClickHouse/ClickHouse/pull/107620) ([Smita Kulkarni](https://github.com/SmitaRKulkarni)).
* Fixed `ALTER TABLE ... REPLACE PARTITION` on a plain `MergeTree` table resurrecting the replaced-out parts after a server restart, which made the table return both the replacement rows and the stale replaced rows. [#107623](https://github.com/ClickHouse/ClickHouse/pull/107623) ([Groene AI](https://github.com/groeneai)).
* Fix a server crash when reading a materialized view whose target is a `Distributed` table while the query runs with `enable_analyzer = 0`. [#107653](https://github.com/ClickHouse/ClickHouse/pull/107653) ([Groene AI](https://github.com/groeneai)).
* When several quotas are assigned to the same user or role, all of them are now enforced together (a query is rejected if any of them is exceeded), instead of only one quota being enforced and chosen non-deterministically. `SHOW QUOTA` and `system.quota_usage` now show all quotas enforced for the current user. [#107664](https://github.com/ClickHouse/ClickHouse/pull/107664) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fixed `s3` and other object storage table functions throwing `LOGICAL_ERROR` instead of `BAD_ARGUMENTS` when a key-value argument is duplicated, e.g. `s3('http://...', format = 'CSV', format = 'TSV')`. [#107670](https://github.com/ClickHouse/ClickHouse/pull/107670) ([Groene AI](https://github.com/groeneai)).
* Fixed the MySQL interface being unusable with `MySQL Connector/J` 8.2.0 and newer (including 9.x). The `info` field of the `OK` packet is now length-encoded, matching the MySQL server, so the JDBC driver can connect. [#107693](https://github.com/ClickHouse/ClickHouse/pull/107693) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fixed a `LOGICAL_ERROR` ("Input nodes size mismatch in dag") when a query with `make_distributed_plan = 1` joins on a function-wrapped key whose two sides have no common type (for example `ON intDiv(-1, t1.key) = t2.key` with a `UInt64` right key). [#107701](https://github.com/ClickHouse/ClickHouse/pull/107701) ([Groene AI](https://github.com/groeneai)).
* Reading Arrow/ArrowStream data with empty `String`/`Binary` columns produced by Apache Arrow Java < 19.0.0 (including Apache Spark) no longer throws `INCORRECT_DATA`. [#107764](https://github.com/ClickHouse/ClickHouse/pull/107764) ([Raúl Marín](https://github.com/Algunenano)).
* Fixed a `BAD_GET` exception ("Bad get: has String, requested UInt64") from `countmin` column statistics estimation when a query compares a column against a literal of a different type that is not pre-coerced, such as `numeric_col IN (SELECT '5')` or `string_col IN (SELECT 5)`. [#107793](https://github.com/ClickHouse/ClickHouse/pull/107793) ([Groene AI](https://github.com/groeneai)).
* Fixed the `odbc` and `jdbc` table functions hanging for minutes and ignoring query cancellation (`KILL QUERY`, `max_execution_time`) when the bridge becomes unresponsive while inferring the remote table structure. [#107809](https://github.com/ClickHouse/ClickHouse/pull/107809) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fixed an exception (`Logical error: 'index >= result.start'`) when formatting a malformed query that mixes the positional and named secret-argument forms of the `s3`/`gcs` table functions, e.g. `s3('url', 'a', 'b', secret_access_key = 'c')`. [#107818](https://github.com/ClickHouse/ClickHouse/pull/107818) ([Groene AI](https://github.com/groeneai)).
* Fix set skip index not pruning granules over `LowCardinality` columns. [#107868](https://github.com/ClickHouse/ClickHouse/pull/107868) ([Konstantin Bogdanov](https://github.com/thevar1able)).
* Fixed insert deduplication computing wrong hashes for `String` and `Array` columns with the server setting `insert_deduplication_version = new_unified_hash`: identical inserts could fail to deduplicate because the deduplication hash depended on the row's position within the inserted block. [#107915](https://github.com/ClickHouse/ClickHouse/pull/107915) ([Sema Checherinda](https://github.com/CheSema)).
* Fix incorrect results of `ORDER BY` over `Nullable` columns with multiple sort keys on macOS (Apple Silicon), caused by a missing sign-extension in the JIT-compiled sort comparator. [#107973](https://github.com/ClickHouse/ClickHouse/pull/107973) ([Raúl Marín](https://github.com/Algunenano)).
* Fix performance regression when reading `Dynamic` columns with multiple threads. Caused by [#100730](https://github.com/ClickHouse/ClickHouse/pull/100730). Closes [#107942](https://github.com/ClickHouse/ClickHouse/issues/107942). [#107997](https://github.com/ClickHouse/ClickHouse/pull/107997) ([Pavel Kruglov](https://github.com/Avogar)).
* The deprecated data lake setting `storage_catalog_url` is now correctly rejected by the catalog guard (previously only `storage_catalog_type` and `storage_aws_access_key_id` were checked), and the error message lists all deprecated settings. [#108040](https://github.com/ClickHouse/ClickHouse/pull/108040) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix a `Bad cast from type DB::ColumnSparse to DB::ColumnVector<char8_t>` logical error when a `LIKE` query reads from a `text` index via the direct-read fallback path over a column stored sparse. [#108068](https://github.com/ClickHouse/ClickHouse/pull/108068) ([Groene AI](https://github.com/groeneai)).
* Always run access cache batch-finished handlers, even on empty batch. [#108124](https://github.com/ClickHouse/ClickHouse/pull/108124) ([Azat Khuzhin](https://github.com/azat)).
* Fixed a `LOGICAL_ERROR` (`Column identifier is already registered`) for some queries with `UNION ALL`. [#100770](https://github.com/ClickHouse/ClickHouse/pull/100770) ([Shaohua Wang](https://github.com/tiandiwonder)).
* Fixed a use-after-free of the workload storage mutex during server shutdown. [#101447](https://github.com/ClickHouse/ClickHouse/pull/101447) ([Tuan Pham Anh](https://github.com/tuanpach)).
* Fixed a deadlock in `ALTER DATABASE MODIFY COMMENT` with the `Shared` catalog. [#103683](https://github.com/ClickHouse/ClickHouse/pull/103683) ([Nikolay Degterinsky](https://github.com/evillique)).
* An empty Unicode-quoted identifier now raises a `SYNTAX_ERROR` instead of `CANNOT_PARSE_QUOTED_STRING`. [#104173](https://github.com/ClickHouse/ClickHouse/pull/104173) ([leonard9893](https://github.com/leonard9893)).
* Preserve the original parameter types of `timeSeries*` aggregate functions so that `AggregateFunction` types round-trip correctly across table reattach and parallel replicas. [#104812](https://github.com/ClickHouse/ClickHouse/pull/104812) ([Vitaly Baranov](https://github.com/vitlibar)).
* Fixed a `LOGICAL_ERROR` for a materialized CTE under `serialize_query_plan` with parallel replicas. [#104896](https://github.com/ClickHouse/ClickHouse/pull/104896) ([Igor Nikonov](https://github.com/devcrafter)).
* Fixed signed integer overflow in the `timeSeries*ToGrid` functions when the staleness (window) parameter is near `INT64_MAX`. [#105319](https://github.com/ClickHouse/ClickHouse/pull/105319) ([Groene AI](https://github.com/groeneai)).
* A `compatibility` setting value no longer reverts `apply_row_policy_after_final` to `false`, so row policies are always applied correctly with `FINAL`. [#105637](https://github.com/ClickHouse/ClickHouse/pull/105637) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* Fixed `clickhouse chdig client` by honoring `SETPGROUP`/`RESETIDS`/`SETSIGDEF` in the `posix_spawn` stub. [#105858](https://github.com/ClickHouse/ClickHouse/pull/105858) ([Azat Khuzhin](https://github.com/azat)).
* Fixed an exception during merge-tree sanity checks on projections when the merge/mutate executor was not initialized. [#105919](https://github.com/ClickHouse/ClickHouse/pull/105919) ([Mikhail Artemenko](https://github.com/Michicosun)).
* During index analysis on projections, the `minmax` index is now loaded from the projection itself rather than from the parent part, producing correct results. [#105940](https://github.com/ClickHouse/ClickHouse/pull/105940) ([Mikhail Artemenko](https://github.com/Michicosun)).
* Fixed an exception in `addMonotonicChain` for `materialize(monotonic_chain(...))`. [#106050](https://github.com/ClickHouse/ClickHouse/pull/106050) ([Nikolai Kochetov](https://github.com/KochetovNicolai)).
* Fixed `RESTORE` failing on backups that include `MASKING POLICY` dependents. [#106086](https://github.com/ClickHouse/ClickHouse/pull/106086) ([Julia Kartseva](https://github.com/jkartseva)).
* Fixed possible memory corruption when expanding SQL user-defined functions with `prefer_column_name_to_alias` enabled. [#106121](https://github.com/ClickHouse/ClickHouse/pull/106121) ([Nikolai Kochetov](https://github.com/KochetovNicolai)).
* A dictionary using the bridge connection is now reloaded after a server restart, re-establishing the connection. Closes [#106151](https://github.com/ClickHouse/ClickHouse/issues/106151). [#106152](https://github.com/ClickHouse/ClickHouse/pull/106152) ([Pedro Ferreira](https://github.com/PedroTadim)).
* Fixed the filesystem cache for `LocalObjectStorage`. [#106239](https://github.com/ClickHouse/ClickHouse/pull/106239) ([Kseniia Sumarokova](https://github.com/kssenii)).
* Fixed the lazy remote source for table functions with `use_delayed_remote_source`. [#106470](https://github.com/ClickHouse/ClickHouse/pull/106470) ([Nikolay Degterinsky](https://github.com/evillique)).
* Fixed `timeSeriesLastToGrid` for timestamps before the grid start and out-of-window timestamps. [#106504](https://github.com/ClickHouse/ClickHouse/pull/106504) ([Vitaly Baranov](https://github.com/vitlibar)). [#106577](https://github.com/ClickHouse/ClickHouse/pull/106577) ([Vitaly Baranov](https://github.com/vitlibar)).
* Fixed a `LOGICAL_ERROR` (`Inconsistent AST formatting`) on a function name containing query parameters. [#106635](https://github.com/ClickHouse/ClickHouse/pull/106635) ([Vitaly Baranov](https://github.com/vitlibar)).
* Fixed a logical error when a table is dropped before distributed plan task deserialization. [#106944](https://github.com/ClickHouse/ClickHouse/pull/106944) ([Alexander Gololobov](https://github.com/davenger)).
* Use exact comparison for `Nullable` `GROUP BY` keys. [#107050](https://github.com/ClickHouse/ClickHouse/pull/107050) ([Nikolai Kochetov](https://github.com/KochetovNicolai)).
* Fixed a `LOGICAL_ERROR` (`Trying to get name of not a column`) raised when a table-function argument was not a column expression (for example an unresolved `*` matcher from `multiIf`/`CASE`). [#107411](https://github.com/ClickHouse/ClickHouse/pull/107411) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fixed unbounded growth of the time-zone cache (`DateLUT`) when many distinct invalid time-zone names are processed. [#107464](https://github.com/ClickHouse/ClickHouse/pull/107464) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Write the `part_log` entry before reporting a plain `MergeTree` mutation as done. [#107741](https://github.com/ClickHouse/ClickHouse/pull/107741) ([Azat Khuzhin](https://github.com/azat)).
* `arrayFold` now sanity-checks its array argument against malformed input. [#107932](https://github.com/ClickHouse/ClickHouse/pull/107932) ([Michael Kolupaev](https://github.com/al13n321)).
* Fixed a rare data race and possible use-after-free on the cached skip-index archive reader of a `MergeTree` part, which could happen when a query read skip indices while the part was being moved or renamed. [#107995](https://github.com/ClickHouse/ClickHouse/pull/107995) ([Raúl Marín](https://github.com/Algunenano)).
* Fix performance regression for `Map` subcolumns with `PREWHERE`. [#107988](https://github.com/ClickHouse/ClickHouse/pull/107988) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix `parseDateTimeBestEffort` with a timezone throwing `CANNOT_PARSE_DATETIME` on NULL rows of `toString(Nullable(DateTime64))`. [#108310](https://github.com/ClickHouse/ClickHouse/pull/108310) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* Fixed the `ArrowFlight` table function and engine rejecting a named collection that omits the optional `dataset` key with a `No such key 'dataset'` error. [#108041](https://github.com/ClickHouse/ClickHouse/pull/108041) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fixed an `Inconsistent AST formatting` logical error for a no-argument window function inside a `CODEC` or engine declaration (e.g. `CODEC(cume_dist() OVER (...))`); such a function now keeps its parentheses so the query survives a format/parse round-trip. [#107806](https://github.com/ClickHouse/ClickHouse/pull/107806) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix `hasToken` with a separator-containing needle silently returning results via a text index instead of raising `BAD_ARGUMENTS`. [#108189](https://github.com/ClickHouse/ClickHouse/pull/108189) ([Jimmy Aguilar Mena](https://github.com/Ergus)).
* The setting `use_skip_indexes_on_data_read` can now be reverted to its pre-26.1 default (`false`) via the `compatibility` setting, providing an escape hatch for a performance regression where the on-data-read path defeats `minmax`/`set`/`bloom_filter` skip-index mark-range pruning. [#108330](https://github.com/ClickHouse/ClickHouse/pull/108330) ([egor romanov](https://github.com/egor-click)).
* Fixed a possible crash (null pointer dereference) when the `database`/`db` override of a named collection passed to `remote`/`remoteSecure` is not a constant database name, e.g. `remote(nc, database = (SELECT 1))`. The query now fails with a clear error instead of crashing. [#108271](https://github.com/ClickHouse/ClickHouse/pull/108271) ([Groene AI](https://github.com/groeneai)).
* Fixed refreshable materialized view getting stuck if the ZooKeeper connection is lost at the wrong moment. [#108234](https://github.com/ClickHouse/ClickHouse/pull/108234) ([Michael Kolupaev](https://github.com/al13n321)).
* Fix `Bad cast from type DB::ColumnVector<...> to DB::ColumnTuple` when reading an `Array(Tuple(...))` column whose value is filled with defaults, e.g. after `ALTER TABLE ... ADD COLUMN` or after an unfinished `ALTER TABLE ... CLEAR COLUMN` mutation applied on the fly. [#107232](https://github.com/ClickHouse/ClickHouse/pull/107232) ([Groene AI](https://github.com/groeneai)).
* Fix a `Bad cast from type DB::ColumnDynamic to DB::ColumnNullable` logical error when an explicit reference to a `JOIN ... USING` key whose common supertype is `Dynamic` is passed to an aggregate function, for example `count(t.key) IGNORE NULLS`. [#107289](https://github.com/ClickHouse/ClickHouse/pull/107289) ([Groene AI](https://github.com/groeneai)).
* Fix silent data loss on plain (non-replicated) `MergeTree` when `REPLACE PARTITION`, `MOVE PARTITION`, `DETACH PARTITION`, or `DETACH PART` is run on a partition that still has unapplied lightweight `UPDATE` patches. These operations now reject the command, as `ReplicatedMergeTree` already does. [#107386](https://github.com/ClickHouse/ClickHouse/pull/107386) ([Groene AI](https://github.com/groeneai)).
* Fix a crash (SIGSEGV in release builds, type-mismatch assertion in debug builds) in `has` over a `Map` with a `Dynamic` key when the lookup argument is `LowCardinality`, e.g. `has(map('a'::Dynamic, ...), toLowCardinality('b'))`. [#107956](https://github.com/ClickHouse/ClickHouse/pull/107956) ([Groene AI](https://github.com/groeneai)).
* Fixed a `LOGICAL_ERROR` ("Block structure mismatch ... between `ConvertingTransform` and `RemovingReplicatedColumnsTransform`") when inserting into a materialized view whose `TO` target table declares a column with a wider `Enum` than the view's `SELECT` produces. The valid `Enum` widening is now applied. [#107648](https://github.com/ClickHouse/ClickHouse/pull/107648) ([Groene AI](https://github.com/groeneai)).
* Fix `NUMBER_OF_COLUMNS_DOESNT_MATCH` error when querying a `Distributed` table (or using parallel replicas) that has several `ALIAS` columns expanding to the same expression and referencing them together with `ORDER BY`/`GROUP BY`/`HAVING`. [#107913](https://github.com/ClickHouse/ClickHouse/pull/107913) ([Yakov Olkhovskiy](https://github.com/yakov-olkhovskiy)).
* Fixed undefined behavior (null pointer passed to `memcpy`) in the `detectCharset` and `detectLanguageUnknown` functions when the input string is larger than 32768 bytes and no character set can be detected. [#108250](https://github.com/ClickHouse/ClickHouse/pull/108250) ([Groene AI](https://github.com/groeneai)).
* Fix `signed integer overflow` (undefined behavior) in `dateDiff` with `hour` and `minute` units on extreme `DateTime64` values close to the `Int64` range limits. [#108229](https://github.com/ClickHouse/ClickHouse/pull/108229) ([Groene AI](https://github.com/groeneai)).
* Fix `Too many marks` for a text index on an empty merged part. [#106867](https://github.com/ClickHouse/ClickHouse/pull/106867) ([Azat Khuzhin](https://github.com/azat)).
* Fix a `LOGICAL_ERROR` ("Unexpected return type from if") when reading a column under `apply_mutations_on_fly = 1` after an `ALTER UPDATE col = ... WHERE <cond>` with a non-constant or false condition followed by `ALTER MODIFY COLUMN col <new type>`. [#108128](https://github.com/ClickHouse/ClickHouse/pull/108128) ([Groene AI](https://github.com/groeneai)).
* Fix a server abort (`Logical error` in `IColumn::insertFrom`) when casting an `Array(Dynamic)` or `Array(Variant)` to `QBit` with `accurateCastOrNull`, e.g. `accurateCastOrNull(CAST(range(114), 'Array(Dynamic)'), 'QBit(Float32, 114)')`. [#108288](https://github.com/ClickHouse/ClickHouse/pull/108288) ([Groene AI](https://github.com/groeneai)).
* Fixed a syntax error when an alias follows a subquery in `DESCRIBE TABLE (...) AS ...`. [#100205](https://github.com/ClickHouse/ClickHouse/pull/100205) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* `getClientHTTPHeader` is now correctly treated as non-deterministic, so its result is no longer incorrectly reused by the query result cache. [#108029](https://github.com/ClickHouse/ClickHouse/pull/108029) ([Alexey Milovidov](https://github.com/alexey-milovidov)).

#### Build/Testing/Packaging Improvement
* Build `delta-kernel-rs` with the `default-engine-native-tls` feature so that its own HTTP client (`reqwest`) can reuse the OpenSSL that ClickHouse already links in. This is only a partial `native-tls` enablement: `object_store` still forces `reqwest/rustls-tls-native-roots`, so `reqwest` ends up with both the `native-tls` and `rustls` backends. `delta-kernel-rs` remains disabled under MSan for now because `ring` is still compiled in via `object_store` (both transitively through `rustls` and directly for AWS request HMAC signing), and its hand-written assembly does not generate the symbols MSan requires (tracked upstream at [arrow-rs-object-store#585](https://github.com/apache/arrow-rs-object-store/pull/585)). [#96856](https://github.com/ClickHouse/ClickHouse/pull/96856) ([Austin Bonander](https://github.com/abonander)).
* Add PGO (Profile-Guided Optimization) and BOLT (Binary Optimization and Layout Tool) post-link optimization for the `clickhouse` binary. Profiles are collected from CI workloads and applied as a best-effort step during release builds — both stages fall back to non-optimized output if a profile is stale or incompatible. As of today, there are no benefits from PGO. [#100938](https://github.com/ClickHouse/ClickHouse/pull/100938) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Add `--storage` mode to `clickhouse keeper-bench` that benchmarks `KeeperStorage` in-process (no network, no raft, no state machine), using the same `setup`/`generator` config sections as the network mode. [#103081](https://github.com/ClickHouse/ClickHouse/pull/103081) ([Michael Kolupaev](https://github.com/al13n321)).
* Fix build with `ENABLE_AWS_S3=OFF`. [#105390](https://github.com/ClickHouse/ClickHouse/pull/105390) ([Yue Ni](https://github.com/niyue)).
* Update `mongo-cxx-driver` to r4.3.0. [#105522](https://github.com/ClickHouse/ClickHouse/pull/105522) ([Konstantin Bogdanov](https://github.com/thevar1able)).
* Fix build against RapidJSON. [#105674](https://github.com/ClickHouse/ClickHouse/pull/105674) ([Ilya Golshtein](https://github.com/ilejn)).
* Speed up the build by removing transitive includes from widely-used base/ headers and stripping unused code from the vendored `Poco/Logger.h`. [#105702](https://github.com/ClickHouse/ClickHouse/pull/105702) ([Raúl Marín](https://github.com/Algunenano)).
* Updated `libxml2` from 2.15.1 to 2.15.3. [#105985](https://github.com/ClickHouse/ClickHouse/pull/105985) ([Konstantin Bogdanov](https://github.com/thevar1able)).
* Use `expat` 2.8.1 inside Poco. [#105988](https://github.com/ClickHouse/ClickHouse/pull/105988) ([Konstantin Bogdanov](https://github.com/thevar1able)).
* Bump `thrift` to `v0.23.0`. [#105993](https://github.com/ClickHouse/ClickHouse/pull/105993) ([Konstantin Bogdanov](https://github.com/thevar1able)).
* Use `postgres` tag `REL_18_4`. [#105994](https://github.com/ClickHouse/ClickHouse/pull/105994) ([Konstantin Bogdanov](https://github.com/thevar1able)).
* Upgrade `krb5` to 1.22.2. [#106076](https://github.com/ClickHouse/ClickHouse/pull/106076) ([Konstantin Bogdanov](https://github.com/thevar1able)).
* Update bundled `curl` to 8.20.0. [#106077](https://github.com/ClickHouse/ClickHouse/pull/106077) ([Konstantin Bogdanov](https://github.com/thevar1able)).
* Bumped `mariadb-connector-c` to 3.1.29. All the ClickHouse-relevant patches preserved. [#106287](https://github.com/ClickHouse/ClickHouse/pull/106287) ([Nikita Mikhaylov](https://github.com/nikitamikhaylov)).
* Bump distroless base image digests for libssl3t64 CVE fixes. [#106360](https://github.com/ClickHouse/ClickHouse/pull/106360) ([Rahul Nair](https://github.com/motsc)).
* Use `wasmtime` v45.0.1. [#106836](https://github.com/ClickHouse/ClickHouse/pull/106836) ([Konstantin Bogdanov](https://github.com/thevar1able)).
* Bump `openssl` to 3.5.7. [#106844](https://github.com/ClickHouse/ClickHouse/pull/106844) ([Konstantin Bogdanov](https://github.com/thevar1able)).
* Distroless Docker build now also updates the `:X.Y-distroless` and `:X.Y.Z-distroless` floating tags, not just the full-version tag. [#106932](https://github.com/ClickHouse/ClickHouse/pull/106932) ([Rahul Nair](https://github.com/motsc)).
* Disable unused `curl` features, such as NTLM auth, cookies, alt-svc, HSTS, DNS-over-HTTPS, netrc, MIME, AWS SigV4. [#107226](https://github.com/ClickHouse/ClickHouse/pull/107226) ([Konstantin Bogdanov](https://github.com/thevar1able)).
* Updated `NuRaft` with a fix for a snapshot-install livelock that occurred when snapshot IO ran on a background thread. The `nuraft_use_bg_thread_for_snapshot_io` Keeper setting remains disabled by default; CI now randomizes it to cover both modes. [#107338](https://github.com/ClickHouse/ClickHouse/pull/107338) ([Antonio Andelic](https://github.com/antonio2368)).
* Fix building `abseil` when the ClickHouse checkout path contains a substring matching a header extension. [#107349](https://github.com/ClickHouse/ClickHouse/pull/107349) ([zhiqiang](https://github.com/zhiqiang-hhhh)).
* Determine the L2 cache size from `CPUID` on x86_64 instead of the glibc-specific `sysconf(_SC_LEVEL2_CACHE_SIZE)`, which is not available under musl libc. [#107469](https://github.com/ClickHouse/ClickHouse/pull/107469) ([Konstantin Bogdanov](https://github.com/thevar1able)).
* Increase the stack size for musl builds to 8 MiB to support deeply-nested queries. [#107470](https://github.com/ClickHouse/ClickHouse/pull/107470) ([Konstantin Bogdanov](https://github.com/thevar1able)).
* Derive the set of C library symbols localized in Rust static libraries from the actual reference libraries instead of a hand-maintained allowlist, so all compiler-rt builtins and platform libm functions are covered. [#107571](https://github.com/ClickHouse/ClickHouse/pull/107571) ([Raúl Marín](https://github.com/Algunenano)).
* Switch the distroless server and keeper images to `gcr.io/distroless/base-nossl-debian13` so they only ship the libraries ClickHouse actually links against and stop pulling in ones we statically link ourselves. [#107837](https://github.com/ClickHouse/ClickHouse/pull/107837) ([Rahul Nair](https://github.com/motsc)).
* Re-enable 50 stateless tests on macOS (`arm_darwin`) that were stale-skipped, and use `fsync` instead of `F_FULLFSYNC` for directory syncing on macOS. [#107887](https://github.com/ClickHouse/ClickHouse/pull/107887) ([Raúl Marín](https://github.com/Algunenano)).

###  ClickHouse release 26.5, 2026-05-21. [Presentation](https://presentations.clickhouse.com/2026-release-26.5/), [Video](https://www.youtube.com/watch?v=P1IDAvsi7p8)

#### Backward Incompatible Change
* Changed defaults of `date_time_input_format` and `cast_string_to_date_time_mode` from `basic` to `best_effort`. Queries that previously failed to parse non-basic datetime strings (e.g. `2024 April 4`, `Apr 15, 2020 10:30:00`) may now succeed by default. To keep the old strict parsing behavior, set these settings to `basic` (or use `compatibility`). [#89334](https://github.com/ClickHouse/ClickHouse/pull/89334) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Tuple element name `null` is now forbidden because it conflicts with the subcolumn name used for Nullable null maps, causing ambiguous subcolumn resolution. [#98377](https://github.com/ClickHouse/ClickHouse/pull/98377) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Add a setting `dynamic_disk_allow_from_env`, `dynamic_disk_allow_from_zk`, `dynamic_disk_allow_include` to disallow usage of `from_env`, `from_zk`, `include` in dynamic disks. Backward Incompatible Change because prohibits by default the behaviour which used to be allowed by default. [#99138](https://github.com/ClickHouse/ClickHouse/pull/99138) ([Kseniia Sumarokova](https://github.com/kssenii)).
* You can no longer use the obsolete Arrow-based Parquet reader and writer. The native implementation will be used instead. [#100949](https://github.com/ClickHouse/ClickHouse/pull/100949) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* `SHOW CREATE TABLE t` now prefers the temporary table when both a permanent and a temporary table named `t` exist and no database is specified, matching the existing behavior of `DESCRIBE TABLE`. Additionally, `DESCRIBE TEMPORARY TABLE` syntax is now supported. [#100966](https://github.com/ClickHouse/ClickHouse/pull/100966) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Reduced default `http_max_fields` from 1,000,000 to 1,000 and `http_max_field_name_size` from 128 KB to 4 KB to limit pre-authentication memory usage by HTTP connections. Added `http_max_request_header_size` and `http_headers_read_timeout` settings. Users who rely on the previous higher limits can restore them via settings. [#103285](https://github.com/ClickHouse/ClickHouse/pull/103285) ([Sema Checherinda](https://github.com/CheSema)).
* Added a `histograms` nested column to `system.metric_log` that snapshots every registered histogram metric per row, with a new `system_metric_log_show_zero_values_in_histograms` setting to control zero-value emission. Deprecates the `system.histogram_metric_log` table. [#103770](https://github.com/ClickHouse/ClickHouse/pull/103770) ([Miсhael Stetsyuk](https://github.com/mstetsyuk)).
* `CAST` to `DateTime` or `DateTime64` without an explicit time zone now preserves the time zone of its source argument (when the source is a `DateTime`/`DateTime64` with an explicit time zone), matching the behavior of the `toDateTime`/`toDateTime64` functions. Closes [#55072](https://github.com/ClickHouse/ClickHouse/issues/55072). [#104433](https://github.com/ClickHouse/ClickHouse/pull/104433) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Removed the `kql` table function. Use `SET dialect = 'kusto'` to run queries in the KQL dialect. [#105101](https://github.com/ClickHouse/ClickHouse/pull/105101) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* The window functions `RANK` and `DENSE_RANK` now reject arguments and throw `NUMBER_OF_ARGUMENTS_DOESNT_MATCH`, in line with the SQL standard. Previously, queries such as `RANK(x) OVER (ORDER BY id)` were silently accepted with the argument ignored. To restore the previous lenient behavior, set `allow_rank_dense_rank_arguments = 1`. Closes [#49526](https://github.com/ClickHouse/ClickHouse/issues/49526). [#104324](https://github.com/ClickHouse/ClickHouse/pull/104324) ([Groene AI](https://github.com/groeneai)).

#### New Feature
* Added a new setting `max_bytes_ratio_before_external_join`, mirroring `max_bytes_ratio_before_external_group_by` and `max_bytes_ratio_before_external_sort`. It expresses the spill-to-disk threshold for hash joins as a fraction of available memory; combined with the absolute `max_bytes_before_external_join`, the smaller resulting threshold applies. [#103862](https://github.com/ClickHouse/ClickHouse/pull/103862) ([Alexey Milovidov](https://github.com/alexey-milovidov)). The `new max_bytes_ratio_before_external_join` setting is now enabled by default at 0.5, mirroring `max_bytes_ratio_before_external_group_by` and `max_bytes_ratio_before_external_sort`. Hash joins automatically spill to grace hash join once the right-side data exceeds half of the available system memory (when memory limits are configured). [#104285](https://github.com/ClickHouse/ClickHouse/pull/104285) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Add table function `filesystem`. It allows to represent directory structure as a table, to query files' metadata and contents with SQL. Originally [#42039](https://github.com/ClickHouse/ClickHouse/pull/42039) by @perst20. See [#42039](https://github.com/ClickHouse/ClickHouse/issues/42039). See [#50208](https://github.com/ClickHouse/ClickHouse/issues/50208). [#53610](https://github.com/ClickHouse/ClickHouse/pull/53610) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Allow passing bare function names to higher-order functions like `arrayMap`, `arrayFilter`, etc. For example, `arrayMap(negate, [1, 2, 3])` is now equivalent to `arrayMap(x -> negate(x), [1, 2, 3])`. [#101033](https://github.com/ClickHouse/ClickHouse/pull/101033) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Add setting `send_table_structure_on_insert_with_inline_data` and `--inline-insert-data` client option to allow the server to parse inline INSERT data itself over the native protocol, avoiding the round-trip to receive table structure and improving performance for many small inserts. [#101034](https://github.com/ClickHouse/ClickHouse/pull/101034) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Add `tokenizeQuery` and `highlightQuery` functions for SQL query tokenization and syntax highlighting. `tokenizeQuery` returns lexer tokens with byte offsets and token types; `highlightQuery` returns parser-based syntax highlighting ranges with highlight categories (keyword, identifier, function, number, string, etc.). [#101054](https://github.com/ClickHouse/ClickHouse/pull/101054) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Add `url_base` setting to resolve relative URLs in the `url` table function and `URL` table engine, following RFC 3986 semantics. [#101113](https://github.com/ClickHouse/ClickHouse/pull/101113) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Support negative values in the `LIMIT BY` clause to select rows from the *end* of each group instead of the beginning. For example, `LIMIT -2 BY id` returns the last two rows per `id`. Negative offsets (`LIMIT -1 OFFSET -1 BY id`) and mixed signs (`LIMIT -2 OFFSET 1 BY id`) are supported as well. [#103222](https://github.com/ClickHouse/ClickHouse/pull/103222) ([Nihal Z. Miaji](https://github.com/nihalzp)).
* Support `json_value` function to output with `tuple` and `array` to improve performance of multiple json query. [#78362](https://github.com/ClickHouse/ClickHouse/pull/78362) ([kevinyhzou](https://github.com/KevinyhZou)). Support multi-path `Tuple`/`Array` JSONPath argument in `JSON_VALUE`, `JSON_EXISTS`, and `JSON_QUERY`, by @KevinyhZou. [#101102](https://github.com/ClickHouse/ClickHouse/pull/101102) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* A new `kafka_autodetect_client_rack` parameter is introduced. If set, discover the Availability Zone via cloud facilities and propagate it as the `client.rack` parameter of `librdkafka` to avoid cross-zone communications. [#81323](https://github.com/ClickHouse/ClickHouse/pull/81323) ([Ilya Golshtein](https://github.com/ilejn)).
* Add `Read` event type to `system.blob_storage_log` for tracking object storage read operations, controlled by new setting `enable_blob_storage_log_for_read_operations`. [#96867](https://github.com/ClickHouse/ClickHouse/pull/96867) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Users can now see ZooKeeper watches issued by `clickhouse-server` using the new `system.zookeeper_watches` table. [#99277](https://github.com/ClickHouse/ClickHouse/pull/99277) ([Den Kalantaevskii](https://github.com/Diskein)).
* Added `Shards` profile event that counts the number of shards involved in distributed queries, summed across all tables. [#99470](https://github.com/ClickHouse/ClickHouse/pull/99470) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* `WASM` UDFs can be declared `DETERMINISTIC` and become a subject of constant folding. [#100005](https://github.com/ClickHouse/ClickHouse/pull/100005) ([Vasily Chekalkin](https://github.com/bacek)).
* Add `parallel_replicas_prefer_local_replica` setting: when disabled, parallel replicas are selected purely by the load balancing algorithm, allowing even `max_parallel_replicas = 1` queries to be directed to another host. [#100139](https://github.com/ClickHouse/ClickHouse/pull/100139) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Add `{disk,storage,http}_connections_rcvbuf` and `{disk,storage,http}_connections_sndbuf` server settings to control TCP socket buffer sizes on outgoing HTTP connections, allowing operators to override kernel autotuning and cap per-connection memory usage. [#100478](https://github.com/ClickHouse/ClickHouse/pull/100478) ([Sema Checherinda](https://github.com/CheSema)).
* Support `CREATE OR REPLACE MATERIALIZED VIEW` with the same atomic swap semantics as `CREATE OR REPLACE TABLE`. Works with inner tables, `TO` tables, `POPULATE`, `REFRESH`, and `ON CLUSTER`. [#100539](https://github.com/ClickHouse/ClickHouse/pull/100539) ([DQ](https://github.com/il9ue)).
* Add `s3_read_request_duration_microseconds` and `s3_read_request_bytes` histogram metrics to observe S3 GET request connection lifetime and bytes consumed, visible in `system.histogram_metrics` and the Prometheus endpoint. [#102058](https://github.com/ClickHouse/ClickHouse/pull/102058) ([Sema Checherinda](https://github.com/CheSema)).
* Add `Paimon`, `PaimonS3`, `PaimonAzure`, `PaimonHDFS`, and `PaimonLocal` table engines with incremental read support backed by Keeper snapshot progress tracking. Incremental mode returns only new rows since the last committed snapshot. Targeted snapshot delta reads are available via `paimon_target_snapshot_id`, and per-query snapshot caps via `max_consume_snapshots`. Background metadata refresh is configurable with `paimon_metadata_refresh_interval_sec`. Gated by `allow_experimental_paimon_storage_engine`. [#102343](https://github.com/ClickHouse/ClickHouse/pull/102343) ([XiaoBinMu](https://github.com/Binnn-MX)).
* Added a new Kafka table setting `kafka_map_virtual_columns_on_write`. When enabled, columns named `_key`, `_timestamp`, `_headers.name` and `_headers.value` in the Kafka table schema are produced as the corresponding Kafka message key, timestamp and headers on `INSERT`, and are excluded from the message payload. [#103243](https://github.com/ClickHouse/ClickHouse/pull/103243) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Added `SYSTEM PAUSE VIEW [db.]name` and `SYSTEM PAUSE VIEWS` queries for refreshable materialized views. Unlike `SYSTEM STOP VIEW`, `SYSTEM PAUSE VIEW` does not interrupt the currently running refresh — the in-flight refresh is allowed to complete and only subsequent refreshes are prevented. Undone by `SYSTEM START VIEW` or `SYSTEM START VIEWS`, which now uniformly clear both the stopped and paused states. [#103252](https://github.com/ClickHouse/ClickHouse/pull/103252) ([Nikita Mikhaylov](https://github.com/nikitamikhaylov)).
* Added function `regexpPosition` (with PostgreSQL-compatible aliases `regexpInstr` and `regexp_instr`) that returns the byte position of the N-th regex match in a string. Supports start offset, return-after-match mode, regex flags, and capture-group selection. [#104172](https://github.com/ClickHouse/ClickHouse/pull/104172) ([Abhinav Agarwal](https://github.com/aagarwal-gtr)).
* New functions `isPrime` and `isProbablePrime` for primality checks. `isPrime` returns an exact result for unsigned integers up to `UInt64`. `isProbablePrime` also supports `UInt128` and `UInt256`; for those wider types, `0` means definitely composite and `1` means probably prime. The optional second argument of `isProbablePrime`, `rounds`, controls the confidence (capped at `256`); the default of `25` rounds bounds the false-positive rate for a random composite below `10^-15`, and `isProbablePrime` is cancellable. [#104234](https://github.com/ClickHouse/ClickHouse/pull/104234) ([Nihal Z. Miaji](https://github.com/nihalzp)). [#104639](https://github.com/ClickHouse/ClickHouse/pull/104639) ([Alexey Milovidov](https://github.com/alexey-milovidov)). [#104806](https://github.com/ClickHouse/ClickHouse/pull/104806) ([Nihal Z. Miaji](https://github.com/nihalzp)).
* `clear` and `/clear` now clear the terminal in the clickhouse command-line tools instead of running as a mistaken query. [#104318](https://github.com/ClickHouse/ClickHouse/pull/104318) ([Tyler Hannan](https://github.com/tylerhannan)).
* Allow the `file` table function to accept an `Array(String)` of paths in `SELECT` queries. [#104442](https://github.com/ClickHouse/ClickHouse/pull/104442) ([Yue](https://github.com/niyue)).
* Add `deterministic` and `higher_order` columns to `system.functions` table. [#104479](https://github.com/ClickHouse/ClickHouse/pull/104479) ([Pedro Ferreira](https://github.com/PedroTadim)).
* Add an optional encoding variant parameter to `bech32Encode` (`bech32` / `bech32m`) and a raw decode mode to `bech32Decode` for non-SegWit address encoding (e.g. Cosmos SDK, Injective, Osmosis). [#98986](https://github.com/ClickHouse/ClickHouse/pull/98986) ([Yash ](https://github.com/Onyx2406)).
* You can now write data in `AvroConfluent` format, which was previously input-only. This enables producing Confluent Schema Registry-framed Avro messages directly from ClickHouse, for example when writing to Kafka. The schema is automatically registered with the registry. Use the new `output_format_avro_confluent_subject` setting to specify the subject name. [#101935](https://github.com/ClickHouse/ClickHouse/pull/101935) ([János Benjamin Antal](https://github.com/antaljanosbenjamin)).
* Added the `prettyPrintJSON` function to format a JSON string into a human-readable form. Useful for dashboards or reports where prettifying previously required an extra step on the client side. Closes [#62523](https://github.com/ClickHouse/ClickHouse/issues/62523). [#102594](https://github.com/ClickHouse/ClickHouse/pull/102594) ([Dmitry Prokofyev](https://github.com/prokofyevDmitry)).
* Added `STRING_AGG` as a case-insensitive alias of `groupConcat` for PostgreSQL / SQL-standard compatibility. [#105125](https://github.com/ClickHouse/ClickHouse/pull/105125) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Individual subquery results can now be cached independently using `SETTINGS use_query_cache = true` on specific subqueries, without caching the entire outer query. A new setting `query_cache_for_subqueries = true` enables bulk propagation of `use_query_cache` into all subqueries. Note: `use_query_cache` on the outer query no longer auto-propagates to subqueries. [#99804](https://github.com/ClickHouse/ClickHouse/pull/99804) ([Vincent Voyer](https://github.com/vvo)).
* Added lexer-based syntax highlighting to the query editor in the Web UI (`play.html`), modelled after `clickhouse-client` colors. [#105105](https://github.com/ClickHouse/ClickHouse/pull/105105) ([Alexey Milovidov](https://github.com/alexey-milovidov)).

#### Experimental Feature
* Added an experimental web terminal interface at `/webterminal` that provides an interactive `clickhouse-client` session in the browser over WebSocket. Disabled by default; enable with the `allow_experimental_webterminal` server setting. See it [here](https://play.clickhouse.com/webterminal?user=play). [#100277](https://github.com/ClickHouse/ClickHouse/pull/100277) ([Alexey Milovidov](https://github.com/alexey-milovidov)). [#105191](https://github.com/ClickHouse/ClickHouse/pull/105191) ([Alexey Milovidov](https://github.com/alexey-milovidov)). [#105059](https://github.com/ClickHouse/ClickHouse/pull/105059) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* The `Kafka2` engine (experimental, with Keeper-based offset storage) now supports direct `SELECT` queries and the `kafka_commit_on_select` setting. [#100276](https://github.com/ClickHouse/ClickHouse/pull/100276) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* `WASM` UDFs can now coerce more numeric types: smaller integers to wider integers (e.g. `Int8` to `UInt64`), and any integer to floating point (e.g. `Int32` to `Float32`). [#100435](https://github.com/ClickHouse/ClickHouse/pull/100435) ([Vasily Chekalkin](https://github.com/bacek)).
* Support `LIKE` function in `DELETE FROM system.webassembly_modules` query. [#104397](https://github.com/ClickHouse/ClickHouse/pull/104397) ([Vladimir Cherkasov](https://github.com/vdimir)).
* Support geo types for `Iceberg`. [#103113](https://github.com/ClickHouse/ClickHouse/pull/103113) ([Konstantin Vedernikov](https://github.com/scanhex12)).
* Add prepared statements functionality to ArrowFlight SQL server. [#103047](https://github.com/ClickHouse/ClickHouse/pull/103047) ([Yakov Olkhovskiy](https://github.com/yakov-olkhovskiy)).
* Improved KQL parser (for the Kusto language support) robustness by preserving parser depth and backtracks counters across KQL parser stages, so parser limits are tracked consistently for complex KQL queries. [#103528](https://github.com/ClickHouse/ClickHouse/pull/103528) ([Yakov Olkhovskiy](https://github.com/yakov-olkhovskiy)).

#### Performance Improvement
* Reuse the Parquet footer metadata cache when reading local Parquet files via the `file` table function or `File` table engine. Previously the cache was only consulted for object-storage backends. [#104260](https://github.com/ClickHouse/ClickHouse/pull/104260) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Push `ORDER BY ... LIMIT n` through `LEFT`/`RIGHT` joins when the sort key only references columns from the side preserved by the join, restricting how many rows the preserved-side input must produce before joining. Controlled by the new setting `query_plan_top_k_through_join` (default enabled). [#104268](https://github.com/ClickHouse/ClickHouse/pull/104268) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Enable `use_top_k_dynamic_filtering` and `use_skip_indexes_for_top_k` settings by default to improve performance of `ORDER BY ... LIMIT N` queries. [#99537](https://github.com/ClickHouse/ClickHouse/pull/99537) ([Alexey Milovidov](https://github.com/alexey-milovidov)). Restrict `use_top_k_dynamic_filtering` to fixed-length sort columns by default, avoiding regressions on `ORDER BY <var-length-column> LIMIT N` queries where the per-row threshold comparison cost exceeds the I/O savings. The previous behavior is available via the new `use_top_k_dynamic_filtering_for_variable_length_types` setting. [#104216](https://github.com/ClickHouse/ClickHouse/pull/104216) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Use the oversize-arena feature of `jemalloc` to reduce page faults. [#103958](https://github.com/ClickHouse/ClickHouse/pull/103958) ([Nikita Taranov](https://github.com/nickitat)).
* Limit simultaneously active streams in `UNION ALL` to reduce peak memory usage. [#100176](https://github.com/ClickHouse/ClickHouse/pull/100176) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Slightly optimize the userspace page cache. [#100300](https://github.com/ClickHouse/ClickHouse/pull/100300) ([Alexey Milovidov](https://github.com/alexey-milovidov)). Now the userspace page cache is always better than the OS page cache.
* Cold reads of object storage through the userspace page cache (`use_page_cache_for_object_storage = 1`) are now significantly faster, because consecutive cache misses are coalesced into a single HTTP request instead of one request per `page_cache_block_size` block. [#104230](https://github.com/ClickHouse/ClickHouse/pull/104230) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Speed up the index analysis involving type casting and function application. Closes [#55653](https://github.com/ClickHouse/ClickHouse/issues/55653). [#100366](https://github.com/ClickHouse/ClickHouse/pull/100366) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Speed up huge queries on `Merge` tables over a huge number of underlying tables. Closes [#32465](https://github.com/ClickHouse/ClickHouse/issues/32465). [#100369](https://github.com/ClickHouse/ClickHouse/pull/100369) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Remove vtable from setting field types, reducing `Settings` copy size by ~28x and improving cache locality via typed-array layout for all settings types. [#102269](https://github.com/ClickHouse/ClickHouse/pull/102269) ([Raúl Marín](https://github.com/Algunenano)).
* Add `max_threads_min_free_memory_per_thread` and `max_insert_threads_min_free_memory_per_thread` settings to automatically reduce query parallelism when the server is low on free memory. [#100383](https://github.com/ClickHouse/ClickHouse/pull/100383) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Reduce memory usage on low-memory systems (< 4 GiB). [#100389](https://github.com/ClickHouse/ClickHouse/pull/100389) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Added `OptimizeTrivialGroupByLimitPass`. For trivial `SELECT ... FROM t GROUP BY k LIMIT n` queries (no `HAVING`, `ORDER BY`, or window functions), the analyzer now sets `max_rows_to_group_by = n + offset` with `group_by_overflow_mode = 'any'`, so aggregation stops once `n` distinct keys have been produced instead of grouping the entire input. Controlled by the new setting `optimize_trivial_group_by_limit_query` (enabled by default). [#104473](https://github.com/ClickHouse/ClickHouse/pull/104473) ([Amos Bird](https://github.com/amosbird)) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Granule-level implicit min-max index for the `_part_offset` and `_block_number` virtual columns, including for projections. Enables fast pruning of granules based on virtual column predicates. [#103952](https://github.com/ClickHouse/ClickHouse/pull/103952) ([Mikhail Artemenko](https://github.com/Michicosun)). [#104746](https://github.com/ClickHouse/ClickHouse/pull/104746) ([Mikhail Artemenko](https://github.com/Michicosun)). [#105137](https://github.com/ClickHouse/ClickHouse/pull/105137) ([Mikhail Artemenko](https://github.com/Michicosun)).
* For the `prealloc_serialized` family of aggregation methods, precompute per-row hashes during the batch-serialization pass and use them to (a) skip rehashing in `emplaceKey`/`findKey` and (b) software-prefetch the next row's bucket. Speeds up multi-key string/serialized aggregation by hiding hash-table cache-miss latency. [#104475](https://github.com/ClickHouse/ClickHouse/pull/104475) ([Amos Bird](https://github.com/amosbird)) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Query condition cache for `Iceberg` tables. [#102115](https://github.com/ClickHouse/ClickHouse/pull/102115) ([Konstantin Vedernikov](https://github.com/scanhex12)).
* Optimize `cramersV`, `cramersVBiasCorrected`, `theilsU`, and `contingency` when used with window functions. Closes [#83521](https://github.com/ClickHouse/ClickHouse/issues/83521). [#93384](https://github.com/ClickHouse/ClickHouse/pull/93384) ([Nihal Z. Miaji](https://github.com/nihalzp)).
* Added a query optimization that rewrites `tupleElement(dictGet('dict', ('a', 'b', 'c'), key), N)` into `dictGet('dict', 'a', key)`, avoiding fetching unnecessary dictionary attributes. Controlled by the `optimize_dictget_tuple_element` setting (enabled by default). [#100186](https://github.com/ClickHouse/ClickHouse/pull/100186) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Enable buffering for sorting steps on the initiator for distributed queries with sorting. [#100661](https://github.com/ClickHouse/ClickHouse/pull/100661) ([Nikita Taranov](https://github.com/nickitat)).
* Performance improvement for `partial_merge` JOIN. [#100945](https://github.com/ClickHouse/ClickHouse/pull/100945) ([Artem Zuikov](https://github.com/4ertus2)).
* Slightly reduced memory over-allocation in `partial_merge` JOIN. [#100963](https://github.com/ClickHouse/ClickHouse/pull/100963) ([Artem Zuikov](https://github.com/4ertus2)).
* Optimize allocations/deallocations by caching sampling settings instead of traversing the entire memory-tracker hierarchy. [#101267](https://github.com/ClickHouse/ClickHouse/pull/101267) ([Azat Khuzhin](https://github.com/azat)).
* Reduce memory allocation overhead during S3 multipart uploads by preallocating internal tracking containers. [#101799](https://github.com/ClickHouse/ClickHouse/pull/101799) ([Gagan Dhakrey](https://github.com/gagandhakrey)).
* Add software prefetch in hash join probe phase to reduce memory access latency for large hash tables, controlled by setting `enable_software_prefetch_in_join`. [#102444](https://github.com/ClickHouse/ClickHouse/pull/102444) ([Xiaozhe Yu](https://github.com/wudidapaopao)).
* Optimize `MemoryTracker` layout, improving its performance by ~25%. [#103464](https://github.com/ClickHouse/ClickHouse/pull/103464) ([Azat Khuzhin](https://github.com/azat)).
* Rewrite `coalesce(a, b, ...) <op> const` and `ifNull(a, b) <op> const` predicates before index analysis so per-column primary key and skip indexes on each argument can prune granules. Controlled by the new setting `allow_key_condition_coalesce_rewrite` (on by default). [#103468](https://github.com/ClickHouse/ClickHouse/pull/103468) ([Manuel](https://github.com/raimannma)).
* Significantly improved query performance when reading Iceberg catalogs with large JSON metadata files by optimizing escaped slash processing. [#103998](https://github.com/ClickHouse/ClickHouse/pull/103998) ([Mohaidoss](https://github.com/mohaidoss)).
* Avoid index uncompressed cache overhead when the cache is disabled (server setting `index_uncompressed_cache_size = 0`, which is the default). [#104063](https://github.com/ClickHouse/ClickHouse/pull/104063) ([Michael Kolupaev](https://github.com/al13n321)).
* Fix `ORDER BY ... LIMIT` queries with small limit reading excessive granules when combined with a non-selective `WHERE` filter. Previously, any filter above an in-order read disabled the per-mark-range task split, so the pipeline could not cancel between granules and read the whole part for each stream. [#104112](https://github.com/ClickHouse/ClickHouse/pull/104112) ([Vladimir Cherkasov](https://github.com/vdimir)).
* Fixed missing hash table sizes cache reuse after reordering JOIN sides. [#104131](https://github.com/ClickHouse/ClickHouse/pull/104131) ([Nikita Taranov](https://github.com/nickitat)).
* When `fsync_after_insert` is enabled, fsync of part files is now performed in parallel using the IO thread pool, speeding up insert finalization on wide tables. The full ClickBench `hits` load is about 22% faster. [#104137](https://github.com/ClickHouse/ClickHouse/pull/104137) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Vectorise `find_first_symbols`, `find_first_not_symbols`, `find_last_symbols_or_null`, `find_last_not_symbols_or_null`, and `splitInto` on AArch64 using NEON. Previously these helpers had a SIMD path only on x86 (SSE2 / SSE4.2) and fell through to a scalar loop on ARM. Speeds up TSV parsing by ~2x, URL functions and `splitByChar` by ~1.3x on the ClickBench `hits` dataset; very dense JSON parsing (sub-16-byte field cadence) regresses slightly in line with the existing SSE2 trade-off. [#104228](https://github.com/ClickHouse/ClickHouse/pull/104228) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Reading data through a trivial `ALIAS` column (e.g. `some_alias['key']` where `some_alias ALIAS m`) now goes through the same per-subcolumn read path as referencing the underlying column directly, restoring large I/O savings for `Map`, `Array`, `Tuple` and `Nullable` aliased columns. [#104245](https://github.com/ClickHouse/ClickHouse/pull/104245) ([Raúl Marín](https://github.com/Algunenano)).
* Reduced lock contention on the asynchronous remote-FS read path by making the per-query `AsyncReadCounters` lockless. [#104374](https://github.com/ClickHouse/ClickHouse/pull/104374) ([Nikita Mikhaylov](https://github.com/nikitamikhaylov)).
* Slightly better query plan for projections in-order scan. [#103723](https://github.com/ClickHouse/ClickHouse/pull/103723) ([Mikhail Artemenko](https://github.com/Michicosun)).
* Extend `optimizeUseNormalProjections` to also handle a specific case where nothing was filtered but the projection's sorting key can remove the sorting step from the query plan. [#104680](https://github.com/ClickHouse/ClickHouse/pull/104680) ([Mikhail Artemenko](https://github.com/Michicosun)).
* Allow `json.path[]` syntax sugar and explicit type hints to work correctly on typed `JSON` paths. [#99179](https://github.com/ClickHouse/ClickHouse/pull/99179) ([Pavel Kruglov](https://github.com/Avogar)).
* Optimize `json.path[N].nested.path` (which expands to `tupleElement(tupleElement(json.path[N], 'nested'), 'path')`) into `json.path[].nested.path[N]`, which reads much less data. [#99802](https://github.com/ClickHouse/ClickHouse/pull/99802) ([Pavel Kruglov](https://github.com/Avogar)).
* Optimize `SHOW TABLES` access checks in `system.parts` by hoisting database-level grant checks out of the per-table loop. [#100860](https://github.com/ClickHouse/ClickHouse/pull/100860) ([Shaohua Wang](https://github.com/tiandiwonder)).
* Remove a redundant per-table `SHOW TABLES` access check in the `SELECT name` / `SELECT database, name` fast path of `system.tables`. [#100881](https://github.com/ClickHouse/ClickHouse/pull/100881) ([Shaohua Wang](https://github.com/tiandiwonder)).
* Enable JIT compilation on macOS. [#100947](https://github.com/ClickHouse/ClickHouse/pull/100947) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Skip deferring the row policy after `FINAL` when it depends only on sorting-key columns and is deterministic, and skip the corresponding `PREWHERE` deferral that the row policy was forcing in that case. [#102884](https://github.com/ClickHouse/ClickHouse/pull/102884) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* Added support for `hasAny` and `hasAll` as filter predicates in text indexes. [#103266](https://github.com/ClickHouse/ClickHouse/pull/103266) ([Anton Popov](https://github.com/CurtizJ)).
* Route long-lived MergeTree heap state (per-part and per-table metadata) to a dedicated jemalloc arena, exposed via `jemalloc.mergetree_arena.*` async metrics. Reduces default-arena fragmentation in steady-state and keeps per-part survivors from pinning otherwise-decayable pages. [#104136](https://github.com/ClickHouse/ClickHouse/pull/104136) ([Raúl Marín](https://github.com/Algunenano)).
* Improve ZooKeeper client timeout handling under heavy load when many requests are pipelined on a single session. The ZooKeeper client now uses a progress-based timeout: as long as any data is received from the server within `session_timeout_ms`, the wait is extended. A hard cap of `3 * session_timeout_ms` per request still bounds caller latency. Closes [#100466](https://github.com/ClickHouse/ClickHouse/issues/100466). [#104351](https://github.com/ClickHouse/ClickHouse/pull/104351) ([Antonio Andelic](https://github.com/antonio2368)).
* Move per-event trace flags into a separate array and allocate them lazily, reducing the overhead of `ProfileEvents` tracing. [#105030](https://github.com/ClickHouse/ClickHouse/pull/105030) ([Azat Khuzhin](https://github.com/azat)).
* Add `compareTrackAt` for `ColumnDecimal`, improving comparison performance for `Decimal` columns. [#105110](https://github.com/ClickHouse/ClickHouse/pull/105110) ([Artem Zuikov](https://github.com/4ertus2)).
* Added a SIMD implementation of `MD5` (`AVX2` / `AVX512`) that hashes multiple inputs in parallel, improving throughput. [#105161](https://github.com/ClickHouse/ClickHouse/pull/105161) ([Joanna Hulboj](https://github.com/jh0x)).

#### Improvement
* Improve the help output for all ClickHouse applications: `--help` now consistently returns exit code `0`, prints to `stdout`, and a top-level `clickhouse --help` lists all subcommands. Adds a `--no-sudo` option for `clickhouse start` / `restart` (useful in Docker), and a `clickhouse help` subcommand. Continuation of [#58244](https://github.com/ClickHouse/ClickHouse/issues/58244) from @qoega. [#98148](https://github.com/ClickHouse/ClickHouse/pull/98148) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* The default of `input_format_column_name_matching_mode` is changed from `match_case` to `auto`. Input formats that match input column names against the table schema (`JSONEachRow`, `CSVWithNames`, `JSONColumns`, `BSONEachRow`, `RowBinaryWithNames`, etc.) now first try a case-sensitive match and fall back to case-insensitive matching when the case-sensitive match misses. The previous strict behavior is preserved under `compatibility`. [#104320](https://github.com/ClickHouse/ClickHouse/pull/104320) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Added `STDDEV` as a case-insensitive alias of `stddevSamp` for PostgreSQL/SQL-standard compatibility. [#105120](https://github.com/ClickHouse/ClickHouse/pull/105120) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Added `array_to_string` as a case-insensitive alias of `arrayStringConcat` for PostgreSQL compatibility. [#105121](https://github.com/ClickHouse/ClickHouse/pull/105121) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Added `unnest` as a case-insensitive alias of `arrayJoin` for PostgreSQL compatibility (function-call form). [#105124](https://github.com/ClickHouse/ClickHouse/pull/105124) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* The progress bar in `clickhouse-client` now shows temporary data on disk usage (e.g. for external sort, aggregation, or JOIN) next to RAM, including a per-host breakdown for distributed queries. [#105190](https://github.com/ClickHouse/ClickHouse/pull/105190) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Added `system.predicate_statistics_log`, a new sampled log of predicate filter selectivity and MergeTree index-granule pruning per query. Disabled by default; enable via the `predicate_statistics_sample_rate` server setting. Needed for automatic index and projection recommendations. [#98727](https://github.com/ClickHouse/ClickHouse/pull/98727) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* Allow skipping local shard with missing table when `skip_unavailable_shards` is enabled. [#100141](https://github.com/ClickHouse/ClickHouse/pull/100141) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Add startup warnings (visible in `system.warnings`) when a Linux mdraid array is being resynchronized or is in a degraded state, as both can affect disk I/O performance or indicate disk failures. [#100941](https://github.com/ClickHouse/ClickHouse/pull/100941) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* WASM UDFs now appear in `system.functions` with correct `origin` (`WasmUserDefined`), `syntax`, `arguments`, and `returned_value` columns populated from their ClickHouse type metadata. Previously they were either missing or listed with the wrong origin as duplicates. [#101053](https://github.com/ClickHouse/ClickHouse/pull/101053) ([Vasily Chekalkin](https://github.com/bacek)).
* The `generate_series` table function now supports negative step values for generating descending sequences, e.g. `SELECT * FROM generate_series(99, 0, -1)`. [#101056](https://github.com/ClickHouse/ClickHouse/pull/101056) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix `Context has expired` exceptions raised by some functions (`dotProduct`, `formatRow`, `structureToCapnProtoSchema`/`structureToProtobufSchema`, user-defined functions) when used in deferred execution paths such as `DEFAULT`/`MATERIALIZED` expressions and table engine settings, by ensuring those functions hold a strong context where required. [#101109](https://github.com/ClickHouse/ClickHouse/pull/101109) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix spurious `Cache limits violated` logical errors on priorities created with zero limits (such as the per-query filesystem cache priority used when `enable_filesystem_query_cache_limit` is on). [#101428](https://github.com/ClickHouse/ClickHouse/pull/101428) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Auto-detect the region for `s3express` endpoints. [#101520](https://github.com/ClickHouse/ClickHouse/pull/101520) ([Pradeep Chhetri](https://github.com/chhetripradeep)).
* Support field ids for data files in `Iceberg` writes. Closes [#102322](https://github.com/ClickHouse/ClickHouse/issues/102322). [#102362](https://github.com/ClickHouse/ClickHouse/pull/102362) ([Konstantin Vedernikov](https://github.com/scanhex12)).
* The left panel in the web UI (`play.html`) now scrolls independently, stays visible when the page is scrolled, and clicking a table scrolls to the query area. [#102498](https://github.com/ClickHouse/ClickHouse/pull/102498) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Allow opening the Play UI in a new tab via Ctrl/Cmd/Shift+click or middle-click on the ClickHouse logo in the left panel. [#102501](https://github.com/ClickHouse/ClickHouse/pull/102501) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* New metrics to track memory used by projection primary keys and projection index granularity across all tables. [#102587](https://github.com/ClickHouse/ClickHouse/pull/102587) ([Narasimha Pakeer](https://github.com/npakeer)).
* Apply `max_network_bandwidth_for_user` and `max_network_bandwidth_for_all_users` to remote filesystem reads/writes. [#103080](https://github.com/ClickHouse/ClickHouse/pull/103080) ([Azat Khuzhin](https://github.com/azat)).
* Improve the resilience of backups when Refreshable Materialized Views are constantly refreshed by making decisions based on the snapshotted tables' state rather than a global one. [#103384](https://github.com/ClickHouse/ClickHouse/pull/103384) ([Nikita Mikhaylov](https://github.com/nikitamikhaylov)).
* `SELECT * FROM system.databases` now always lists data lake catalog databases regardless of the `show_data_lake_catalogs_in_system_tables` setting. Previously they were hidden by default, which was inconsistent with `SHOW DATABASES` that always showed them. [#103444](https://github.com/ClickHouse/ClickHouse/pull/103444) ([Alsu Giliazova](https://github.com/alsugiliazova)).
* Align the default of the server setting `concurrent_threads_soft_limit_ratio_to_cores` in code with the shipped `config.xml` value (`2`), so the default `max_min_fair` concurrent threads scheduler caps query processing threads at 2x cores out of the box even when the shipped `config.xml` is not used. [#103446](https://github.com/ClickHouse/ClickHouse/pull/103446) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Improved sanitizer robustness in parser and string-function edge cases by handling empty input in `getURLScheme`, avoiding null-pointer arithmetic in `Lexer::nextToken` `max_query_size` checks, and short-circuiting UTF-8 subsequence evaluation on empty haystacks before decoding. [#103489](https://github.com/ClickHouse/ClickHouse/pull/103489) ([Yakov Olkhovskiy](https://github.com/yakov-olkhovskiy)).
* Improved correctness of monotonicity inference for `divide(0, x)` and `intDiv(0, x)`: previously the functions were unconditionally reported as monotonic, but `0 / x` is non-monotonic on any range that includes 0 because `0 / 0` is undefined (`NaN`/`Inf` for `divide`, division-by-zero exception for `intDiv`). The false claim caused `KeyCondition::applyMonotonicFunctionsChainToRange` to produce ranges with `left > right`, which tripped a `LOGICAL_ERROR` `Invalid binary search result in MergeTreeSetIndex` in debug builds when an `IN` / `NOT IN` expression on the primary key wrapped the key in `divide(0, key)` or `intDiv(0, key)`. Release builds were unaffected — the assertion is gated by `#ifndef NDEBUG`. [#103621](https://github.com/ClickHouse/ClickHouse/pull/103621) ([Groene AI](https://github.com/groeneai)).
* Replace the `HTTPConnectionPool*TCP{Rcv,Snd}BufBytes_{p50,p75,p90,p95}` async metrics with a bucket-based histogram `http_pool_tcp_buf_bytes` (labels `group`, `direction`) in `system.histogram_metrics`. Per-group total async metrics are preserved. [#103704](https://github.com/ClickHouse/ClickHouse/pull/103704) ([Sema Checherinda](https://github.com/CheSema)).
* The server settings `{disk,storage,http}_connections_{rcvbuf,sndbuf}` are now reported as changeable without restart in `system.server_settings`. Their values can be updated via `SYSTEM RELOAD CONFIG`; the runtime application path was already in place since [#100478](https://github.com/ClickHouse/ClickHouse/issues/100478). [#103772](https://github.com/ClickHouse/ClickHouse/pull/103772) ([Sema Checherinda](https://github.com/CheSema)).
* Add support for resolved symbols (`Array(String)`) in `flameGraph`. [#103816](https://github.com/ClickHouse/ClickHouse/pull/103816) ([Azat Khuzhin](https://github.com/azat)).
* CLI client can now specify `<rainbow_parentheses>false</rainbow_parentheses>` in its config in environments where terminal colors clash with the parentheses (similarly, `clickhouse format` now has `--no_rainbow_parentheses`). [#103851](https://github.com/ClickHouse/ClickHouse/pull/103851) ([Larry Snizek](https://github.com/larry-cdn77)).
* Fix `MultiVolnitsky` UTF-8 case-insensitive search by rolling back partial `putNGram` inserts on failure and switching failed needles to fallback searchers, avoiding inconsistent state. [#103864](https://github.com/ClickHouse/ClickHouse/pull/103864) ([Yakov Olkhovskiy](https://github.com/yakov-olkhovskiy)).
* Implement `sched_getcpu` via `rseq` TLS in glibc-compatibility musl. [#104016](https://github.com/ClickHouse/ClickHouse/pull/104016) ([Azat Khuzhin](https://github.com/azat)).
* Replicated refreshable materialized view in APPEND mode will no longer refresh twice if connection to zookeeper was briefly lost during refresh. [#104051](https://github.com/ClickHouse/ClickHouse/pull/104051) ([Michael Kolupaev](https://github.com/al13n321)).
* Allow Distributed tables without an explicit column list to validate sharding keys against the inferred remote table structure. [#104111](https://github.com/ClickHouse/ClickHouse/pull/104111) ([Yue](https://github.com/niyue)).
* Fix REST catalog with `Azure` `abfss` path. [#104120](https://github.com/ClickHouse/ClickHouse/pull/104120) ([Konstantin Vedernikov](https://github.com/scanhex12)).
* Honor `role_arn` and `role_session_name` auth settings in the Keeper S3 snapshot client, allowing snapshot uploads to use STS `AssumeRole`-based authentication. [#104140](https://github.com/ClickHouse/ClickHouse/pull/104140) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix a memory leak when running queries with `MATERIALIZED` CTEs. [#104153](https://github.com/ClickHouse/ClickHouse/pull/104153) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix `lowerUTF8` / `upperUTF8` exception when processing large non-ASCII data sets (e.g. during text-index builds) where the accumulated output buffer would exceed 2 GiB; reject excessively long single rows with a clear error. [#104229](https://github.com/ClickHouse/ClickHouse/pull/104229) ([Shaohua Wang](https://github.com/tiandiwonder)).
* Harden MergeTree column-statistics loading against transient I/O failures to prevent permanently disabling statistics-based optimizations for affected parts. [#104372](https://github.com/ClickHouse/ClickHouse/pull/104372) ([zoomxi](https://github.com/zoomxi)).
* `INSERT INTO ... SELECT FROM input(...)` no longer requires the `CREATE TEMPORARY TABLE` grant. [#104470](https://github.com/ClickHouse/ClickHouse/pull/104470) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Added a new MergeTree setting `concurrent_part_removal_threshold_for_remote_disk` (default `16`) that is used instead of `concurrent_part_removal_threshold` when at least one part being removed is stored on a remote disk. The previous threshold of `100` could make `DROP TABLE` and other part-removal operations on object storage backends stall for tens of seconds because removals were performed serially even though each one is a separate network round-trip. The new setting causes the parallel removal path to be entered much sooner on remote storage, while leaving local-disk behavior unchanged. [#104676](https://github.com/ClickHouse/ClickHouse/pull/104676) ([Groene AI](https://github.com/groeneai)).
* New setting `defer_partition_pruning_after_final` (default `1`) makes the 26.3-introduced behavior of skipping partition pruning under `FINAL` opt-out. Set it to `0` to restore pre-26.3 partition pruning — substantially faster on event-log workloads where same-PK rows cannot span partitions. `compatibility = '26.2'` flips it to `0` automatically. [#104705](https://github.com/ClickHouse/ClickHouse/pull/104705) ([Nikita Fomichev](https://github.com/fm4v)).
* Fix `intExp2` returning wrong results for out-of-range inputs (shifts `>= 64` under JIT, and integers with magnitude exceeding `INT_MAX` on both code paths). [#105054](https://github.com/ClickHouse/ClickHouse/pull/105054) ([Raúl Marín](https://github.com/Algunenano)).
* Quote shell arguments built from CLI options and parsed input in `clickhouse install` and `clickhouse git-import` so paths, user/group names, and commit hashes containing whitespace or shell metacharacters are handled correctly. [#105232](https://github.com/ClickHouse/ClickHouse/pull/105232) ([Raúl Marín](https://github.com/Algunenano)).
* The `Alias` table engine is now non-experimental and available without the `allow_experimental_alias_table_engine` setting. [#103488](https://github.com/ClickHouse/ClickHouse/pull/103488) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Added `--queries-format` option to `clickhouse-benchmark` to choose between the default tab-escaped one-query-per-line input (`tsv`) and parsing standard input as a script of multiple queries separated by `;` (`script`). [#99972](https://github.com/ClickHouse/ClickHouse/pull/99972) ([Aleksandr Musorin](https://github.com/AVMusorin)).
* The element-wise tuple operators `tuplePlus`, `tupleMinus`, `tupleMultiply`, `tupleDivide`, `tupleModulo`, `tupleIntDiv`, and `tupleIntDivOrZero` are now variadic and accept two or more tuples of the same size, applied element-wise as a left-fold. They previously accepted exactly two arguments only. [#104659](https://github.com/ClickHouse/ClickHouse/pull/104659) ([Aruj Bansal](https://github.com/arujbansal)).
* Added a new built-in web UI at `/processors-profile` that visualizes the pipeline of any past `SELECT` query as a heatmap, sourced from `system.query_log` and `system.processors_profile_log`. Each processor is colored by its `elapsed_us` and shows per-processor stats (rows, bytes, wait times) on hover. [#104614](https://github.com/ClickHouse/ClickHouse/pull/104614) ([Nikita Mikhaylov](https://github.com/nikitamikhaylov)).
* Setting `query_plan_use_logical_join_step` (and its alias `query_plan_use_new_logical_join_step`) is now obsolete and has no effect; the logical join step is always used. [#104017](https://github.com/ClickHouse/ClickHouse/pull/104017) ([Vladimir Cherkasov](https://github.com/vdimir)).
* The `user` input on `play.html` and the other built-in web pages (`dashboard.html`, `jemalloc.html`, `merges.html`, `binary.html`, `webterminal.html`) is no longer pre-filled with the literal text `default`. It now shows a `user` placeholder hint and is empty by default. When left empty, the page does not send a `user=` URL parameter (and the WebTerminal auth JSON omits the `user` field), so the server applies its usual fallback to the `default` user — and HTTP credentials supplied via other channels (`X-ClickHouse-User`, HTTP Basic, per-handler `<handler><user>` configuration) are no longer overridden. [#105254](https://github.com/ClickHouse/ClickHouse/pull/105254) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* `ORC` reader: decouple offset-based read (`readBigAt`) from `use_prefetch`, so EC-encoded data on `HDFS` can be read correctly even when `use_prefetch = false` (e.g. by Gluten). [#103348](https://github.com/ClickHouse/ClickHouse/pull/103348) ([zhanglistar](https://github.com/zhanglistar)).
* Files downloaded from `play.html` with the `CSVWithNames` format now use the `.csv` file extension. [#103737](https://github.com/ClickHouse/ClickHouse/pull/103737) ([JackFielding](https://github.com/JackFielding)).
* More input validation for the BigLake catalog. [#105117](https://github.com/ClickHouse/ClickHouse/pull/105117) ([Konstantin Vedernikov](https://github.com/scanhex12)).

#### Bug Fix (user-visible misbehavior in an official stable release)
* Fix inconsistent formatting by remembering if an expression was parenthesized. [#92340](https://github.com/ClickHouse/ClickHouse/pull/92340) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix accurate comparison between Decimal and Float types. [#94293](https://github.com/ClickHouse/ClickHouse/pull/94293) ([zoomxi](https://github.com/zoomxi)).
* Allow positional arguments in distributed queries. [#94359](https://github.com/ClickHouse/ClickHouse/pull/94359) ([simonmichal](https://github.com/simonmichal)).
* Fix assertion failure in `DatabaseCatalog::updateDependencies` when dropping and recreating a materialized view with the same name; also fix view dependencies being silently lost during `RENAME TABLE` or `EXCHANGE TABLES` when referential dependencies were empty. [#98779](https://github.com/ClickHouse/ClickHouse/pull/98779) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fixed a server abort (assertion failure in `DatabaseCatalog::getTableImpl`) that occurred when creating a table via `ON CLUSTER` with a UUID identical to an existing database's UUID. [#98861](https://github.com/ClickHouse/ClickHouse/pull/98861) ([xiaohuanlin](https://github.com/xiaohuanlin)).
* Fixed usage of skip indexes on data read (with enabled setting `use_skip_indexes_on_data_read`) and existing patch parts created by lightweight updates. [#99543](https://github.com/ClickHouse/ClickHouse/pull/99543) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix "Not-ready Set" exception when a filter with `IN (subquery)` is moved to PREWHERE by the query optimizer. [#100375](https://github.com/ClickHouse/ClickHouse/pull/100375) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix "Cannot find column" error when combining `ADD COLUMN` with `RENAME COLUMN` in a single `ALTER TABLE` statement. [#100387](https://github.com/ClickHouse/ClickHouse/pull/100387) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix views with mixed `UNION` and `INTERSECT`/`EXCEPT` operators returning wrong results after `DETACH`/`ATTACH` or server restart. [#100390](https://github.com/ClickHouse/ClickHouse/pull/100390) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix "Trying to execute PLACEHOLDER action" exception that could occur during stress testing with the AST fuzzer when a correlated subquery appeared in an IN clause. [#100398](https://github.com/ClickHouse/ClickHouse/pull/100398) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix logical error exception when inserting into an Iceberg table with a `Date` column partitioned by `year`, `month`, or `day` transforms. [#100404](https://github.com/ClickHouse/ClickHouse/pull/100404) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix skip index being used with incompatible data after `ALTER TABLE MODIFY COLUMN` changes the column type, which could cause server crashes in sanitizer builds or incorrect query results. [#100526](https://github.com/ClickHouse/ClickHouse/pull/100526) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix credential leak in `query_log` for `paimonCluster`, `paimonS3Cluster`, `paimonAzureCluster`, and `deltaLakeS3` table functions. [#100529](https://github.com/ClickHouse/ClickHouse/pull/100529) ([JIaQi Tang](https://github.com/JiaQiTang98)).
* Fix `DROP TABLE` on Kafka engine tables potentially hanging indefinitely due to a deadlock in `rd_kafka_consumer_close`. [#100604](https://github.com/ClickHouse/ClickHouse/pull/100604) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Replace the hardcoded `source_table_engines` list with runtime lookup via `StorageFactory` and `DatabaseFactory`. Add `source_access_type` to `DatabaseFactory::EngineFeatures` so that `CREATE DATABASE` with source engines (PostgreSQL, MySQL, S3, etc.) requires the same source grants as `CREATE TABLE`. Fixes `GRANT TABLE ENGINE ON *` failing with `table_engines_require_grant=false`. Closes [#71544](https://github.com/ClickHouse/ClickHouse/issues/71544). [#100746](https://github.com/ClickHouse/ClickHouse/pull/100746) ([pufit](https://github.com/pufit)).
* Fix server crash when reading from a table whose `ALIAS` column contained a correlated subquery nested inside a function call (e.g. `ALIAS toString(intDivOrZero(x, (SELECT ...)))`). `CREATE TABLE` and `ALTER TABLE` now reject any subquery at any depth in `DEFAULT` / `ALIAS` / `MATERIALIZED` column expressions with `THERE_IS_NO_DEFAULT_VALUE`. Previously, the shallow validation accepted nested subqueries, so the correlated case crashed at read time and the nested non-correlated case appeared to work but could lead to unexpected behavior; both are now rejected at DDL time. [#100753](https://github.com/ClickHouse/ClickHouse/pull/100753) ([Groene AI](https://github.com/groeneai)).
* Fixed a server crash (`Logical error: Bad cast from type DB::FunctionNode to DB::ColumnNode`) that could occur when using queries with correlated subqueries on tables that have `CONSTRAINT ... ASSUME` definitions, when `optimize_substitute_columns` and `convert_query_to_cnf` settings are enabled. [#100756](https://github.com/ClickHouse/ClickHouse/pull/100756) ([Groene AI](https://github.com/groeneai)).
* Fix an exception that could occur when inserting a row into a JSON column where the row introduced a new dynamic field alongside a typed field with an incompatible value, and the column was subsequently used as a GROUP BY key. [#100758](https://github.com/ClickHouse/ClickHouse/pull/100758) ([Jimmy Aguilar Mena](https://github.com/Ergus)).
* Fix workload IO scheduling being silently bypassed for S3/object-storage writes that go through the `DiskObjectStorageTransaction` path (used by `s3_with_keeper` disks and explicitly when `use_fake_transaction=false`). Previously, INSERT writes into MergeTree tables on such disks ignored `CREATE RESOURCE` / `CREATE WORKLOAD` throttling because the resource link was never injected into `WriteSettings` for the transactional write path. [#100777](https://github.com/ClickHouse/ClickHouse/pull/100777) ([JIaQi Tang](https://github.com/JiaQiTang98)).
* Fix shared schema-cache collision between `Protobuf` and `ProtobufList`: reading a message first as `FORMAT Protobuf` and then as `FORMAT ProtobufList` could fail because `ProtobufList` forced the cached schema into its envelope form. `ProtobufList` now falls back to the cached message type when no envelope schema is available. [#100849](https://github.com/ClickHouse/ClickHouse/pull/100849) ([Callum Cooper](https://github.com/callumc34)).
* Fix heap-buffer-overflow in Rust CXX bridge due to `std::exception` ABI mismatch. [#100931](https://github.com/ClickHouse/ClickHouse/pull/100931) ([Azat Khuzhin](https://github.com/azat)).
* `FunctionVariantAdaptor` now throws `ILLEGAL_TYPE_OF_ARGUMENT` when all `Variant` alternatives are incompatible with a function, instead of silently returning `Nullable(Nothing)`. Previously, a `WHERE function(variant_col)` predicate where no alternative type was compatible would return 0 rows with no error, while the equivalent `SELECT` context already threw correctly. [#100939](https://github.com/ClickHouse/ClickHouse/pull/100939) ([Vasily Chekalkin](https://github.com/bacek)).
* `TRUNCATE ALL TABLES` no longer fails when the database contains views. [#100943](https://github.com/ClickHouse/ClickHouse/pull/100943) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix the `optimize_rewrite_array_exists_to_has` optimization to correctly handle type-incompatible cases (e.g. Date vs String) and re-enable it by default. [#100944](https://github.com/ClickHouse/ClickHouse/pull/100944) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix S3 settings priority so that `storage_configuration` disk settings override global `<s3>` section, and user/profile/query-level settings override both. [#100975](https://github.com/ClickHouse/ClickHouse/pull/100975) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix sparse serialization losing the sign of negative zero (-0.0) for BFloat16, Float32, and Float64 columns. [#100983](https://github.com/ClickHouse/ClickHouse/pull/100983) ([Takumi Hara](https://github.com/takumihara)).
* Fixed two bugs in the WKT geometry parser used when reading WKT-encoded GeoParquet and Arrow files: `MULTILINESTRING` geometries were incorrectly parsed as `Polygon` (causing an exception for typed columns and silent data corruption for mixed `Geometry` columns), and a malformed WKT string with no type keyword triggered undefined behaviour instead of a clean error. [#100997](https://github.com/ClickHouse/ClickHouse/pull/100997) ([Vasily Chekalkin](https://github.com/bacek)).
* Fix `grouping`/`GROUPING SETS` queries on Distributed tables with a single shard that failed with "Method executeImpl is not supported for 'grouping' function". [#101030](https://github.com/ClickHouse/ClickHouse/pull/101030) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix `LOGICAL_ERROR` "Column identifier is already registered" in the planner that could occur when the same table expression was processed multiple times. [#101048](https://github.com/ClickHouse/ClickHouse/pull/101048) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix LOGICAL_ERROR exception "Column identifier is already registered" when `additional_result_filter` setting is used with UNION or EXCEPT queries. [#101051](https://github.com/ClickHouse/ClickHouse/pull/101051) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fixed server crash (Logical error: Bad cast from ColumnVector to ColumnNullable) when using `* APPLY` with aggregate functions and `group_by_use_nulls=1` with GROUPING SETS, ROLLUP, or CUBE. [#101062](https://github.com/ClickHouse/ClickHouse/pull/101062) ([Groene AI](https://github.com/groeneai)).
* Fix infinite loop when `input_format_csv_skip_first_lines` or `input_format_tsv_skip_first_lines` exceeds the number of lines in the file. [#101111](https://github.com/ClickHouse/ClickHouse/pull/101111) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix out-of-bounds access in lazy materialization optimization that could cause an exception in debug builds. [#101144](https://github.com/ClickHouse/ClickHouse/pull/101144) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix type inference in recursive CTEs: column types are now iteratively widened via `getLeastSupertype` across the non-recursive and recursive sides of the `UNION ALL` until convergence, preventing integer overflow in expressions like `x + 1`. [#101155](https://github.com/ClickHouse/ClickHouse/pull/101155) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Clamp MergeTree compress block size settings (max_compress_block_size, min_compress_block_size, marks_compress_block_size, primary_key_compress_block_size) to 256 MiB to prevent server crash when extreme values are set via CREATE TABLE SETTINGS. [#101159](https://github.com/ClickHouse/ClickHouse/pull/101159) ([Groene AI](https://github.com/groeneai)).
* Fix a LOGICAL_ERROR crash in `QueryAnalyzer::resolve()` when a ROW POLICY uses a scalar subquery in its `USING` clause (e.g. `USING (SELECT 1)`). Closes [#100695](https://github.com/ClickHouse/ClickHouse/issues/100695). [#101263](https://github.com/ClickHouse/ClickHouse/pull/101263) ([Groene AI](https://github.com/groeneai)).
* Fix undefined behavior in `MergeTreeDataPartWriterCompact::cancel` when a stream allocation fails. [#101292](https://github.com/ClickHouse/ClickHouse/pull/101292) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fixes a case where timezone was not included during the assignment in the ALTER statement. Closes [#101328](https://github.com/ClickHouse/ClickHouse/issues/101328). Related https://github.com/ClickHouse/ClickHouse/pull/100647. [#101403](https://github.com/ClickHouse/ClickHouse/pull/101403) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* Fix server crash (LOGICAL_ERROR) for INSERT SELECT queries with ORDER BY ALL when the SELECT pipeline produces multiple streams. [#101443](https://github.com/ClickHouse/ClickHouse/pull/101443) ([Groene AI](https://github.com/groeneai)).
* Fix incorrect query results caused by join reordering pushing an INNER JOIN filter (referencing only the preserved side of an outer join) into the outer join’s ON clause. [#101504](https://github.com/ClickHouse/ClickHouse/pull/101504) ([Vladimir Cherkasov](https://github.com/vdimir)).
* Skip applying lazy materialization for plans with arrayJoin, which could lead to limit not being respected. Close [#101608](https://github.com/ClickHouse/ClickHouse/issues/101608). [#101644](https://github.com/ClickHouse/ClickHouse/pull/101644) ([Vladimir Cherkasov](https://github.com/vdimir)).
* Fix incorrect JOIN query results when `mergeFilterIntoJoinCondition` optimization silently dropped a WHERE equality condition with mismatched types. [#101652](https://github.com/ClickHouse/ClickHouse/pull/101652) ([Xiaozhe Yu](https://github.com/wudidapaopao)).
* Fix the `error` test hint not working for syntax/parsing errors — previously `-- { error SYNTAX_ERROR }` on a malformed query would fail with "Expected server error" instead of matching the client-side parse error. [#101675](https://github.com/ClickHouse/ClickHouse/pull/101675) ([Groene AI](https://github.com/groeneai)).
* Fix `INTO OUTFILE ... TRUNCATE` not actually using atomic rename — the write went directly to the original file instead of a temp file, so on query failure the original content was destroyed. Now the data is written to a temp file and renamed only on success. [#101884](https://github.com/ClickHouse/ClickHouse/pull/101884) ([Pablo Marcos](https://github.com/pamarcos)).
* Fixed an exception `Unsupported DeltaLake type: varchar(n)` when reading Delta Lake tables whose schema contains varchar(n) or char(n) column types. These types are now mapped to String, consistent with how the Delta Lake protocol stores them as plain byte arrays in Parquet. [#101973](https://github.com/ClickHouse/ClickHouse/pull/101973) ([Flavio Malavazi](https://github.com/flaviomalavazi)).
* Fix silent data loss when reading tar archives from S3 with `schema_inference_mode=union` and heterogeneous Parquet schemas — the Parquet metadata cache incorrectly reused the first file's metadata for all subsequent files in the archive. [#101990](https://github.com/ClickHouse/ClickHouse/pull/101990) ([Ahaan Limaye](https://github.com/ahaanlimaye)).
* Fix server crash (LOGICAL_ERROR) when executing ALTER TABLE UPDATE/DELETE on Iceberg tables when no prior SELECT or INSERT was done on the table in the same server lifetime. [#102113](https://github.com/ClickHouse/ClickHouse/pull/102113) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix possible crash when an ALTER query executed on tables from in-memory database (e.g. temporary tables). [#102360](https://github.com/ClickHouse/ClickHouse/pull/102360) ([Den Kalantaevskii](https://github.com/Diskein)).
* Fixed `formatQuery` producing duplicate grants like `GRANT FILE ON *.*, FILE ON *.* TO x` instead of `GRANT FILE ON *.* TO x` when formatting backward-compatible READ/WRITE grants on the same source. [#102411](https://github.com/ClickHouse/ClickHouse/pull/102411) ([Groene AI](https://github.com/groeneai)).
* Fix lost parallelism for aggregation after read-in-order queries when `max_streams_to_max_threads_ratio` is greater than 1. [#102467](https://github.com/ClickHouse/ClickHouse/pull/102467) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fixed a crash (`LOGICAL_ERROR: Unknown virtual column`) when selecting subcolumns (like `.null` for Nullable, `.size0` for Array, tuple elements, or map keys/values) from a Buffer table engine. [#102470](https://github.com/ClickHouse/ClickHouse/pull/102470) ([Groene AI](https://github.com/groeneai)).
* Fix exception "Cannot fold actions for projection" in join reorder optimization when a LEFT/RIGHT JOIN with `join_use_nulls` is combined with other joins involving more than two tables. [#102516](https://github.com/ClickHouse/ClickHouse/pull/102516) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fixed silent overflow in scalar pointwise operations on numericIndexedVector (e.g. `numericIndexedVectorPointwiseAdd`) when the scalar is out of range. Such inputs now raise `INCORRECT_DATA` instead of returning corrupted values. [#102546](https://github.com/ClickHouse/ClickHouse/pull/102546) ([FriendLey](https://github.com/FriendLey)).
* Fix inconsistent AST formatting for INSERT with SAMPLE and query-level OFFSET. Closes [#102523](https://github.com/ClickHouse/ClickHouse/issues/102523). [#102547](https://github.com/ClickHouse/ClickHouse/pull/102547) ([zoomxi](https://github.com/zoomxi)).
* Fix `LOGICAL_ERROR` exception in `groupConcat` when deserializing a malformed aggregate function state. [#102558](https://github.com/ClickHouse/ClickHouse/pull/102558) ([Christoph Wurm](https://github.com/cwurm)).
* Now we do not accept garbage at the end of Time64 CSV values with `input_format_csv_use_default_on_bad_values=0`. Closes [#102490](https://github.com/ClickHouse/ClickHouse/issues/102490). [#102596](https://github.com/ClickHouse/ClickHouse/pull/102596) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* Fix UNKNOWN_ELEMENT_OF_ENUM exception when inserting default value to JSON column with Enum typed paths. Closes [#102359](https://github.com/ClickHouse/ClickHouse/issues/102359). [#102687](https://github.com/ClickHouse/ClickHouse/pull/102687) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix columns_substreams.txt corruption during column rename in some cases. Closes [#102259](https://github.com/ClickHouse/ClickHouse/issues/102259). [#102689](https://github.com/ClickHouse/ClickHouse/pull/102689) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix inserting into Time data type during JSON parsing. Closes [#102016](https://github.com/ClickHouse/ClickHouse/issues/102016). [#102690](https://github.com/ClickHouse/ClickHouse/pull/102690) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix hex encoding of content sample in cached schema filenames. Closes [#101904](https://github.com/ClickHouse/ClickHouse/issues/101904). [#102703](https://github.com/ClickHouse/ClickHouse/pull/102703) ([Pavel Kruglov](https://github.com/Avogar)).
* Fixed sort order violation (crash in debug, silent data corruption in release) during `SummingMergeTree` merge when the `ORDER BY` key is a hash expression over a `Float32` column containing signaling NaN values. [#102791](https://github.com/ClickHouse/ClickHouse/pull/102791) ([Groene AI](https://github.com/groeneai)).
* Make `DETACH DATABASE ... SYNC` and other operations that call `waitDetachedTableNotInUse` cancellable via `KILL QUERY` and responsive to server shutdown, preventing indefinite hangs when a concurrent query holds a table reference. [#102804](https://github.com/ClickHouse/ClickHouse/pull/102804) ([Antonio Andelic](https://github.com/antonio2368)).
* Fixed possible incorrect result of `ANY RIGHT JOIN`. [#102893](https://github.com/ClickHouse/ClickHouse/pull/102893) ([Nikita Taranov](https://github.com/nickitat)).
* Fix S3 requests failing with `ios_base::clear: unspecified iostream_category error` instead of being retried, caused by Poco `BufferedStreamBuf::flushBuffer` not handling short writes from the socket layer. [#102894](https://github.com/ClickHouse/ClickHouse/pull/102894) ([Sema Checherinda](https://github.com/CheSema)).
* Fix `input('auto')` table function failing via HTTP interface in INSERT SELECT queries. [#102902](https://github.com/ClickHouse/ClickHouse/pull/102902) ([Miсhael Stetsyuk](https://github.com/mstetsyuk)).
* Disable trivial LIMIT optimization with row policies/additional_table_filters (to allow parallel index analysis). [#102921](https://github.com/ClickHouse/ClickHouse/pull/102921) ([Azat Khuzhin](https://github.com/azat)).
* Hide secret key in `HMAC` SQL function. Fix [#102927](https://github.com/ClickHouse/ClickHouse/issues/102927). [#102997](https://github.com/ClickHouse/ClickHouse/pull/102997) ([Mikhail f. Shiryaev](https://github.com/Felixoid)).
* Fix `MULTIPLE_EXPRESSIONS_FOR_ALIAS` exception raised on distributed queries that reference the same `quantile` call multiple times (e.g. in `SELECT`, `HAVING`, and `ORDER BY`) with `optimize_syntax_fuse_functions` enabled. [#103014](https://github.com/ClickHouse/ClickHouse/pull/103014) ([tanner-bruce](https://github.com/tanner-bruce)).
* Fixes a case found by CI where a not-ready set was passed when the filter depends on the left-side column. Closes [#102966](https://github.com/ClickHouse/ClickHouse/issues/102966). [#103029](https://github.com/ClickHouse/ClickHouse/pull/103029) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* Fix castOrNull to JSON in some cases. Closes [#101818](https://github.com/ClickHouse/ClickHouse/issues/101818). [#103036](https://github.com/ClickHouse/ClickHouse/pull/103036) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix `SELECT DISTINCT` silently returning incomplete results when an aggregate projection matched the query and some parts of the table had no projection data (e.g. the projection was added on a table that already held data, and `MATERIALIZE PROJECTION` was not run). Closes [#102951](https://github.com/ClickHouse/ClickHouse/issues/102951). [#103052](https://github.com/ClickHouse/ClickHouse/pull/103052) ([Nihal Z. Miaji](https://github.com/nihalzp)).
* Fix `TOO_FEW_ARGUMENTS_FOR_FUNCTION` exception when a `WHERE` predicate such as `AND(OR(A, A), A)` collapses to a single top-level argument during common expression extraction in the analyzer. [#103072](https://github.com/ClickHouse/ClickHouse/pull/103072) ([Peng](https://github.com/fastio)).
* Fix a logical error `Function writeSlice expects same column types for GenericArraySlice and GenericArraySink` raised when evaluating `if`/`ifNull` over tuples, maps, or arrays containing a `QBit` element. `ColumnQBit::structureEquals` incorrectly compared the inner tuple of one `QBit` column against the outer wrapper of the other, so structurally identical `QBit` columns were reported as different. [#103084](https://github.com/ClickHouse/ClickHouse/pull/103084) ([Groene AI](https://github.com/groeneai)).
* Make `DETACH DATABASE` with `database_atomic_wait_for_drop_and_detach_synchronously` respect `KILL QUERY` instead of hanging indefinitely when a table reference is held. [#103095](https://github.com/ClickHouse/ClickHouse/pull/103095) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix segfault when deleting WASM module using non-identifier predicate (e.g. `WHERE 1=1`). [#103101](https://github.com/ClickHouse/ClickHouse/pull/103101) ([Joe Redfern](https://github.com/JosephRedfern)).
* Fix backward compatibility break where old clients fail with `UNEXPECTED_PACKET_FROM_SERVER` when inserting into a newer server via `remote()` or distributed tables, caused by unconditional `sendProgress` at the end of `processInsertQuery`. [#103148](https://github.com/ClickHouse/ClickHouse/pull/103148) ([Sema Checherinda](https://github.com/CheSema)).
* IN with non-constant tuple second argument must not CAST tuple elements down to the LHS type, this can overflow. Closes [#103055](https://github.com/ClickHouse/ClickHouse/issues/103055). [#103169](https://github.com/ClickHouse/ClickHouse/pull/103169) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* Fix use-of-uninitialized-value in protocol function. [#103187](https://github.com/ClickHouse/ClickHouse/pull/103187) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix `LOGICAL_ERROR` (`Bad cast … to ColumnLowCardinality`) during MergeTree index analysis when a `WHERE` clause compares a `LowCardinality` key column with a constant cast to a type that contains nested `LowCardinality` (for example `Variant(LowCardinality(Date), String)`). [#103211](https://github.com/ClickHouse/ClickHouse/pull/103211) ([Groene AI](https://github.com/groeneai)).
* Fix `Logical error: 'index < bucket_count'` in the `timeSeries*ToGrid` aggregate function family (e.g. `timeSeriesResampleToGridWithStaleness`, `timeSeriesChangesToGrid`, `timeSeriesResetsToGrid`, `timeSeriesRateToGrid`) when called with extreme timestamp parameters that would overflow signed 64-bit arithmetic in the bucket count computation. Also cap the total number of grid buckets at 16 million to prevent accidental large-memory allocation from adversarial inputs. [#103223](https://github.com/ClickHouse/ClickHouse/pull/103223) ([Groene AI](https://github.com/groeneai)).
* Fix `Logical error: 'Port is already connected'` exception during pipeline expansion in the lazy `FINAL` path for `ReplacingMergeTree`. The bug affected queries with `query_plan_optimize_lazy_final = 1` when `ReadFromMergeTree::initializePipeline` inserted internal transforms (e.g. a `Resize`) that wired the sub-pipeline's processors together, causing `LazyUnorderedReadFromMergeTreeSource::expandPipeline` to try to connect output ports that were already connected. [#103230](https://github.com/ClickHouse/ClickHouse/pull/103230) ([Groene AI](https://github.com/groeneai)).
* Fix wrong results from `LIMIT BY` and `DISTINCT` when the input is a `UNION ALL` of sorted subqueries. The query plan optimizer incorrectly treated such a union as globally sorted, causing extra rows to be returned. [#103231](https://github.com/ClickHouse/ClickHouse/pull/103231) ([Nihal Z. Miaji](https://github.com/nihalzp)).
* Fix possible crash during statistics calculation in Map type with lazy replication. Closes [#102390](https://github.com/ClickHouse/ClickHouse/issues/102390). [#103273](https://github.com/ClickHouse/ClickHouse/pull/103273) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix a data race for ClickHouse, MySQL, PostgreSQL and XDBC dictionary sources where `clone() const` reads from and `isModified() const` writes to the same `invalidate_query_response` string. [#103277](https://github.com/ClickHouse/ClickHouse/pull/103277) ([Miсhael Stetsyuk](https://github.com/mstetsyuk)).
* Fix incorrect monotonicity detection for `Date32`. Closes [#101265](https://github.com/ClickHouse/ClickHouse/issues/101265). [#103283](https://github.com/ClickHouse/ClickHouse/pull/103283) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* Cap pre-auth TCP Hello packet strings to 64 KB and add `handshake_timeout_milliseconds` server setting to limit total handshake time, preventing unauthenticated clients from consuming excessive memory or holding threads indefinitely. [#103284](https://github.com/ClickHouse/ClickHouse/pull/103284) ([Sema Checherinda](https://github.com/CheSema)).
* Fix Parquet ColumnIndex stats min_value > max_value for String columns. [#103334](https://github.com/ClickHouse/ClickHouse/pull/103334) ([Saurabh Kumar Ojha](https://github.com/saurabhojha)).
* Fix incorrect handling of NULL rows for `Nullable(Tuple(...))` inputs in `flattenTuple` and `tupleToNameValuePairs`. `flattenTuple` now preserves the outer null map so NULL rows stay NULL. `tupleToNameValuePairs` now changes the result's value type to `Nullable(T)` when possible when the input is `Nullable(Tuple(...))`, so NULL rows produce `[('a', NULL), ('b', NULL)]` instead of `[('a', 0), ('b', 0)]`. When the element type cannot be wrapped in `Nullable` (e.g. `Array`), default values are used instead of NULL. Closes [#103312](https://github.com/ClickHouse/ClickHouse/issues/103312). [#103383](https://github.com/ClickHouse/ClickHouse/pull/103383) ([Nihal Z. Miaji](https://github.com/nihalzp)).
* Check for malformed flattened Dynamic data in Native format. [#103392](https://github.com/ClickHouse/ClickHouse/pull/103392) ([Pavel Kruglov](https://github.com/Avogar)).
* Fix stale RPC causing replication stall after snapshot sync. [#103406](https://github.com/ClickHouse/ClickHouse/pull/103406) ([Seva Potapov](https://github.com/seva-potapov)).
* Fix a `LOGICAL_ERROR` "Cannot pop N rows from X" that aborted the server (in debug / sanitizer builds) when reading a malformed BSON document containing a value whose BSON type is incompatible with the target column type inside a `Nullable(T)` or `Array(Nullable(T))` column. The malformed row now produces a clean `ILLEGAL_COLUMN` exception as intended. [#103418](https://github.com/ClickHouse/ClickHouse/pull/103418) ([Groene AI](https://github.com/groeneai)).
* Fix a server abort in `arrayFill` and `arrayReverseFill` when applied to an `Array(String)` column whose first row is empty together with a constant-false lambda. The aggregate / sub-array loop underflowed a `size_t` index to `SIZE_MAX`, which then caused an out-of-bounds read inside `ColumnString::doInsertManyFrom`. Same bug family as [#12263](https://github.com/ClickHouse/ClickHouse/issues/12263). [#103424](https://github.com/ClickHouse/ClickHouse/pull/103424) ([Groene AI](https://github.com/groeneai)).
* Fixes ACCESS_DENIED / UNKNOWN_TABLE in downstream APPEND RMVs with SQL SECURITY DEFINER when an upstream REPLACE RMV's EXCHANGE flips the target storage identity mid-resolution. [#103427](https://github.com/ClickHouse/ClickHouse/pull/103427) ([Alexander Gololobov](https://github.com/davenger)).
* Populate `_time` column from `url` table function. [#103437](https://github.com/ClickHouse/ClickHouse/pull/103437) ([Nikita Taranov](https://github.com/nickitat)).
* Fix potential out-of-bounds read in the `ALP` codec decompression path when processing malformed input with an invalid bit-width. [#103457](https://github.com/ClickHouse/ClickHouse/pull/103457) ([Raufs Dunamalijevs](https://github.com/rienath)).
* Fix a bug where `SYSTEM SYNC FILESYSTEM CACHE '<name>' ON CLUSTER ...` could lose the cache name while formatting the query, causing remote nodes to sync all filesystem caches instead of only the requested cache. [#103469](https://github.com/ClickHouse/ClickHouse/pull/103469) ([Asish Kumar](https://github.com/officialasishkumar)).
* Fix processing of URL-encoded path in `deltaLakeAzure`. Closes [#103509](https://github.com/ClickHouse/ClickHouse/issues/103509). [#103525](https://github.com/ClickHouse/ClickHouse/pull/103525) ([Smita Kulkarni](https://github.com/SmitaRKulkarni)).
* Fix heap-use-after-free in multiplying an `AggregateFunction` state by an integer (e.g. `quantilesExactState(...) * N`). The exponentiation-by-squaring loop merged the state with itself, which is undefined when the aggregate function's `merge` reallocates its internal storage. Closes STID 0988-40af. [#103536](https://github.com/ClickHouse/ClickHouse/pull/103536) ([Groene AI](https://github.com/groeneai)).
* Fixed a rare `LOGICAL_ERROR` "Part X intersects previous part Y" raised during `ReplicatedMergeTree` table startup when two empty unexpected parts on disk had overlapping but non-containing block ranges. The exception aborted the table-attach thread and prevented the table from coming up. [#103537](https://github.com/ClickHouse/ClickHouse/pull/103537) ([Groene AI](https://github.com/groeneai)).
* Fix `Logical error: Incorrect mark rows for part ...` (debug-only assertion) that was triggered by mutations on `MergeTree` tables with non-adaptive index granularity (`index_granularity_bytes = 0`) whose last data mark was incomplete (most reliably reproduced via `DETACH`/`ATTACH` followed by a lightweight `DELETE`). [#103538](https://github.com/ClickHouse/ClickHouse/pull/103538) ([Groene AI](https://github.com/groeneai)).
* Fix `clickhouse-local` returning 0 rows silently when reading from `/proc` and `/sys` pseudo-files via the `file()` table function (e.g. `SELECT * FROM file('/proc/cpuinfo', 'RawBLOB')`). [#103548](https://github.com/ClickHouse/ClickHouse/pull/103548) ([Ashrith Bandla](https://github.com/ashrithb)).
* Fixed handling of the `max_string_length` argument for the `GenerateRandom` table engine. [#103550](https://github.com/ClickHouse/ClickHouse/pull/103550) ([Alex Kuleshov](https://github.com/0xAX)).
* Fix masking nested credentials in logs. [#103552](https://github.com/ClickHouse/ClickHouse/pull/103552) ([Vitaly Baranov](https://github.com/vitlibar)).
* Fix SVE detection using SVE instructions when unavailable. [#103568](https://github.com/ClickHouse/ClickHouse/pull/103568) ([Raúl Marín](https://github.com/Algunenano)).
* Fix `GenerateRandom` storage args parsing. [#103574](https://github.com/ClickHouse/ClickHouse/pull/103574) ([Konstantin Bogdanov](https://github.com/thevar1able)).
* Fix infinite loop on `WITH FILL` for data starting with ±inf. [#103580](https://github.com/ClickHouse/ClickHouse/pull/103580) ([Konstantin Bogdanov](https://github.com/thevar1able)).
* Fix `JSONExtract` into a `Variant` type silently truncating fractional JSON numbers. Previously, `JSONExtract('{"x": 3.14}', 'x', 'Variant(Int64, Float64)')` returned `Int64=3` and `JSONExtract('{"x": 3.14}', 'x', 'Variant(String, Int64)')` returned `Int64=3`, dropping the fractional part. The fractional value is now preserved losslessly: a `Float64`/`Decimal` member claims it when present, otherwise a `String` member captures the original JSON. `Variant` types containing only integer members (e.g. `Variant(Int64, Int32)`) and direct integer extraction (`JSONExtract(json, 'Int64')`, `JSONExtractInt`, etc.) are unchanged. [#103620](https://github.com/ClickHouse/ClickHouse/pull/103620) ([Groene AI](https://github.com/groeneai)).
* Fix `SYSTEM INSTRUMENT REMOVE` without arguments producing `std::bad_optional_access` (error code 1001) instead of `SYNTAX_ERROR` (error code 62). [#103622](https://github.com/ClickHouse/ClickHouse/pull/103622) ([Pablo Marcos](https://github.com/pamarcos)).
* Fix logical error / undefined behavior in `windowID` and `tumble` window view when called with a timezone string as the 3rd argument. [#103641](https://github.com/ClickHouse/ClickHouse/pull/103641) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* S3 client logging now treats HTTP 400 responses that include a non-empty x-amz-bucket-region header (wrong SigV4 signing region) as an informational wrong-region case with a clearer log line instead of the generic error-style path. The STS web identity credentials provider is added to the S3 credentials chain only when web identity is configured, which reduces spurious warnings for deployments that do not use it. Closes [#99140](https://github.com/ClickHouse/ClickHouse/issues/99140). [#103673](https://github.com/ClickHouse/ClickHouse/pull/103673) ([MeltonSmith](https://github.com/MeltonSmith)).
* Fix `SYSTEM SYNC REPLICA <db>.<tbl> IF EXISTS` to silently succeed when the database does not exist, matching the existing behaviour for a missing table and the precedent set by `DROP TABLE IF EXISTS`. Previously the query threw `UNKNOWN_DATABASE` despite `IF EXISTS`. Closes [#103629](https://github.com/ClickHouse/ClickHouse/issues/103629). [#103689](https://github.com/ClickHouse/ClickHouse/pull/103689) ([Groene AI](https://github.com/groeneai)).
* Fix logical error `Arguments of 'plus' have incorrect data types` thrown by `FunctionBinaryArithmetic::executeImpl2` when a `MergeTree` table had `Array(LowCardinality(...))` in its sort key and a `WHERE` clause used `plus` / `minus` between that column and an `Array` constant of a different element type. `KeyCondition::getMonotonicityForRange` now strips `LowCardinality` recursively before invoking the inner numeric dispatch. [#103701](https://github.com/ClickHouse/ClickHouse/pull/103701) ([Groene AI](https://github.com/groeneai)).
* Fix dynamic cache resize race in 26.1+. [#103702](https://github.com/ClickHouse/ClickHouse/pull/103702) ([Kseniia Sumarokova](https://github.com/kssenii)).
* Fixed an issue where text and bloom_filter skip indices on `ALIAS` columns whose expression contained a lambda with captured constants (e.g. `arrayMap((k, v) -> concat(k, '=', v), mapKeys(m), mapValues(m)))` were silently ignored. [#103708](https://github.com/ClickHouse/ClickHouse/pull/103708) ([Anton Popov](https://github.com/CurtizJ)).
* Fix `position` and `positionCaseInsensitive` with a `start_pos` close to `UINT64_MAX` getting stuck or causing a segmentation fault due to overflowing pointer arithmetic. [#103766](https://github.com/ClickHouse/ClickHouse/pull/103766) ([Raúl Marín](https://github.com/Algunenano)).
* Fixes undefined behavior while parsing dateTime with a double fractional part. [#103773](https://github.com/ClickHouse/ClickHouse/pull/103773) ([Yarik Briukhovetskyi](https://github.com/yariks5s)).
* Fixed a data-correctness regression in 26.x where JIT-compiled `if` and `multiIf` with a `Decimal` result type and a non-`Decimal` (integer or float) literal in one branch silently returned a value `10^scale` too small. The slow (non-JIT) path was unaffected. Workaround on affected versions: `SET compile_expressions = 0`. [#103809](https://github.com/ClickHouse/ClickHouse/pull/103809) ([Groene AI](https://github.com/groeneai)).
* Fixes forwarding the tokenizer from the text index to supported functions. [#103826](https://github.com/ClickHouse/ClickHouse/pull/103826) ([Elmi Ahmadov](https://github.com/ahmadov)).
* Fix wrong results from `numbers`, `generate_series`, and similar range-honoring sources when the `WHERE` clause uses `IN` or `NOT IN` over a tuple whose elements deduplicate to a single key column (for example, `WHERE tuple(number, number) NOT IN (tuple(1, 2))`). Closes [#103660](https://github.com/ClickHouse/ClickHouse/issues/103660). [#103835](https://github.com/ClickHouse/ClickHouse/pull/103835) ([Groene AI](https://github.com/groeneai)).
* Keep the auto-spilling hash join's actual memory peak under `max_bytes_before_external_join`. Previously, statistics-driven preallocation, in-place hash table doubling, and unbounded `GraceHashJoin` in-memory buckets could each push the query past the configured cap and trip `MEMORY_LIMIT_EXCEEDED`. [#103838](https://github.com/ClickHouse/ClickHouse/pull/103838) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix a hang in `clickhouse-local` shutdown when system logs (such as `text_log` or `filesystem_cache_log`) are configured. `SystemLogs::flushImpl` was calling `BaseDaemon::instance().flushTextLogs()`, which throws `std::bad_cast` outside `clickhouse-server` and left the saving threads running until `pthread_cond_destroy` blocked the destruction of the system log queues. [#103874](https://github.com/ClickHouse/ClickHouse/pull/103874) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Reject `MATERIALIZED` CTE queries whose body resolves to different inferred column types in different references with a clear `TYPE_MISMATCH` error instead of crashing the server with a `Bad cast` `LOGICAL_ERROR`. This previously happened when the CTE body referenced identifiers from outer scope (for example an alias from the calling subquery's projection) that were inlined as different constants per reference. [#103879](https://github.com/ClickHouse/ClickHouse/pull/103879) ([Groene AI](https://github.com/groeneai)).
* Fix a use-of-uninitialized-value in the JOIN-conversion query plan optimizers (`tryConvertAnyOuterJoinToInnerJoin`, `tryConvertAnyJoinToSemiOrAntiJoin`) when the filter on top of an `ANY` `OUTER` `JOIN` contains a non-deterministic function such as `rand`, `now`, or `rowNumberInAllBlocks`. The optimizer no longer attempts to constant-fold such filters and leaves the JOIN unchanged, which also prevents incorrect conversions to `INNER`/`SEMI`/`ANTI JOIN` that could silently drop rows. [#103880](https://github.com/ClickHouse/ClickHouse/pull/103880) ([Groene AI](https://github.com/groeneai)).
* Fix a use-after-free in `StorageKafka2` that could crash the server when a Keeper session is replaced while the consumer is holding ephemeral topic-partition locks. [#103890](https://github.com/ClickHouse/ClickHouse/pull/103890) ([Groene AI](https://github.com/groeneai)).
* Fixed a `LOGICAL_ERROR` "Primary key type mismatch" thrown when joining an `EmbeddedRocksDB` table via `JOIN ... USING (key)` against a subquery whose key column has a different type (e.g. `Nullable(UInt64)`, `Int64`, `Decimal`) than the storage's primary key. The planner now declines `DirectKeyValueJoin` on type mismatch and falls back to `HashJoin`, which handles the type conversion. [#103928](https://github.com/ClickHouse/ClickHouse/pull/103928) ([Groene AI](https://github.com/groeneai)).
* `SET max_threads = DEFAULT` (and the same for `max_final_threads` and `max_parsing_threads`) no longer loses the auto state. Previously, after resetting one of these settings, `system.settings` would report the resolved core count (e.g. `32`) instead of `'auto(32)'`, and the server would behave as if the value had been explicitly pinned. [#103991](https://github.com/ClickHouse/ClickHouse/pull/103991) ([Groene AI](https://github.com/groeneai)).
* Fix `SIZES_OF_ARRAYS_DONT_MATCH` when reading `AggregateFunction(topK(N), String)` columns whose persisted `alpha_size` was grown by a pre-25.12 deserialize+serialize cycle. [#104002](https://github.com/ClickHouse/ClickHouse/pull/104002) ([Raúl Marín](https://github.com/Algunenano)).
* Fixed SQL injection vulnerability in PostgreSQL, Cassandra and XDBC dictionary sources: string keys containing single quotes were escaped with `\'` (backslash), which these backends treat as a literal backslash rather than an escape sequence, allowing arbitrary SQL to be injected into dictionary lookup queries. `ExternalQueryBuilder` now emits SQL-standard `''` escaping for those backends; ClickHouse and MySQL dictionary sources continue to use backslash escaping. [#104009](https://github.com/ClickHouse/ClickHouse/pull/104009) ([Shaohua Wang](https://github.com/tiandiwonder)).
* Fixed possible type mismatch in aggregation when a column type was altered to/from LowCardinality, and min-max projection wasn't rebuilt. [#104013](https://github.com/ClickHouse/ClickHouse/pull/104013) ([Nikita Taranov](https://github.com/nickitat)).
* Fix infinite loop of query optimizations caused by not propagating prevention of unused column removal when merging expressions. [#104083](https://github.com/ClickHouse/ClickHouse/pull/104083) ([János Benjamin Antal](https://github.com/antaljanosbenjamin)).
* Fix `LOGICAL_ERROR` in `StreamingStorageRegistry::renameTable` when batch-renaming streaming tables (S3Queue, Kafka, RabbitMQ) by using UUID-based identity tracking instead of name-based. [#104101](https://github.com/ClickHouse/ClickHouse/pull/104101) ([Nikita Taranov](https://github.com/nickitat)).
* Fixed wrong results when a CTE constructed with `UNION ALL` contained a `SELECT DISTINCT` branch and the outer query projected only a subset of the CTE's columns. The new analyzer's `RemoveUnusedProjectionColumnsPass` was incorrectly removing the un-referenced column from the inner `DISTINCT` projection, causing rows that should have remained distinct (same value in the projected column but different value in the dropped column) to collapse into one. [#104114](https://github.com/ClickHouse/ClickHouse/pull/104114) ([Groene AI](https://github.com/groeneai)).
* Fix several edge case correctness issues in setting `optimize_inverse_dictionary_lookup` where the optimization could silently drop rows or suppress exceptions. Closes [#103270](https://github.com/ClickHouse/ClickHouse/issues/103270). Close [#103085](https://github.com/ClickHouse/ClickHouse/issues/103085). [#104133](https://github.com/ClickHouse/ClickHouse/pull/104133) ([Nihal Z. Miaji](https://github.com/nihalzp)).
* Fix write out of bounds while deserializing `quantileTiming` state. [#104141](https://github.com/ClickHouse/ClickHouse/pull/104141) ([Alexey Milovidov](https://github.com/alexey-milovidov)).
* Fix undefined behavior when an out-of-range `Float64` value is converted to a wide integer type (`UInt64`, `Int64`, `Int128`, `UInt128`, `Int256`, `UInt256`). Previously, values equal to `Float64(numeric_limits<T>::max())` (which rounds up to a value above the actual maximum) bypassed the bounds check and produced UB in the subsequent cast. This affected aggregate-function parameter parsing (`topK`, `histogram`, `uniqUpTo`, `groupArrayInsertAt`, etc.) and integer-typed settings via `SET <setting> = <Float64>`. Closes [#103817](https://github.com/ClickHouse/ClickHouse/issues/103817). [#104154](https://github.com/ClickHouse/ClickHouse/pull/104154) ([Groene AI](https://github.com/groeneai)).
* Fix `LOGICAL_ERROR` exception "Unexpected return type from comparison. Expected `UInt8`. Got `Const(Nullable(UInt8))`" when comparing a nested `Tuple(Tuple(Nullable(...)))` (or deeper nesting) with a `String` literal. The comparison's return type is now correctly inferred as `Nullable(UInt8)`, matching the runtime behaviour. [#104171](https://github.com/ClickHouse/ClickHouse/pull/104171) ([Groene AI](https://github.com/groeneai)).
